#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> config_table.tcl : This procedure loads and displays    <--#
#-->                    the configuration table that maps    <--#
#-->                    group no + id to specific data       <--#
#-->                    wrds.                                <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc config_table {} {
    global configtable
    global debuglevel 
    global cfglist
    global cfgstart
    global mydebug
    global cft_name cft_grp cft_item cft_label cft_enable cft_bits

    read_config_table

    :frame FCTAB :label "MIDASsort: Configuration File Viewer" \
	:resize F :transient T
     :panel PCT1 :layout V :padx 5 :pady 5
      :layout H
      :message MCFT :label "Use this frame to view the configuration file"
      :next-row T
      :next-row T
      :list CFGLIST :cols 80 :rows 20 :exclusive T :see 0 \
	               :scroll V :strings $cfglist
      :next-row T
#      :text TCFGTAB1         :label "Name"       :w 16  :value $cft_name
#      :hskip 5
#      :text TCFGTAB2         :label "Group"      :w  4  :value $cft_grp
#      :hskip 5
#      :text TCFGTAB3         :label "Item"       :w  3  :value $cft_item
#      :hskip 5
#      :text TCFGTAB4         :label "Label"      :w  6  :value $cft_label
#      :hskip 5
#      :checkbox CBCFGTAB     :label "Enable"     :value $cft_enable
#      :hskip 5
#      :text TCFGTAB5         :label "Databits"   :w  3  :value $cft_bits

    :show T

}

proc read_config_table {} {
    global configtable
    global debuglevel 
    global cfglist
    global cfgstart
    global mydebug

    set line ""
    set cfglist ""
    set myline ""

    set z [ catch { open $configtable r } f ]
    if { $z != 0 } then {
	midas-warning "Unable to open file $configtable\n$f"
	return
    } else {
	set t 1
	while { [ gets $f line ] >= 0 } {
	    if { $mydebug == 1 } then {
		puts $line
	    }
	    if { $t == 1 } then {
		set cfglist [ list $line ]
		set t 0
	    } else {
		lappend cfglist $line 
	    }

	}
	close $f
    }
    
}

proc paint-cgf {} {
    global configtable
    global debuglevel 
    global cfglist
    global cfgstart

    :modify CFGLIST :empty T :strings $cfglist

}