#--> ======================================================= <--#
#--> developer.tcl this file will generate a GUI that will   <--#
#-->               allow the enviroment variables to be set  <--#
#-->               so that a developer can test the software <--#
#-->               prior to releasing the code to the world  <--#
#--> ======================================================= <--#

proc developer {} {
    global mydebug
    global env
    global csdev0value
    global shmstrings shmvalue shmconstant

    :frame FDEVELOPER :label "MIDASsort - Development enviroment" \
	    :resize F :transient T
     :panel PDEV0 :layout V :padx 5 :pady 5
      :layout H
      :message MDEV0 :label  "MIDASsort - Development enviroment"
      :next-row T
      :next-row T
      :message MDEV1 :label "Enable MIDASsort tcl debugging" \
	      :x 10
      :checkbox CBDEV0 :label "" \
	      :value $mydebug \
	      :x 200
      :next-row T
      :message MDEV2 :label "Shared Memory Control " :x 10
      :hskip 25
      :choice-stack CSDEV0 :label " " \
	      :x 200 \
	      :strings "Read Write" \
	      :value   $csdev0value
      :choice-stack CSDEV1 :label "Variable" \
	      :strings $shmstrings \
	      :value $shmvalue \
	      :x 300
      :number NDEV0 :label "Value" \
	      :value $shmconstant \
	      :valuex 5 \
	      :x 500
      :button BDEV0 :label "Execute" :valuex 12 :x 600

    :show T
}

proc run_shmctrl { read var val } {
    global mydebug
    
    

    if { $mydebug == 1 } then { puts "run_shmctrl: Entered with arguments $read $var $val\n" }

    if { $read == 0 } then {
	set arg1 "r"
    } else {
	set arg1 "w"
    }
    if { $mydebug == 1 } then { puts "run_shmctrl: arg1 set to $arg1\n" }

    if { $var == 0 } then {
	if { $mydebug == 1 } then { puts "run_shmctrl: arg1 set to $arg1 as not a valid segment value (<=0)\n" }
	set arg1 "r"
    }

    set rc [ catch { exec "midasSortshm" $arg1 $var $val } m ]
    if { $rc == 0 } then {
	if { $arg1 == "r" } then {
	    midas-report $m
	}
    }

    if { $mydebug == 1 } then { puts "run_shmctrl: Leaving\n" }

}