#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> device_ctrl.tcl                                         <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc input_media args {
 global input_type idf imedia
    
    set input_type $args

    :modify TDEVICE :inactive F
    :modify BBROWSEDEV :inactive F

    if { $input_type == 0 } then {
	:modify TDEVICE :label "Drive"
	:modify TDEVICE :value ""
	:modify BIMEDIADATA :label "Tape Info"
	:modify BIMEDIADATA :inactive F
	:modify STATED :label "Not Selected"
	set imedia 0
    } elseif { $input_type == 1 } then {
	:modify TDEVICE :label "Disk File"
	:modify TDEVICE :value ""
	:modify TDEVICE :inactive T
	:modify BIMEDIADATA :label "Disk Info"
	:modify BIMEDIADATA :inactive F
	:modify BBROWSEDEV :inactive T
	:modify STATED :label "Not Selected"
	set imedia 1
    } elseif { $input_type == 2 } then {
	:modify TDEVICE :value ""
	:modify TDEVICE :label ""
	:modify TDEVICE :inactive T
	:modify BBROWSEDEV :inactive T
	:modify BIMEDIADATA :inactive T
	set imedia 2
##--> We should check to see that the Tape server is actually running ...
	set rc [catch { exec ts_status_midas_sort } m]
	:modify STATED :label $m
    }

}

#--> Let us browse for a suitable device
proc input_browse_device args {
 global input_type idf dclist directory
    set dclist ""

    if { $input_type == 0 } then {
	set frame          bbrowse
	set frametitle     "Input File Browser"
	set ext            "n"
	for {set d 0} {$d < 4} {incr d} {lappend dclist /dev/rmt/$d$ext}

	:frame dcbrowse :label $frametitle :show-footer T \
         :resize F
	:panel DCP1 :layout V :padx 5 :pady 5
	 :layout H; :row-gap 10; :col-gap 5
	 :message DCTitle :label "Input Device Browser" :bold T
	 :next-row T
	 :list DCLIST :strings $dclist :w 300 :rows 10 :exclusive T
	 :next-row T
	:show T
    } elseif { $input_type == 1 } then {
	option add *Canvas.background  #c0c020
	set types {
	    {{All Files}  *}
	}
	set file [tk_getOpenFile -parent [self frame-name] \
		-title "Input SortFile Selection"  \
		-initialdir $directory -filetypes $types]
	if {$file == ""} then {return}

	set idf $file
	:modify TDEVICE :value $idf
    }


}
#--> What hapens when we have chosen our device
proc in_list args {
  global input_type idf dclist

  set idf $args
  :modify TDEVICE :value $idf

#--> What is the status of this drive ....?                <--#
    set rc [catch { exec tapestatus_midas_sort $idf } m]
    :modify STATED :label $m


}