#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> get_after_status.tcl                                    <--#
#-->                                                         <--#
#--> This routine checks the status of the sort and updates  <--#
#--> the GUI as required ......                              <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc get_after_status args {
    global running
    global paused
    global started
    global mydebug
    global update_time

#--> First set the busy flag on the main gui ...
    :modify MIDASsort :busy T
#--> now set the footer
    set-footer MIDASsort "Updating display ..."

#--> If mydebug is set then we will just print out the current status
    if { $mydebug == 1 } then {
	puts "#-->  running = $running"
	puts "#-->  paused  = $paused"
	puts "#-->  started = $started"
    }

#--> Ok, so we shall now read the data from the status file ....
    set z [ catch { open "sort.status" r } f ]
    if { $z != 0 } then { 
#--> As we can not read the file, the sort can not be running
	set running 0
    } else {
#--> but we can .... so it is
	gets $f running
	close $f
    }
#--> So what do we need to do ....?
    if { $running == 1 } then {
	if { $paused == 0 } then {
#--> System is running happily ...
	    :modify MSRSTATE :label "Running"
	} else {
#--> Sort is running, but the user has paused things at the moment
	    :modify MSRSTATE :label "Paused"
	}
    } else {
#--> We are not going .....
	:modify MSRSTATE :label "Stopped"
	:modify BSTART   :label "Start" :inactive F
	:modify BSTOP    :label "Stop"  :inactive T
	inable 1
	set paused 0
    }
#--> Next question .... do we want to check again in a bit ..
#--> only if the sort is actually running
    if { $running == 1 } then {
	after $update_time get_after_status
    }
#--> now unset the busy flag on the main gui ...
    :modify MIDASsort :busy F
#--> now reset the footer
    set-footer MIDASsort "Display updated at : [clock format [clock seconds]  -format %m.%d.%y\ %H:%M:%S ] "
    update idletasks
#--> Thats all folks!



}