#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Settings  frame                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 06/30/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc get_settings {} {
    global midasbase
    global mydebug
    global directory
    global gaindirectory
    global gatedirectory
    global env
    global makefilepath
    global configtable
    global usegcc
    global sortdatadir
    global usesssnc
    global kmemsas

    set dummy ""

    if { $mydebug == 1 } then {
	puts "In \"get_settings\" ...."
	puts "About to set midasbase"
	puts "midasbase is currently set to : $midasbase (before catch ...)"
    }
    
    set z [ catch { set midasbase $env(MIDASBASE) } f ]
    if { $mydebug == 1 } then {
	puts "midasbase is currently set to : $midasbase (after catch ...)"
    }
    if { $z != 0 } then {
	if { $mydebug == 1 } then {
	    puts "MIDASBASE is not set ...."
	}
    }

    :frame FSET :label "MIDASsort: Settings" \
	:icon-name "MIDASsort: Settings" :resize F \
	:transient T
      :panel PSET1 :layout V :padx 5 :pady 5
       :layout H
       :message MSET :label "MIDASsort: Settings control frame" :bold T
       :next-row T
       :next-row T
       :text TSETMBDIR :label "MIDASBASE" :value $midasbase \
	:valuex 20c :w 55
       :next-row T
       :text TSETDIR :label "Sort directory" :value $directory \
	:valuex 20c :w 55
       :next-row T
       :text TSETDATADIR :label "Sort Data directory" :value $sortdatadir \
	:valuex 20c :w 55
       :next-row T
       :text TSETGAINDIR :label "Gainfile directory" :value $gaindirectory \
	:valuex 20c :w 55
       :next-row T
       :text TSETGATEDIR :label "Gatefile directory" :value $gatedirectory \
	:valuex 20c :w 55
       :next-row T
       :text TSETUM :label "Users Makefile" :value $makefilepath \
	:valuex 20c :w 55
       :next-row T
       :text TSETTAB :label "Config Table" :value $configtable \
	:valuex 20c :w 55
       :next-row T
       :checkbox CBUSEGCC :label "Use GNU compilers ?" :value $usegcc \
	:valuex 30c
       :hskip 50
       :checkbox CBSSSNC :label "Sunsort spectrum name convention ?" \
	       :value $usesssnc :valuex 30c
       :next-row T
       :checkbox CBKMSAS :label "Kill memsas server on Exit ?" :value $kmemsas \
	       :valuex 30c
       :hskip 50
       :button BMEMSASCTRL :label "Memsas Ctrl"
       :next-row T
       :next-row T
       :button BSETREDISPLAY :label "Redisplay"
    
    :show T

}

proc gs-redisplay {} {
    global midasbase
    global mydebug
    global directory
    global gaindirectory
    global gatedirectory
    global env
    global makefilepath
    global usegcc
    global sortdatadir
    global usesssnc
    global configtable
    global kmemsas
    
    :modify TSETMBDIR     :value $midasbase
    :modify TSETDIR       :value $directory
    :modify TSETDATADIR   :value $sortdatadir
    :modify TSETGAINDIR   :value $gaindirectory
    :modify TSETGATEDIR   :value $gatedirectory
    :modify TSETUM        :value $makefilepath
    :modify TSETTAB       :value $configtable
    :modify CBUSEGCC      :value $usegcc
    :modify CBSSSNC       :value $usesssnc
    :modify CBKMSAS       :value $kmemsas

    update idletasks
}
