#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> lets_go.tcl                                             <--#
#-->                                                         <--#
#--> This routine sets the sort going - go team !            <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc lets_go args {
    global sigforce
    global execfilename
    global running
    global paused
    global input_type idf file_list
    global data_type
    global mydebug
    global overwritespec
    global debugsort
    global started
    global configtable
    global debuglevel
    
    set so3 ""
    set so4 ""
    set so5 ""


#--> The status of the sort program can be obtained from the
#--> file sort.status in the tmp dir in which we are running.
    set z [ catch { open "sort.status" r } f ]
    if { $z != 0 } then {
	#--> As we can not read the file, the sort can not be running
	set running 0
    } else {
	gets $f "$running"
	close $f
    }
    if { $mydebug == 1 } then {
	puts "running       = $running"
	puts "paused        = $paused"
	puts "input_type    = $input_type"
	puts "data_type     = $data_type"
	puts "overwritespec = $overwritespec"
	puts "configtable   = $configtable"
    }

    if { $running == 0 } then {
#--> ok we know need to set up our command line arguments
#--> First, where are we reading from .... data that is ...
	set so3 "/dev/null"
	if { $input_type == 0 } then {
	    set so1 "tape"
	    set so3 $idf
	} elseif { $input_type == 1 } then {
	    set so1 "disc"
	} elseif { $input_type == 2 } then {
	    set so1 "midasTS"
	}
#--> Now what is the format of the data we are reading ..?
	if { $data_type == 0 } then {
	    set so2 "eurogam_fmt"
	} elseif { $data_type == 1 } then {
	    set so2 "grain"
	} elseif { $data_type == 2 } then {
	    set so2 "exogam_fmt"
	} elseif { $data_type == 3 } then {
	    set so2 "great_fmt"
	} else {
	    set so2 "null"
	}

#--> Do we want to overwrite any existing spectra ?
	if { $overwritespec == 0 } then {
	    set so4 "-addspec"
	} else {
	    set so4 "-newspec"
	}

#--> Do we want to start off with debugging enabled ?
	if { $debugsort == 1 } then {
	    set so5 "1"
	} else {
	    set so5 "0"
	}
#--> Are we to use traceback ?
#	if { $debuglevel(tback) == 1 } then {
#	    [ catch { exec "setenv LD_PRELOAD $env(MIDASBASE)/MIDASSort/Lib/traceback.so" } m ]
#	}
#--> Make sure we have some DEBUG info saved ...
	save_debug_levels

	if { $mydebug == 1 } then {
	    puts "execfilename  = $execfilename"
	    puts "                 -debug $so5"
	    puts "                 -idev $so1"
	    puts "                 -ifmt $so2"
	    puts "                 $so4"
	    puts "                 -cft $configtable"
	    puts "                 -tdev $so3"
	}

	if [catch { exec $execfilename "-debug" $so5 "-idev" $so1 "-ifmt" $so2 $so4 "-cft" $configtable "-tdev" $so3 & } m] {
	    :modify MSRSTATE :label "Start Error run"
	} else {
	    :modify MSRSTATE :label "Started"
	    :modify BSTOP    :label "Pause"
	    :modify BSTART   :inactive T
	    set running 1
	    update idletasks
	    inable 0
#--> Start the refresh deamon ....
	    after 2000 get_after_status 1
	}
    } else  {
	if { $paused == 1 } then {
	    :modify MSRSTATE :label "Running"
	    :modify BSTART   :label "Continue"
	    :modify BSTART   :inactive T
	    :modify BSTOP    :label "Pause"
	    
	    update idletasks
	    if { $sigforce == 1 } then {
		set rc [catch { exec smf-sigsend 0 } m]
	    } else {
#		set rc [catch { exec shmctrl 2 w 0 } m]
		set rc [catch { exec midasSortshm w 1 0 } m]
	    }
	    set paused 0
	}

    }
}
