#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> lets_not_go.tcl                                         <--#
#-->                                                         <--#
#--> This routine either pauses the sort or kills it         <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc lets_not_go args {
    global sigforce
    global execfilename
    global running
    global paused
    global started
    global mydebug

#--> The status of the sort program can be obtained from the
#--> file sort.status in the tmp dir in which we are running.
    set z [ catch { open "sort.status" r } f ]
    if { $z != 0 } then {
	#--> As we can not read the file, the sort can not be running
	set running 0
    } else {
	gets $f running
	close $f
    }
    if { $mydebug == 1 } then {
	puts "running = $running"
    }

    if { $running == 1 } then {
	if { $paused == 0} then {
	    :modify MSRSTATE :label "Paused"
	    :modify BSTART   :label "Continue" :inactive F
	    :modify BSTOP    :label "Kill"

	    update idletasks
	    
	    if { $sigforce == 1 } then {
		set rc [catch { exec smf-sigsend 1 } m]
	    } else {
#		set rc [catch { exec shmctrl 2 w 1 } m]
		set rc [catch { exec midasSortshm w 1 1 } m]
	    }
	    
	    set paused 1
	    
	} else {
	    :modify MSRSTATE :label "Killed"
	    :modify BSTART   :label "Start"
	    :modify BSTOP    :label "Stop"

	    if { $sigforce == 1 } then {
		set rc [catch { exec smf-sigsend -1 } m]
	    } else {
#		set rc [catch { exec shmctrl 2 w -1 } m]
		set rc [catch { exec midasSortshm w 1 -1 } m]
	    }
	    set running 0
	    set paused 0
	    inable 1
	    update idletasks
	    set running 0
	}
    } else {
	:modify MSRSTATE :label "NOT running"
	:modify BSTART :inactive F
	:modify BSTOP :inactive F

	inable 1
	
	set running 0
	set paused 0
	set started 0
	update idletasks
    }


} 
 
 
