#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Control Frame                                           <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 11/27/02                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Include files containing other procedures               <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
loadsource variables
loadsource browse_sortfile
loadsource edit_sortfile
loadsource bsopts
loadsource device_ctrl
loadsource out_device_ctrl
loadsource abort_report
loadsource compile_sortfile
loadsource click
loadsource tsortfile
loadsource insert-list
loadsource lets_go
loadsource lets_not_go
loadsource vic_edit
loadsource tape_info
loadsource get_settings
loadsource memsas_ctrl
loadsource save_settings
loadsource sort_options
loadsource debug
loadsource leave_sort
loadsource config_table
loadsource inable
loadsource status
loadsource setthist
loadsource disk
loadsource get_after_status
loadsource view_data
loadsource preferences
loadsource kill_memsas
loadsource resource
loadsource set_colour
loadsource user_var
loadsource splash
loadsource check_experiment
loadsource developer
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Procedure to setup and draw the GUI                     <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc start args {
    global started preferences
    global input_type
    global env
    global scomplete
    global mydebug

    set scomplete 0

    if { $started == 0 } then {
      set started 1
      image create photo ring -format gif -file [ file join $env(MIDASBASE) MIDASsort logo.gif ]
      splash_create ring "MIDASsort Version 1.0" " Contact D. Appelbe \n(D.Appelbe@dl.ac.uk)\n  for more details  " "Initialising ...."

	if { $mydebug == 1 } then { puts "1" }
	
	start1
	
	if { $mydebug == 1 } then { puts "2" }		
	 input_media $input_type
	 if { $mydebug == 1 } then { puts "3" }
       }
}

proc start1 {} {
    global mydebug env

    if { $mydebug == 1 } then { puts "4" }
    set env(MSPWD) [ pwd ]
#--> Ok Now we should makesure that the executable path is set ..
    if { $mydebug == 1 } then { puts "4-1-1" }
    lappend env(PATH) ":$env(MIDASBASE)/MIDASsort/bin"
    if { $mydebug == 1 } then { puts "4-1" }
    splash_update "Preferences loading ...."
    if { $mydebug == 1 } then { puts "4-2" }
    after 1000 
    start2
}

proc start2 {} {
    global mydebug

    if { $mydebug == 1 } then { puts "5" }
    LoadPreferences
    if { $mydebug == 1 } then { puts "5-1" }
    splash_update "Checking enviroment for a valid EXPERIMENT  ....."
    if { $mydebug == 1 } then { puts "5-2" }
    after 1000 
    start2a
}

proc start2a {} {
    global mydebug

    if { $mydebug == 1 } then { puts "51" }
    check_experiment
    if { $mydebug == 1 } then { puts "51-1" }
    splash_update "Checking for memsas server ....."
    if { $mydebug == 1 } then { puts "51-2" }
    after 1000 
    start3
}

proc start3 {} {
    global mydebug

    if { $mydebug == 1 } then { puts "6" }
    check_server
    if { $mydebug == 1 } then { puts "6-1" }
    splash_update "Setting system colours ..." 
    if { $mydebug == 1 } then { puts "6-2" }
    after 1000 
    start4
}

proc start4 {} {
    global input_type
    global mydebug

    if { $mydebug == 1 } then { puts "7" }
    set_colour
    if { $mydebug == 1 } then { puts "7-1" }
    splash_update "Generating GUI ..." 
    if { $mydebug == 1 } then { puts "7-2" }
    after 1000 
    start5
}

proc start5 {} {
    global scomplete
    global mydebug

    if { $mydebug == 1 } then { puts "8" }
    after 2000 splash_remove
    if { $mydebug == 1 } then { puts "8-1" }
    splash_update "MIDASsort Ready to rumble ..."
    if { $mydebug == 1 } then { puts "8-2" }
    make-frame
    if { $mydebug == 1 } then { puts "8-3" }
    
    set scomplete 1
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Procedure to define the layout of our GUI               <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc make-frame {} {
    global mediastring fmtstring tstring
    global srstate
    global sortfilename directory
    global file_status
    global input_type idf data_type
    global output_type odf
    global ssavedir
    global overwritespec
    global thist
    global indev infmt

    :frame [self frame-name] :label "[self frame-title]" :show-footer T \
	    :icon-name "[self icon-title]" :resize F
    :panel PH1 :layout L :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 5
     :message MSORT :label "Sort Setup" :bold T :colour "-fg black"
     :message DUMDUM :label " " :w 60c
     :next-row T
#--> Sortfile input name
     :text TSORTFILE :label "Sortfile:" :valuex 9c :shifters T \
	     :value $sortfilename
     :hskip 5
     :button BBROWSE :label "Browse" 
     :hskip 5
     :message MS :label "State:" :bold T
     :message STATE :label $file_status
     :next-row T
     :hskip 5
     :button BEDITFILE :label "Edit Sortfile"      :w 12 :inactive T
     :hskip 9
     :button BCOMPILE  :label "Compile Sortfile"   :w 12 :inactive T
     :hskip 9
     :button BSETTINGS :label "Settings"           :w 12
     :hskip 9
     :button BSOPTS    :label "Sort Options"       :w 12
     :next-row T
#--> Input Stream / Data Format / Upper and lower run numbers
     :hskip 5
     :choice-stack CSMEDIA :label "Input Media" :strings $mediastring \
	     :value $input_type
     :hskip 40
     :choice-stack CSFMT :label "Data Format" :strings $fmtstring :rows 5 \
	     :value $data_type
     :hskip 20
     :button BIMEDIADATA :label "Tape Info" :w 12 :inactive F
     :next-row T
#--> Device/command input
     :text TDEVICE :label $tstring :valuex 9c :shifters T :value $idf
     :hskip 5
     :button BBROWSEDEV :label "Browse"
     :hskip 5
     :message MSD :label "State:" :bold T
     :message STATED :label "Not Selected"
     :next-row T
#--> Output Stream / Data Format
     :hskip 5
     :choice-stack CSMEDIAO :label "Output Media" :strings "NULL" :inactive T
     :hskip 40
     :choice-stack CSFMTO :label "Data Format" :strings "NULL" :rows 5 :inactive T
     :next-row T
#--> Device/command input
     :text TDEVICEO :label $tstring :valuex 9c :shifters T :value $odf :inactive T
     :hskip 5
     :button BBROWSEDEVO :label "Browse" :inactive T
     :hskip 5
     :message MSDO :label "State:" :bold T
     :message STATEDO :label ""
     :next-row T
#--> Spectrum Control
     :message MSPEC :label "Spectrum Control" :bold T :colour "-fg black"
     :next-row T
#-->     :text TSAVEDIR :label "Save to:" :valuex 9c :shifters T :value $ssavedir
#-->     :hskip 80
#--><<<<     :button BBROWSESPECDIR :label "Browse"
#-->     :next-row T
#-->     :hskip 5
#-->     :number NREFRESH :label "Refresh every (s)" :min 5 :max 3600 :w 4
#-->     :hskip 59
#     :choice-stack CSOS :label "Overwrite Existing Spectra" :strings "No Yes" :value $overwritespec
     :checkbox CSOS :label "Overwrite Existing Spectra" :value $overwritespec :valuex 25c
     :button BSPECTRA  :label "View Spectra"       :w 12  :inactive T :x 405
     :next-row T
     :checkbox CBTHIST :label "Enable Histogramming" :value $thist :valuex 25c
     :next-row T
#--> Some Control Buttons
     :message MSRUN :label "Sort Control" :bold T :colour "-fg black"
     :message MSRSTATE :label $srstate :bold T 
     :next-row T
     :button BSTART    :label "Start"              :w 12
     :hskip 9
     :button BSTOP     :label "Stop"               :w 12 :inactive T
     :hskip 9
#     :button BSTATUS   :label "Update"             :w 12 :inactive T
     :hskip 160
     :button BQUIT     :label "Exit"               :w 12
#      bind [:path BQUIT] <ButtonPress-3>  "msau"


    :panel P3 :layout B :padx 5 :pady 5 :after FOOTER
     :galley LIST :cols 50 :rows 8 :deaf T  :font variable
     open-frame
     :galley_size LIST 8 50

# :show T

    bind [:path BSOPTS] <ButtonPress-3>  "developer"

}
