#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> msau.tcl : Midas Sort Advanced user interface           <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
set msau_sort_running      "Not Running"
set msau_sort_paused       "Not Paused"
set msau_ts_connection     "Not Present"
set msau_disk_file         "Not Present"
set msau_tape_file         "Not Present"
set msau_debug_value       0
set msau_saction_value     0
set msau_thist_value       0

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc click-bmsau1 {} {
    msau-obtain-settings
}
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Get the status of all of the settings ...               <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc msau-obtain-settings {} {
    global msau_debug_value
    global msau_saction_value
    global msau_thist_value

    set rc [catch { exec shmctrl "1" "r" } msau_debug_value ]
    set rc [catch { exec shmctrl "2" "r" } msau_saction_value ]
    set rc [catch { exec shmctrl "5" "r" } msau_thist_value ]

    :modify MMSAU3 :label $msau_debug_value
    :modify MMSAU5 :label $msau_saction_value
    :modify MMSAU7 :label $msau_thist_value

}
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Startup routine ...                                     <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc start args {
   global started preferences

   if {$started == 0} then {
       make-frame
       set started 1
   } else {
       open-frame
   }
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#-->  Define the GUI that we will be using                   <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc make-frame {} {
    global msau_debug_value
    global msau_saction_value
    global msau_thist_value


    :frame FMSAU  :label "MIDASsort: Advanced User Control" \
	:icon-name "MIDASsort: Advanced User ctrl" :resize F \
	:transient T

    :panel PMSAU1 :layout L
     :layout H
     :message MMSAU1 :label "MIDASsort: Advanced User CTRL" :bold T
     :next-row T
     :next-row T
     :message MMSAU2 :label "Sort debug value: " \
	:valuex 20c :colour "-fg black"
     :message MMSAU3 :label $msau_debug_value :valuex 6c
     :next-row T
     :message MMSAU4 :label "Sort action value" \
	:valuex 20c :colour "-fg black"
     :message MMSAU5 :label $msau_saction_value :valuex 6c
     :next-row T
     :message MMSAU6 :label "Sort histogram value" \
	:valuex 20c  :colour "-fg black"
     :message MMSAU7 :label $msau_thist_value :valuex 6c
     :next-row T
     :next-row T
     :button BMSAU1 :label "Redisplay" :w 7

    :show T

    msau-obtain-settings

}

