#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> preferences.tcl : This file contains all of the procs   <--#
#-->                   related to the use of the preferences <--#
#-->                   feature in MIDAS tcl                  <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc LoadPreferences {} {
    global preferences
    global mydebug
    global preflist
    global update_time input_type data_type
    global midasbase
    global directory
    global gaindirectory
    global gatedirectory
    global env
    global makefilepath
    global configtable
    global usegcc
    global sortdatadir
    global usesssnc
    global kmemsas
    global diskffmt
    global uv1 uv2 uv3 uv4 uv5 uv6 uv7 uv8 uv9 uv10 uv11 uv12
    global uv13 uv14 uv15 uv16
    global vdpos vdaspos

    #--> Call the system routine to perform this load ...
    if { $mydebug == 1 } then {
	puts "Loading system preferences"
    }
    load_preferences
    if { $mydebug == 1 } then {
	parray preferences
    }
    #--> Now Are the preferences set .. if not set them to the default
    foreach item $preflist {
	switch $item {
	    updateTime             { if {![info exists preferences($item)]} then { set preferences($item) $update_time }  }
	    inputDevice            { if {![info exists preferences($item)]} then { set preferences($item) $input_type }  }
	    inputFormat            { if {![info exists preferences($item)]} then { set preferences($item) $data_type }  }
	    sortDir                { if {![info exists preferences($item)]} then { set preferences($item) $directory }  }
	    sortDataDir            { if {![info exists preferences($item)]} then { set preferences($item) $sortdatadir }  }
	    gainDir                { if {![info exists preferences($item)]} then { set preferences($item) $gaindirectory }  }
	    gateDir                { if {![info exists preferences($item)]} then { set preferences($item) $gatedirectory }  }
	    makeFilePath           { if {![info exists preferences($item)]} then { set preferences($item) $makefilepath }  }
	    configTable            { if {![info exists preferences($item)]} then { set preferences($item) $configtable }  }
	    useGCCcompilers        { if {![info exists preferences($item)]} then { set preferences($item) $usegcc }  }
	    useSunSortSpecNameConv { if {![info exists preferences($item)]} then { set preferences($item) $usesssnc }  }
	    killMemsasOnExit       { if {![info exists preferences($item)]} then {set preferences($item) $kmemsas } }
	    inDiskFormat           { if {![info exists preferences($item)]} then {set preferences($item) $diskffmt } }
	    userVar01              { if {![info exists preferences($item)]} then {set preferences($item) $uv1 } }
	    userVar02              { if {![info exists preferences($item)]} then {set preferences($item) $uv2 } }
	    userVar03              { if {![info exists preferences($item)]} then {set preferences($item) $uv3 } }
	    userVar04              { if {![info exists preferences($item)]} then {set preferences($item) $uv4 } }
	    userVar05              { if {![info exists preferences($item)]} then {set preferences($item) $uv5 } }
	    userVar06              { if {![info exists preferences($item)]} then {set preferences($item) $uv6 } }
	    userVar07              { if {![info exists preferences($item)]} then {set preferences($item) $uv7 } }
	    userVar08              { if {![info exists preferences($item)]} then {set preferences($item) $uv8 } }
	    userVar09              { if {![info exists preferences($item)]} then {set preferences($item) $uv9 } }
	    userVar10              { if {![info exists preferences($item)]} then {set preferences($item) $uv10 } }
	    userVar11              { if {![info exists preferences($item)]} then {set preferences($item) $uv11 } }
	    userVar12              { if {![info exists preferences($item)]} then {set preferences($item) $uv12 } }
	    userVar13              { if {![info exists preferences($item)]} then {set preferences($item) $uv13 } }
	    userVar14              { if {![info exists preferences($item)]} then {set preferences($item) $uv14 } }
	    userVar15              { if {![info exists preferences($item)]} then {set preferences($item) $uv15 } }
	    userVar16              { if {![info exists preferences($item)]} then {set preferences($item) $uv16 } }
	    vdposGLOB              { if {![info exists preferences($item)]} then {set preferences($item) $vdpos } }
	    vdasposGLOB            { if {![info exists preferences($item)]} then {set preferences($item) $vdaspos } }
	}
    }

    #--> Now set all of our variables to what is in the pref list
    foreach item $preflist {
	switch $item {
	    updateTime             { set update_time $preferences($item) }
	    inputDevice            { set input_type $preferences($item) }
	    inputFormat            { set data_type $preferences($item) }
	    sortDir                { set directory $preferences($item) }
	    sortDataDir            { set sortdatadir $preferences($item) }
	    gainDir                { set gaindirectory $preferences($item) }
	    gateDir                { set gatedirectory $preferences($item) }
	    makeFilePath           { set makefilepath $preferences($item) }
	    configTable            { set configtable $preferences($item) }
	    useGCCcompilers        { set usegcc $preferences($item) }
	    useSunSortSpecNameConv { set usesssnc $preferences($item) }
	    killMemsasOnExit       { set kmemsas $preferences($item) }
	    inDiskFormat           { set diskffmt $preferences($item) }
	    userVar01              { set uv1 $preferences($item) }
	    userVar02              { set uv2 $preferences($item) }
	    userVar03              { set uv3 $preferences($item) }
	    userVar04              { set uv4 $preferences($item) }
	    userVar05              { set uv5 $preferences($item) }
	    userVar06              { set uv6 $preferences($item) }
	    userVar07              { set uv7 $preferences($item) }
	    userVar08              { set uv8 $preferences($item) }
	    userVar09              { set uv9 $preferences($item) }
	    userVar10              { set uv10 $preferences($item) }
	    userVar11              { set uv11 $preferences($item) }
	    userVar12              { set uv12 $preferences($item) }
	    userVar13              { set uv13 $preferences($item) }
	    userVar14              { set uv14 $preferences($item) }
	    userVar15              { set uv15 $preferences($item) }
	    userVar16              { set uv16 $preferences($item) }
	    vdposGLOB              { set vdpos $preferences($item) }
	    vdasposGLOB            { set vdaspos $preferences($item) }
	}
    }

}

proc SavePreferences {} {
    global preferences
    global mydebug
    global preflist
    global update_time input_type data_type
    global midasbase
    global directory
    global gaindirectory
    global gatedirectory
    global env
    global makefilepath
    global configtable
    global usegcc
    global sortdatadir
    global usesssnc
    global kmemsas
    global diskffmt
    global uv1 uv2 uv3 uv4 uv5 uv6 uv7 uv8 uv9 uv10 uv11 uv12
    global uv13 uv14 uv15 uv16
    global vdpos vdaspos

    #--> Now set all of our variables to what is in the pref list
    foreach item $preflist {
	switch $item {
	    updateTime             { set preferences($item) $update_time }
	    inputDevice            { set preferences($item) $input_type }
	    inputFormat            { set preferences($item) $data_type }
	    sortDir                { set preferences($item) $directory }
	    sortDataDir            { set preferences($item) $sortdatadir }
	    gainDir                { set preferences($item) $gaindirectory }
	    gateDir                { set preferences($item) $gatedirectory }
	    makeFilePath           { set preferences($item) $makefilepath }
	    configTable            { set preferences($item) $configtable }
	    useGCCcompilers        { set preferences($item) $usegcc }
	    useSunSortSpecNameConv { set preferences($item) $usesssnc }
	    killMemsasOnExit       { set preferences($item) $kmemsas }
	    inDiskFormat           { set preferences($item) $diskffmt }
	    userVar01              { set preferences($item) $uv1 }
	    userVar02              { set preferences($item) $uv2 }
	    userVar03              { set preferences($item) $uv3 }
	    userVar04              { set preferences($item) $uv4 }
	    userVar05              { set preferences($item) $uv5 }
	    userVar06              { set preferences($item) $uv6 }
	    userVar07              { set preferences($item) $uv7 }
	    userVar08              { set preferences($item) $uv8 }
	    userVar09              { set preferences($item) $uv9 }
	    userVar10              { set preferences($item) $uv10 }
	    userVar11              { set preferences($item) $uv11 }
	    userVar12              { set preferences($item) $uv12 }
	    userVar13              { set preferences($item) $uv13 }
	    userVar14              { set preferences($item) $uv14 }
	    userVar15              { set preferences($item) $uv15 }
	    userVar16              { set preferences($item) $uv16 }
	    vdposGLOB              { set preferences($item) $vdpos }
	    vdasposGLOB             { set preferences($item) $vdaspos }
	}
    }
    if { $mydebug == 1 } then {
	parray preferences
    }
    #--> Now Save things ....
    update_preferences

}