#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Tape Info frame                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 04/28/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc tape_info {} {
    global imedia ifmt numitapes imedianum simedianame
    global imediahdr imediavals
    global dtext atext ffmt bfmt startitape tfctr

    set filefmt [ list "text number" "text number text" "custom" ] 
    set blksize [ list 1024 2048 4096 8192 16384 32768 65536 ] 

    if { $imedia == 0 } then {
#--> Tape in use as input device
	:frame FIMEDIA :label "MIDASsort: Tape file info" \
		:icon-name "MIDASsort: Tape file info" :resize F \
		:transient T
	 :panel PIMEDIA :layout V :padx 5 :pady 5
	  :layout H
	  :message MIMEDIAT :label "MIDASsort: Tape file info" :bold T
	  :next-row T
	  :next-row T
	  :number NIMEDIATAPES :label "Number of Tapes to Scan" :min 1 \
		  :max 30 :value $numitapes :w 3
	if { $ifmt == 1 } then {
#--> We have ansi format tapes we need to know what not to read
	    :next-row T
	    :message MIMEDIA :label "Use the form below to decide which runfiles to IGNORE"
	    :next-row T
	    :next-row T
	    :layout H
	    :next-row T
	    :next-row T
	    :panel PIMDIA2 :layout L :padx 5 :pady 5
	     :layout V
	     :list IMEDIALIST :cols 15 :rows 10 :exclusive T :see 0 \
		     :scroll V :strings $imediahdr
	    :panel PIMDIA2A :layout L :padx 5 :pady 5
	     :layout H
	    :number NIMEDIAVAL :label "Tape Number" :min 1 :max 20 \
		    :value $imedianum :w 3
	    :next-row T
	    :hskip 20
	    :text TIMEDIANAME :label "File Name" :value $simedianame :w 6
	    :next-row T
	    :button BIMEDIAADD :label "Add" :w 7
	    :button BIMEDIAREMOVE :label "Remove" :w 7
	    :next-row T
	    :button BIMEDIAOK :label "All Set" :w 7
        } elseif { $ifmt == 1 } then {
	    :hskip 25
	    :button BIMEDIAOK :label "All Set" :w 7
	}
	:show T
    } elseif { $imedia == 1 } then {
#--> Disk files in use as input device
#-->	:frame FIMEDIAT :label "MIDASsort: Data file info" \
#-->		:icon-name "MIDASsort: Data file info" :resize F \
#-->		:transient T
#-->	 
#-->	 :panel PIMEDIAT :layout V :padx 5 :pady 20
#-->	  :layout H
#-->	  :message MIMEDIAD :label "MIDASsort: Data file info" :bold T
#-->	  :next-row T
#-->	  :next-row T
#-->	  :choice-stack CSMEDIAD :label "Filename Format" :strings $filefmt \
#-->		  :value $ffmt
#-->	  :hskip 40
#-->	  :number NIMEDIADTAPES :label "Number of Files to Scan" :min 1 \
#-->		  :max 100 :value $numitapes :w 3
#-->	  :next-row T
#-->	  :next-row T
#-->	  :text TTEXTD1 :label "Text" :w 36 :shifters T :value $dtext
#-->	  :hskip 20
#-->	  :text TTEXTD2 :label "Append Text" :w 8 :shifters F \
#-->		  :value $atext
#-->	  :next-row T
#-->	  :next-row T
#-->	  :next-row T
#-->	 :panel PIMDIAD2 :layout L :padx 5 :pady 5
#-->	  :layout V
#-->	  :list IMEDIADLIST :cols 35 :rows 15 :exclusive T :see 0 \
#-->		  :scroll V
#-->	 :panel PIMDIAD2A :layout L :padx 5 :pady 5
#-->	  :layout H
#-->	  :choice-stack CSMEDIADLEN :label "Block Size" :strings $blksize \
#-->		  :value 5
#-->	  :next-row T
#-->	  :next-row T
#-->	  :button BIMEDIADADD :label "Add" :w 7
#-->	  :hskip 5
#-->	  :button BIMEDIADREMOVE :label "Remove" :w 7
#-->	  :next-row T
#-->	  :button BIMEDIADGENERATE :label "Generate" :w 7
#-->	  :hskip 5
#-->	  :button BIMEDIADCLEAR :label "Clear" :w 7
#-->	  :next-row T
#-->	  :next-row T
#-->	  :next-row T
#-->	  :button BMEDIADSET :label "All Set"
#-->	  :hskip 5
#-->	  :button BIMEDIADRD :label "ReDisplay" :w 7
#-->	  
#-->	:show T
	disk
    }

}

#--> Here are the routines that are used by the tape portion of our GUI
proc paint-imedialist {} {
    global imediahdr imediavals imediaselect

    set mylist $imediahdr

    foreach v $imediavals { lappend mylist $v }

    :modify IMEDIALIST :empty T :strings $mylist
    :modify IMEDIALIST :select $imediaselect
}

proc add-imedia {} {
    global imediahdr imediavals imediaselect
    global numitapes imedianum simedianame

    set fred [ format "%3d   %6s" $imedianum $simedianame ]
    lappend imediavals $fred
    
    paint-imedialist

}

proc ok-imedia {} {
    global imediahdr imediavals imediaselect
    global numitapes imedianum simedianame ifmt

    if { $numitapes < 1 } then {
	midas-warning "Incorrect number of tapes specified ($numitapes)\n"
	return
    }

    set z [ catch { open "tape.info" w } f ]
    if {$z != 0} then {
	midas-warning "Unable to write file $sortfilename\n$f"
	return
    } else {
	puts $f "$ifmt"
	puts $f "$numitapes"
	foreach v $imediavals { puts $f "$v" }
    }
    close $f
    midas-report "Data saved ok ...\n"

    :modify STATED :label "Files input"

    set numitapes 0
    
    destroy-frame FIMEDIA

}

proc choice-imedia {s} {
    global imediaselect

    if { $s > 0 } then {
	set imediaselect $s
    }

    :modify IMEDIALIST :select $imediaselect

}

proc remove-imedia {} {
    global imediaselect imediavals tfctr

    if { $imediaselect > 0 } then {
	set imediaselect [expr { $imediaselect - 1 } ]
	set imediavals [ lreplace $imediavals $imediaselect $imediaselect ]
	set imediaselect -1
	set tfctr [ expr { $tfctr - 1 } ]
	paint-imedialist
    }

}
#--> Here are the routines used by the Disk part of the gui ....
proc paint-imediadlist {} {
    global imediadhdr imediadvals imediaselect

    set mylist ""

    foreach v $imediadvals { lappend mylist $v }

    :modify IMEDIADLIST :empty T :strings $mylist
    :modify IMEDIADLIST :select $imediaselect
}

proc add-imediad {} {
    global imediadvals imediadselect
    global numitapes dtext atext ffmt bfmt startitape tfctr
    global mydebug

    set i $numitapes

    if { $mydebug == 1 } then {
	puts $ffmt
    }

    if { $ffmt == 0 } then {
	set fred [ format "%s%i     %i" $dtext $i $bfmt ]
	set tfctr [ expr { $tfctr + 1 } ]
    } elseif { $ffmt == 1 } then {
	set fred [ format "%s%i%s     %i" $dtext $i $atext $bfmt ]
	set tfctr [ expr { $tfctr + 1 } ]
    } else {
	set fred [ format "%s%s     %i" $dtext $atext $bfmt ]
	set tfctr [ expr { $tfctr + 1 } ]
    }
    lappend imediadvals $fred

    set dtext ""
    set atext ""

    :modify TTEXTD1 :value $dtext
    :modify TTEXTD2 :value $atext

    paint-imediadlist

}

proc gen-imediad {} {
    global imediadvals imediadselect
    global numitapes dtext atext ffmt bfmt startitape tfctr

    for { set i $startitape } { $i < $numitapes } { incr i } {
	if { $ffmt == 0 } then {
	    set fred [ format "%s%i     %i" $dtext $i $bfmt ]
	    set tfctr [ expr { $tfctr + 1 } ]
	} elseif { $ffmt == 1 } then {
	    set fred [ format "%s%i%s     %i" $dtext $i $atext $bfmt ]
	    set tfctr [ expr { $tfctr + 1 } ]
	} else {
	}
	lappend imediadvals $fred
    }

    set dtext ""
    set atext ""

    :modify TTEXTD1 :value $dtext
    :modify TTEXTD2 :value $atext

    paint-imediadlist

}

proc ok-imediad {} {
    global imediadvals imediadselect
    global numitapes dtext atext ffmt bfmt startitape tfctr

    if { $tfctr < 1 } then {
	midas-warning "Incorrect number of files specified ($numitapes)\n"
	return
    }

    set z [ catch { open "disc.info" w } f ]
    if {$z != 0} then {
	midas-warning "Unable to write file disc.info\n$f"
	return
    } else {
	puts $f "$tfctr"
	foreach v $imediadvals { puts $f "$v" }
    }
    close $f
    midas-report "Data saved ok ...\n"

    :modify STATED :label "Files input"

    destroy-frame FIMEDIAT
}

proc choice-imediad {s} {
    global imediadselect

    set imediadselect $s

    :modify IMEDIADLIST :select $imediadselect

}

proc remove-imediad {} {
    global imediadselect imediadvals

    set imediadvals [ lreplace $imediadvals $imediadselect $imediadselect ]
    paint-imediadlist

}

proc clear-imediad [] {
    global imediadvals tfctr 
    global atext dtext numitapes bfmt ffmt
    global mydebug

    if { $mydebug == 1 } then {
	puts $tfctr
    }

    set tfctr [ expr { $tfctr - 1 } ]

    while { $tfctr >= 0 } {
	set imediadvals [ lreplace $imediadvals $tfctr $tfctr ]
	set tfctr [ expr { $tfctr - 1 } ]
    }

    paint-imediadlist

    set dtext ""
    set atext ""
    set tfctr 1
    set bfmt 32768

    :modify CSMEDIAD :value 0
    :modify NIMEDIADTAPES :value 1
    :modify TTEXTD1 :value $dtext
    :modify TTEXTD2 :value $atext

}
