#--> ======================================================== <--#
#--> The control routines ...                                 <--#
#--> ======================================================== <--#
proc paint-disklist {} {
    global list_select list_vals

    set mylist {}
    
    foreach v $list_vals { lappend mylist $v }

    :modify LDISK :empty T :strings $mylist
    :modify LDISK :select $list_select

}
#--> ======================================================== <--#
proc add-list {} {
    global dtext
    global atext
    global dstart
    global dstop
    global ffmt
    global bfmt
    global list_vals
    global tfctr

    if { $ffmt == 0 } then {
	if { $dstart <= $dstop } then {
	    for { set i $dstart } { $i <= $dstop } { incr i } {
		set fred  [ format "%32s%i        %i" $dtext $i $bfmt ]
		set tfctr [ expr { $tfctr + 1 } ]
		lappend list_vals $fred
	    }
	} else {
	    set fred  [ format "%32s%i        %i" $dtext $dstart $bfmt ]
	    set tfctr [ expr { $tfctr + 1 } ]
	    lappend list_vals $fred
	}
    } elseif { $ffmt == 1 } then {
	if { $dstart <= $dstop } then {
	    for { set i $dstart } { $i <= $dstop } { incr i } {
		set fred  [ format "%32s%i%s        %i" $dtext $i $atext $bfmt ]
		set tfctr [ expr { $tfctr + 1 } ]
		lappend list_vals $fred
	    }
	} else {
	    set fred  [ format "%32s%i%s        %i" $dtext $dstart $atext $bfmt ]
	    set tfctr [ expr { $tfctr + 1 } ]
	    lappend list_vals $fred
	}
    } else {
	set fred  [ format "%32s        %i" $dtext $bfmt ]
	set tfctr [ expr { $tfctr + 1 } ]
	lappend list_vals $fred
    }

    set dstart 0
    set dstop  1
    set dtext  ""
    set atext  ""
    
    :modify NDISK  :value $dstart
    :modify NDISK1 :value $dstop
    :modify TDISK  :value $dtext
    :modify TDISK1 :value $atext

    paint-disklist

}

#--> ======================================================== <--#
proc remove-list {} {
    global list_select
    global tfctr
    global list_vals

    set list_vals[ lreplace $list_vals $list_select $list_select ]
    set list_vals -1
    set tfctr [ expr { $tfctr - 1 } ]
    paint-disklist

}

#--> ======================================================== <--#
proc select-item { s } {
    global list_select

    set list_select $s

    :modify LDISK :select $list_select

}
#--> ======================================================== <--#
proc ndisk arg {
    global dstart

    set dstart $arg

    :modify NDISK :value $dstart

}
#--> ======================================================== <--#
proc ndisk1 arg {
    global dstop

    set dstop $arg

    :modify NDISK1 :value $dstop

}
#--> ======================================================== <--#
proc csdisk arg {
    global ffmt

    set ffmt $arg

    if { $ffmt == 1 } then {
	:modify TDISK1 :inactive F
    } else {
	:modify TDISK1 :inactive T
    }

}
#--> ======================================================== <--#
proc browse_disk_files {} {
    global sortdatadir
    global dtext

    option add *Canvas.background  #c0c020

    set file [tk_getOpenFile -parent [self frame-name] \
		  -title "Input DataFile Selection"  \
		  -initialdir $sortdatadir ]
    option add *Canvas.background  $env(tkcanvasbackground)
    if {$file == ""} then {return}

    set dtext $file
    :modify TDISK :value $dtext
    [:path TDISK].entry xview 200

}

#--> ======================================================== <--#
#--> The procedure that sets up the GUI                       <--#
#--> ======================================================== <--#
proc disk {} {
    global imedia ifmt numitapes imedianum simedianame
    global imediahdr imediavals
    global dtext atext ffmt bfmt startitape tfctr dstart dstop


    set filefmt [ list "text number" "text number text" "custom" ] 
    set blksize [ list 1024 2048 4096 8192 16384 32768 65536 ] 

    :frame FDISK :label "MIDASsort: Disk Info" \
	:resize F \
	:transient T
    :panel PDISK :layout V :padx 5 :pady 5
    :layout H
    :message MDISK :label "DISK Info:" :bold T
    :hskip 5
    :message MDISK1 :label "Use this frame generate the file containing information about the input disc files to scan" :colour "-fg black"
    :next-row T
    :next-row T
    :list LDISK :cols 70 :rows 20 :exclusive T :see 0 \
	:scroll V
    :next-row T
    :panel PDISK2 :layout V :padx 5 :pady 5
    :layout H
    :choice-stack CSDISK :label "Name Format" :strings $filefmt \
	:value $ffmt
    :hskip 30
    :number NDISK :label "Start at" :min 0 \
	:max 500 :value $dstart :w 3
    :hskip 5
    :number NDISK1 :label "Stop at" :min 0 \
	:max 500 :value $dstop :w 3
    :hskip 20
    :choice-stack CSDISK1 :label "Block size" :strings $blksize \
	:value 5
    :panel PDISK3 :layout V :padx 5 :pady 5
    :layout H
    :text TDISK :label "Text" :w 35 :shifters T :value $dtext
    :hskip 25
    if { $ffmt == 1 } then {
	:text TDISK1 :label "Append text" :w 8 :shifters T :inactive F :value $atext
    } else {
	:text TDISK1 :label "Append text" :w 8 :shifters T :inactive T
    }
    :hskip 20
    :button BDISK6 :label "Browse" :w 10
    :panel PDISK1 :layout V :padx 5 :pady 5
    :layout H
    :button BDISK0 :label "Add" :w 10
    :hskip 10
    :button BDISK1 :label "Redisplay" :w 10
    :hskip 10
    :button BDISK2 :label "Remove" :w 10
    :hskip 10
    :button BDISK3 :label "Clear" :w 10
    :hskip 10
    :button BDISK4 :label "Quit & Save" :w 10
    :hskip 10
    :button BDISK5 :label "Cancel" :w 10
    :hskip 10
    :next-row T

    :show T

}

