#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> user_var.tcl : A total of 16 variables are provided     <--#
#-->                for the user to make use of. This GUI    <--#
#-->                can be used to set / change these        <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc user_var {} {
    global mydebug

    if { $mydebug == 1 } then { puts "user_var : Entered" }
    #--> First thing to do is to set up the GUI
    user_var.create
    if { $mydebug == 1 } then { puts "user_var : Leaving" }

}

proc user_var.create {} {
    global mydebug
    global uv1 uv2 uv3 uv4 uv5 uv6 uv7 uv8 uv9 uv10 uv11 uv12
    global uv13 uv14 uv15 uv16

    if { $mydebug == 1 } then { puts "user_var.create : Entered" }
    :frame FUSERVAR :label "MIDASsort: User Variables" :resize F :transient T
    :panel PUV1 :layout V :padx 5 :pady 5
     :layout H
     :message MUV1 :label "GUI to control user variables" :bold T
     :next-row T
     :next-row T
     :message MUV2 :label "Variables 1 - 4 are of type integer" :colour "-fg black"
     :next-row T
     :text TUV1 :label "UV1" :value $uv1 :w 11 :valuex 5c
     :hskip 10
     :text TUV2 :label "UV2" :value $uv2 :w 11 :valuex 5c
     :hskip 10
     :text TUV3 :label "UV3" :value $uv3 :w 11 :valuex 5c
     :hskip 10
     :text TUV4 :label "UV4" :value $uv4 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :message MUV3 :label "Variables 5 - 8 are of type unsigned integer" :colour "-fg black"
     :next-row T
     :text TUV5  :label "UV5" :value $uv5 :w 11 :valuex 5c
     :hskip 10 		    		 
     :text TUV6  :label "UV6" :value $uv6 :w 11 :valuex 5c
     :hskip 10 		    		 
     :text TUV7  :label "UV7" :value $uv7 :w 11 :valuex 5c
     :hskip 10 		    		 
     :text TUV8  :label "UV8" :value $uv8 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :message MUV4 :label "Variables 9 - 12 are of type short" :colour "-fg black"
     :next-row T
     :text TUV9  :label "UV9 " :value $uv9  :w 11 :valuex 5c
     :hskip 10		   		 	
     :text TUV10 :label "UV10" :value $uv10 :w 11 :valuex 5c
     :hskip 10		   		 	
     :text TUV11 :label "UV11" :value $uv11 :w 11 :valuex 5c
     :hskip 10		   		 	
     :text TUV12 :label "UV12" :value $uv12 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :message MUV5 :label "Variables 13 - 16 are of type float" :colour "-fg black"
     :next-row T
     :text TUV13 :label "UV13" :value $uv13 :w 11 :valuex 5c
     :hskip 10		   		 	
     :text TUV14 :label "UV14" :value $uv14 :w 11 :valuex 5c
     :hskip 10		   		 	
     :text TUV15 :label "UV15" :value $uv15 :w 11 :valuex 5c
     :hskip 10		   		 	
     :text TUV16 :label "UV16" :value $uv16 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :next-row T
     :button BUV1 :label "Write to shared memory"
    :show T
    if { $mydebug == 1 } then { puts "user_var.create : Leaving" }

}

proc user_var.write {} {
    global mydebug;
    global uv1 uv2 uv3 uv4 uv5 uv6 uv7 uv8 uv9 uv10 uv11 uv12
    global uv13 uv14 uv15 uv16

    for { set i 5 } { $i < 21 } { incr i } {
	set arg1 $i
	if { $i == 5 } then  { set arg2 [ scan $uv1 %i ] }
	if { $i == 6 } then  { set arg2 [ scan $uv2 %i ] }
	if { $i == 7 } then  { set arg2 [ scan $uv3 %i ] }
	if { $i == 8 } then  { set arg2 [ scan $uv4 %i ] }
	if { $i == 9 } then  { set arg2 [ scan $uv5 %u ] }
	if { $i == 10 } then { set arg2 [ scan $uv6 %u ] }
	if { $i == 11 } then { set arg2 [ scan $uv7 %u ] }
	if { $i == 12 } then { set arg2 [ scan $uv8 %u ] }
	if { $i == 13 } then { set arg2 [ scan $uv9 %i ] }
	if { $i == 14 } then { set arg2 [ scan $uv10 %i ] }
	if { $i == 15 } then { set arg2 [ scan $uv11 %i ] }
	if { $i == 16 } then { set arg2 [ scan $uv12 %i ] }
	if { $i == 17 } then { set arg2 [ scan $uv13 %f ] }
	if { $i == 18 } then { set arg2 [ scan $uv14 %f ] }
	if { $i == 19 } then { set arg2 [ scan $uv15 %f ] }
	if { $i == 20 } then { set arg2 [ scan $uv16 %f ] }
	if { $mydebug == 1 } then { puts "user_var.write : arg1 = $arg1  arg2 = $arg2" }
	set rc [ catch { exec midasSortshm w $arg1 $arg2 } ]
    }


}