# This file sets up "netints" that are used to initialise internal global
# variables when the register server starts.
# This allows globals to be set up before the registers' init routines are run.
#
# Only those globals that were "exported" from the register-server (via the
# generic register class) during compilation can be initialised in this way.
#
# N.B. 
# 1) A global that is exported but is not mentioned here is initialised to 0.
# 2) A global can be set via the generic class after the server has started.
#
# TraceMode displays VXI access info
netint TraceMode 0
# ContinueRegardless allows continuation when the accessed card doesn't exist
netint ContinueRegardless 1
