# clover.tcl---clover card control

# Wed Jan 25 17:30:37 GMT 1995, DB
#   substituted $env(EXPBASE) for /eg
# Wed Nov 30 11:02:18 GMT 1994, DB
#   printing via print templates introduced
# created 24-8-93 PHO

set debug 0
set started 0

set frame CLOVER
set frametitle "Clover Card Setup"
set icontitle Clover

set chanlist {???}
set chanindex 0
set seglist {A B C D E}
set segindex -1

set defaultchanlist {0 1 2 3 4 5 6 7}


set cardtype Clover

set suppressionfile ""
set suppressiondirectory "$env(EXPBASE)/clover-suppression"
set suppressiontable {Simple Exactly-One-Ge Ignore-Opposite-Corner File...}


#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for regsiter access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ALLSEGS)  {allsegs  int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Disable" 
      not-reg->param param->not-reg nil :checkbox nil nil nil 1 nil}
foreach i {A B C D E} {
   set table(ENABLE-$i) "enable$i int-widget->param param->int-widget \"Ge$i.Enable\" 
      int-reg->param param->int-reg nil :checkbox nil nil nil 0 nil 1 nil"
}
set table(ENABLE-BGO) {enablebgo int-widget->param param->int-widget "BGO.Disable" 
      not-reg->param param->not-reg nil :checkbox nil nil nil 1 nil}

set table(SUP) {suppression int-widget->param param->int-widget BGO.SuppressionTable
      suppression-reg->param param->suppression-reg nil :choice-stack suppressiontable nil nil 1 nil}
set table(SPARE) {spare spare-widget->param param->int-widget "GeE.4MeV.Addr" 
      spare-reg->param param->spare-reg nil nil nil nil nil 0 nil}

set table(ATTN) {attn int-widget->param param->int-widget "Ge.TestGen.Attn"
       int-reg->param param->int-reg nil :checkbox nil nil nil 0 nil}

set table(TESTGEN-GE) {testgeng slider-widget->param param->int-widget "Ge.TestGen" 
       unit-reg->param param->unit-reg keV :slider 0 7000 1 9 nil}
foreach i {A B C D E} {
   set table(TEST-GE-$i) "testge$i int-widget->param param->int-widget \"Ge$i.TestMode\"
       int-reg->param param->int-reg nil :checkbox nil nil nil 0 nil"
}

set table(TESTGEN-BGO) {testgenbgo slider-widget->param param->int-widget "BGO.TestGen" 
      unit-reg->param param->unit-reg mV :slider 0 5000 3 9 nil}
foreach i {A B C D E F G H} {
   set table(TEST-BGO-$i) "testbgo$i int-widget->param param->int-widget \"BGO.$i.TestMode.Disable\" 
       not-reg->param param->not-reg nil :checkbox nil nil nil 0 nil"
}

set table(CONFENETRES) {confenetres int-widget->param param->int-widget "ConFenetres" 
      int-reg->param param->int-reg nil :checkbox nil nil nil 0 nil}
set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard" 
      int-reg->param param->int-reg nil :checkbox nil nil nil 0 nil}

set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode" 
      int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum" 
      int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel" 
      int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID" 
      int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset" 
      int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(RESET-FIFO) {resetfifo int-widget->param param->int-widget "FIFO.Reset" 
      int-reg->param param->int-reg nil nil nil nil nil 0 nil}


#    register selection for parameter save function

set registersavepatterns {
   ConFenetres PileupReject
   Ge.CFD.Width Ge.FTSample Ge.ValSample Ge.Watchdog
   Ge[A-E].TFAGain
   Ge[A-E].Enable
   Ge[A-E].CFD.Thresh 
   Ge[A-E].CFD.Delay
   Ge[A-E].PoleZero
   Ge[A-E].PDSGate
   Ge[A-E].20MeV.Thresh  Ge[A-E].20MeV.SSEnable Ge[A-E].20MeV.ROEnable Ge[A-E].20MeV.Addr
   Ge[A-E].4MeV.Thresh   Ge[A-E].4MeV.SSEnable  Ge[A-E].4MeV.ROEnable  Ge[A-E].4MeV.Addr
   Ge[A-E].FT.Thresh     Ge[A-E].FT.SSEnable    Ge[A-E].FT.ROEnable    Ge[A-E].FT.Addr
   Ge[A-E].CO.Thresh     Ge[A-E].CO.SSEnable    Ge[A-E].CO.ROEnable    Ge[A-E].CO.Addr
   RdOut.ROCR
   BGO.SuppressionTable 
   BGO.Disable 
   BGO.Pattern.Thresh  BGO.Pattern.SSEnable BGO.Pattern.ROEnable
   BGO.TAC.Thresh      BGO.TAC.SSEnable     BGO.TAC.ROEnable
   BGO.Energy.Thresh   BGO.Energy.SSEnable  BGO.Energy.ROEnable
   BGO.Veto.Width BGO.DT.Width BGO.Sum.Width BGO.PDSGate 
   BGO.FTSample BGO.ValSample BGO.Watchdog BGO.Disc.Thresh
}

loadsource rdout
loadsource common.vxi


proc click-spare v {
	global debug cardtype chanlist chanindex segindex

	set adcs {20MeV 4MeV FT CO}
	set seg [lindex {E A B C D} $v]
	set chan [lindex $chanlist $chanindex]

        set segindex $v

	if {$v!=0} then {
		set val [second [read-reg $chan Ge$seg Enable]]
		write-reg $chan GeE    Enable $val 0
		write-reg $chan Ge$seg Enable    0 0
	}
	foreach adc $adcs {
		write-reg $chan GeE $adc.Addr $cardtype$chan.Ge$seg.$adc 0
	}
	click-redisplay
}

proc click-ge seg {
   global seglist
   inform cloverge start
   inform cloverge click-segment [lsearch $seglist $seg]
}

proc click arg {
   global debug VXIGlobal
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}
      HELP        {click-help}
      GE          {click-ge $v}
      BGO         {inform cloverbgo start}

      RDOUT       {click-RdOut}

      ALLCHANS  {click-whichchans $v}

      SUP         {set vxiglobal $VXIGlobal; set VXIGlobal ""; click-suppression $v; set VXIGlobal $vxiglobal}
      SPARE       {click-spare $v}

      CHANNEL     {
        click-channel $v
        catch {inform cloverge click-channel $v}
        catch {inform cloverbgo click-channel $v}
      }

      SUP-DIRECTORY {click-suppression-directory $v}
      SUP-FILE      {click-suppression-file $v}
      SUP-LIST      {click-suppression-list $c $v}
      SUP-LOAD      {click-suppression-load}

      default       {click-on $w $v}
      }
   }


global electronicsframe
set electronicsframe [self frame-name].electronics

global suppressionfarme
set suppressionframe [self frame-name].suppression


proc make-frame1 {} {
   global env suppressiontable seglist chanlist

   :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" 

     :panel P1 :layout T :padx 5 :pady 5
       :layout H; :row-gap 10 

	:choice-stack CHANNEL :label Channel: :valuex 8c :strings $chanlist

	:checkbox ALLCHANS :label "Act on all Channels:" 
#	:checkbox ALLSEGS  :label "Act on all Segments:"

        :row-gap 20; :next-row T; :row-gap 10	
	:choice ENABLE-A :exclusive F :strings A :label Enable: :w 3 :valuex 15c
        foreach i {B C D E} {
	   :choice ENABLE-$i   :exclusive F :strings "$i" :w 3
        }
	:choice ENABLE-BGO  :exclusive F :strings "BGO" :w 5

	:next-row T	
	:choice-stack SUP :label "Suppression Mode:" :valuex 20c :strings $suppressiontable
        :next-row T	
	:choice-stack SPARE :label "Spare Channel:" :valuex 20c  \
		:strings [list "Unused" "Position A" "Position B" "Position C" "Position D"]

    :panel P2 :layout B :padx 5 :pady 5
     :layout H; :row-gap 0
      :menubutton GE :label "Ge Channel" :strings $seglist
      :button BGO :label "BGO Channel..."
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button RDOUT :label "RdOut"
      :next-row T
      :button REDISPLAY :label Redisplay
      :hskip 80
      :button HELP :label "Help..." 

   :show T
}


proc make-electronics {} {
   global env electronicsframe electronicsvisible

set col1 20c
set col2 20c

  :frame $electronicsframe :label "Clover Electronics" :show-footer T :resize F :transient T

    :panel P :layout T :padx 5 :pady 5
     :layout H; :row-gap 5
     :checkbox LASTCARD    :label "Last Card:"                       :valuex $col1
     :text MODELCODE       :label "Model Code:"    :w 6 :read-only T :valuex $col2
     :next-row T
     :checkbox CONFENETRES :label "Controle Fenetres:"               :valuex $col1
     :text SERIALNUM       :label "Serial Number:" :w 6 :read-only T :valuex $col2
     :next-row T
     :text MODLEVEL        :label "Modification Level:" :w 6 :read-only T :valuex $col2
     :next-row T
     :checkbox RESET-FIFO  :label "Reset FIFO:"                          :valuex $col1
     :text MANID           :label "Manufacturer ID:" :w 6 :read-only T   :valuex $col2
     :next-row T 
     :checkbox ATTN        :label "Test Gen Attenuation:"                :valuex $col1
     :text OFFSET          :label "Offset Register:" :w 6 :read-only T   :valuex $col2
     :next-row T
     :choice TEST-GE-A :exclusive F :strings A :w 2 :label "Ge Test Mode:" :valuex $col1
     foreach i {B C D E} {
       :choice TEST-GE-$i :exclusive F :strings $i :w 2
     }

    :row-gap 10
    :next-row T
    :slider TESTGEN-GE :label "Test Generator (keV):" :min 0 :max 7000  :valuex $col1
    :next-row T
    :choice TEST-BGO-A :exclusive F :strings A :w 2 :label "BGO Test Mode:" :valuex $col1
    foreach i {B C D E F G H} {
       :choice TEST-BGO-$i :exclusive F :strings $i :w 2
    }
    :next-row T
    :slider TESTGEN-BGO :label "Test Generator (mV):" :min 0 :max 5000  :valuex $col1

    :show T
  set electronicsvisible 1
}       

proc make-suppression  {} {
   global env suppressionframe suppressionvisible suppressiondirectory suppressionfile 

   :frame $suppressionframe :label "Clover Suppresion Mode" :show-footer T :resize F :transient T 

set col1 10c

   :panel PA :layout L :padx 5 :pady 5
    :layout H

   :row-gap 10
   :text SUP-DIRECTORY :label Directory: :w 32  :value "$suppressiondirectory" :valuex $col1
   :next-row T
   :text SUP-FILE :label File: :w 30 :value "$suppressionfile" :valuex $col1
   :button SUP-LOAD :label Load
   :next-row T
   :text SUP-CURRENT :label Mode: :w 40 :read-only T :valuex $col1

   :panel PB :layout R :padx 5 :pady 5
    :layout H
   :list SUP-LIST    :rows 6 :cols 20
  
   :show T
  set suppressionvisible 1
}
