# demon.tcl---Setup frame for Demon card

#     created 1/7/03  from Icare card frame   VP

set debug 0
set started 0

set frame DEMON
set frametitle "Demon Card Setup"
set icontitle Demon

set chanlist {???}
set chanindex 0


set defaultchanlist {1 2 3 4 5 6 7 8 9 10 11 12}

set cardtype Demon
set VXIGlobal ""

set presetslist {}


#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil
        nil nil nil nil nil nil nil 0 nil}
       
set table(ADC1THRESH) {adc1thresh slider-widget->param param->int-widget "SYREP.Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "SYREP Threshold"}
set table(ADC1SSE) {adc1sse int-widget->param param->int-widget "SYREP.SSEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "SYREP SS Enable"}
set table(ADC1ROE) {adc1roe int-widget->param param->int-widget "SYREP.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "SYREP RO Enable"}
set table(ADC1ADDR) {adc1addr widget->param param->hex-widget "SYREP.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "SYREP Address"}

set table(ADC2THRESH) {adc2thresh slider-widget->param param->int-widget "Entire.Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Entire Threshold"}
set table(ADC2SSE) {adc2sse int-widget->param param->int-widget "Entire.SSEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Entire SS Enable"}
set table(ADC2ROE) {adc2roe int-widget->param param->int-widget "Entire.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Entire RO Enable"}
set table(ADC2ADDR) {adc2addr widget->param param->hex-widget "Entire.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Entire Address"}

set table(ADC3THRESH) {adc3thresh slider-widget->param param->int-widget "Slow.Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Slow Threshold"}
set table(ADC3SSE) {adc3sse int-widget->param param->int-widget "Slow.SSEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Slow SS Enable"}
set table(ADC3ROE) {adc3roe int-widget->param param->int-widget "Slow.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Slow RO Enable"}
set table(ADC3ADDR) {adc3addr widget->param param->hex-widget "Slow.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Slow Address"}

set table(ADC4THRESH) {adc4thresh slider-widget->param param->int-widget "Time.Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Time Threshold"}
set table(ADC4SSE) {adc4sse int-widget->param param->int-widget "Time.SSEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Time SS Enable"}
set table(ADC4ROE) {adc4roe int-widget->param param->int-widget "Time.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Time RO Enable"}
set table(ADC4ADDR) {adc4addr widget->param param->hex-widget "Time.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Time Address"}

set table(CFDTHRESH) {cfdthresh slider-widget->param param->int-widget "CFD.Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "CFD Threshold"}
set table(CFDDELAY) {cfddelay slider-widget->param param->int-widget "CFD.Delay"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "CFD Delay"}
set table(CFDWIDTH) {cfdwidth slider-widget->param param->int-widget "CFD.Width"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "CFD Width"}

set table(GATEWIDTH) {gatewidth slider-widget->param param->int-widget "Gate.Width"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Gate Width"}
set table(GATEDELAY) {gatedelay slider-widget->param param->int-widget "Gate.Delay"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Gate Delay"}

set table(FTSAMPLE) {ftsample slider-widget->param param->int-widget "FTSample"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Fast Trigger Sample"}
set table(CHANTRIG) {chantrig slider-widget->param param->int-widget "ChanTrigW3"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Channel Trigger W3"}

set table(TRIGDELAY) {trigdelay slider-widget->param param->int-widget "FT.Delay"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "FT Delay"}
set table(TRIGWIDTH) {trigwidth slider-widget->param param->int-widget "FT.Width"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "FT Width"}
set table(SYREPTHRESH) {syrepthresh slider-widget->param param->int-widget "SYREP_QDC_Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "SYREP Threshold"}
set table(E&STHRESH) {gatedelay slider-widget->param param->int-widget "E&S_QDC_Thresh"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Entire & Slow Threshold"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "ValSample"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Validation Sample"}
set table(TRIGW3) {trigw3 slider-widget->param param->int-widget "FT.W3"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Trigger Card W3"}

set table(SS) {ss slider-widget->param param->int-widget "SlidingScale"
       int-reg->param param->int-reg nil :slider nil nil nil 1 "Sliding Scale"}
set table(SSE) {sse int-widget->param param->int-widget "SSEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 0 "SS Enable"}
    
set table(CFDSCALER) {cfdscaler int-widget->param param->int-widget "PromptScaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(ADCSCALER) {adcscaler int-widget->param param->int-widget "ADCScaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALERSCLR) {scalersclr int-widget->param param->int-widget "Scalers.Clear"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALERSLOAD) {scalersload int-widget->param param->int-widget "Scalers.Load"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    These are used by the electronics window
set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Last Card"}
set table(VALMODE) {valmode int-widget->param param->int-widget "ValMode"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "Validation Mode"}
set table(FTMODE) {ftmode int-widget->param param->int-widget "FTMode"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "FT Mode"}
set table(CFDE) {cfde int-widget->param param->int-widget "CFD.Enable"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "CFD Mode"}
set table(LEMO) {lemo int-widget->param param->int-widget "LEMO.Enable"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "A1=>LEMO"}
set table(S2E) {s2e int-widget->param param->int-widget "Sumbus_2.Enable"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "Sumbus_2 Enable"}
set table(SB1C) {sb1c int-widget->param param->int-widget "Sumbus_1.Connect"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "Sumbus_1 Connect"}
set table(SB1C1) {sb1c1 int-widget->param param->int-widget "Sumbus_1.Connect1"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "Sumbus_1=>SUMBUS 1"}
set table(SB2C1) {sb2c1 int-widget->param param->int-widget "Sumbus_2.Connect1"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "Sumbus_2=>SUMBUS 1"}
set table(SB2C2) {sb2c2 int-widget->param param->int-widget "Sumbus_2.Connect2"
       int-reg->param param->int-reg nil :choice nil nil nil 1 "Sumbus_2=>SUMBUS 2"}
set table(FIFOMTY) {fifomty int-widget->param param->int-widget "FIFO.NotEmpty"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "FIFO not empty"}
set table(TIMEW3) {timew3 int-widget->param param->int-widget "TimeoutW3"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Timeout W3"}
set table(TIME256) {time256 int-widget->param param->int-widget "Timeout256"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Timeout 256"}


#    register selection for parameter save function

set registersavepatterns {
 FTMode ValMode Sumbus_1.* Sumbus_2.* SSEnable FT.* ValSample *_Thresh CFD.* Gate.*  \
 FTSample ChanTrigW3 *.Thresh *.SSEnable *.ROEnable *.Enable  
}


# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to 
# the Signal Select register

set insp_table(MUX-AI1) {"Insp.A1" AI}
set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}
set insp_table(MUX-VI)  {"Insp.V"  VI}

set insp_menu(MUX-AI1) analogueinsptable
set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable
set insp_menu(MUX-VI)  voltageinsptable


set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2 MUX-VI}
set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2 Insp.V}

#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set analogueinsptable {Disconnected
        SYSREP Entire Slow Time
}
set AI-ChanSelect {0 * * * *}
set AI-Param      {* 0 1 2 3}

set analogueinspmenu {Disconnected SYSREP Entire Slow Time}
  
set digitalinsptable {Disconnected Prompt Sumbus Slow Entire Trigger Inhibit \
      ADC_Clock Data_Available Data_Ack EOC TM Last_Pass \
      Fast_Trigger RAZ RENIN Trigger_Card_Inhibit Val_Sample Val_Input \
}

set DI-ChanSelect {0 * * * * * * 1 2 3 4 5 6 1 2 3 4 5 6} 
set DI-Param      {* 0 1 2 3 4 5 6 6 6 6 6 6 7 7 7 7 7 7} 

set digitalinspmenu {Disconnected Prompt Sumbus Slow Entire Trigger Inhibit \
      ADC_Clock Data_Available Data_Ack EOC TM Last_Pass \
      Fast_Trigger RAZ RENIN Trigger_Card_Inhibit Val_Sample Val_Input \
}
 
set voltageinsptable {Disconnected \
    CFD_Thresh CFD_Delay CFD_Width Gate_Width Gate_Delay FT_Sample W3 \
    VREF_DAC -24V -12V -6V -5.2V -2V 0V 5V 5V 6V 12V 9V 20V 24V \
    SYSREP_Thresh Entire&Slow_Thresh Trig_Width Trig_Delay Trig_W3 Val_Sample \
}

set VI-ChanSelect {0 * * * * * * * 7 7 7 7 7 7 7 7  7  7  7  7  7  7 1 2 3 4 5 6}
set VI-Param      {* 0 1 2 3 4 5 6 0 1 4 5 6 7 8 9 10 11 12 13 14 15 7 7 7 7 7 7}


#    these are common
set steplist1 ""
#    no per segment items
set steplist2 ""


loadsource common.vxi


#    procedures to handle prompt and adc scaler functions

proc click-scalers {} {
#  start scalers sub frame
   global scalersvisible scalersframe
   if {$scalersvisible==0} then {make-scalersframe} else {open-frame $scalersframe}
   click-updteallscalers
}

#    these procedures are called directly from the main Demon frame
#    they will apply to the scalers on the current card only unless the 
#    "Act on all Detectors" choice is set to All or Select

proc click-clearcurrentscalers {} {
#    to clear all scalers set control bit to 1 and then back to 0
   write-widget-reg SCALERSCLR 1
   write-widget-reg SCALERSCLR 0
}

proc click-loadcurrentscalers {} {
#    to load all scalers set control bit to 1 and then back to 0
   write-widget-reg SCALERSLOAD 1
   write-widget-reg SCALERSLOAD 0
}

#    these procedures are called directly from the Scalers display frame
#    they will apply to all scalers on all cards as if the "Act on all Detectors"
#    choice is set to All 

proc click-clearallscalers {} {
   global allchans
   set allchans 1
   make-myserver
   click-clearcurrentscalers
   set allchans 0
   make-myserver
   click-updateallscalers
}

proc click-loadallscalers {} {
#    to load all scalers set control bit to 1 and then back to 0
   global allchans
   set allchans 1
   make-myserver
   click-loadcurrentscalers
   set allchans 0
   make-myserver
}

proc click-updteallscalers {} {
   global allchans scalersframe
#    to redisplay all scalers in the Demon Scalers Display
#    first load all scalers
   open-frame $scalersframe
   set-footer $scalersframe "Updating Scalers"
   click-loadallscalers
#    now have to switch to all channel mode
   set allchans 1
   make-myserver
#    read all the ADC scalers and update display
   set l [read-regs * "" ADCScaler]
   foreach item $l {
       set r [first $item]
       set v [second $item]
       set m [first [split $r .]]
       set c [string range $m 5 end]
       :modify SCALEA$c :value $v
   }
#    read all the Prompt scalers and update display
   set l [read-regs * "" PromptScaler]
   foreach item $l {
       set r [first $item]
       set v [second $item]
       set m [first [split $r .]]
       set c [string range $m 5 end]
       :modify SCALEP$c :value $v
   }
#    and finally switch back to single channel mode
   set allchans 0
   make-myserver
   clear-footer $scalersframe
}

proc click-scalers-period v {
   global scaleperiod scaleperiodchoice

   set scaleperiod [lindex $scaleperiodchoice $v]
}

proc click-scalers-go v {
   global scalego scalerafterid scaleperiod
   set scalego $v
#    v=0   stop scalers auto update
#    v=1   start scalers auto update
   switch $scalego {
      0  {
         if {$scalerafterid != ""} then {
            after cancel $scalerafterid
            set scalerafterid ""
         }
      }
      1  {
         if {$scalerafterid == ""} then {
            set scalerafterid [after [expr $scaleperiod * 1000] do-scalers-event]
         }
      }
   }
}

proc do-scalers-event {} {
   global scalerafterid
   set scalerafterid ""
   click-updteallscalers
   click-scalers-go 1
}

proc click arg {
   global debug userselection allchans
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
#    insert-debug "click with argument \{$arg\}"
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}

      SCALEPERIOD {click-scalers-period $v}
      SCALEGO     {click-scalers-go $v}
      
      CHANNEL     {click-channel $v}
      ALLCHANS    {click-whichchans $v}

      PARAM       {click-param $v}
      MUX-*       {click-inspection $w [lindex $arg 4]}

      default   {
          if {$allchans < 0} then {set userselection 1}
             click-on $w $v
             set userselection 0
      }
   }
}

set electronicsframe "[self frame-name].electronics"
set scalersframe     "[self frame-name].scalers"
set scalersvisible 0

proc make-frame1 {} {
  global env chanlist 
  global analogueinspmenu digitalinspmenu voltageinsptable stepmenu stepmode

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel P1 :layout T :padx 10 :pady 5
     :layout H; :row-gap 10; :col-gap 10
      :choice-stack CHANNEL :label "Current Detector:" :strings $chanlist :rows 6
      :choice ALLCHANS :label "Act on Detectors?" :strings [list Current All Select] :value 0

   :panel P2 :layout T  :padx 10 :pady 10
     :layout H; :row-gap 5; :col-gap 10
      :message P2M :label "Read Out Chip (ROCI)" :bold T
      :next-row T
      :message M1  :label "Threshold"      :valuex 28c
      :message M2  :label "Sliding Scale"  :valuex 20c
      :message M3  :label "Read Out"
      :message M4  :label "Address"

      :next-row T
      :message ADC1M     :label "SYREP" :w 8
      :slider ADC1THRESH :label " " :min 0 :max 255 
      :checkbox ADC1SSE  :label " "
      :checkbox ADC1ROE  :label " " :valuex 7c
      :text ADC1ADDR     :label " " :w 6   :read-only T  :valuex 4c

      :next-row T
      :message ADC2M     :label "Entire" :w 8
      :slider ADC2THRESH :label " " :min 0 :max 255 
      :checkbox ADC2SSE  :label " "
      :checkbox ADC2ROE  :label " " :valuex 7c
      :text ADC2ADDR     :label " " :w 6   :read-only T  :valuex 4c

      :next-row T
      :message ADC3M     :label "Slow" :w 8
      :slider ADC3THRESH :label " " :min 0 :max 255 
      :checkbox ADC3SSE  :label " "
      :checkbox ADC3ROE  :label " " :valuex 7c
      :text ADC3ADDR     :label " " :w 6   :read-only T  :valuex 4c

      :next-row T
      :message ADC4M     :label "Time" :w 8
      :slider ADC4THRESH :label " " :min 0 :max 255 
      :checkbox ADC4SSE  :label " "
      :checkbox ADC4ROE  :label " " :valuex 7c
      :text ADC4ADDR     :label " " :w 6   :read-only T  :valuex 4c

   :panel P3 :layout T :padx 10 :pady 10
     :layout H; :row-gap 5; :col-gap 10
      :message P3M :label "Digital to Analogue Converters (DAC) (per channel)" :bold T
      :next-row T
      :slider CFDTHRESH  :label "CFD Threshold" :min 0 :max 255    :valuex 15c
      :slider CFDDELAY   :label "CFD Delay"    :min 0 :max 255    :valuex 15c
      :next-row T
      :slider CFDWIDTH   :label "CFD Width"    :min 0 :max 255    :valuex 15c
      :slider GATEWIDTH  :label "Gate Width Entire"   :min 0 :max 255    :valuex 15c
      :next-row T 
      :slider GATEDELAY  :label "Gate Delay Slow"     :min 0 :max 255    :valuex 15c
      :slider FTSAMPLE   :label "FT Sample"           :min 0 :max 255    :valuex 15c
      :next-row T
      :slider CHANTRIG   :label "Channel Trigger"  :min 0 :max 255    :valuex 15c

   :panel P4 :layout T :padx 10 :pady 10
     :layout H; :row-gap 5; :col-gap 10
      :message P3M :label "Digital to Analogue Converters (DAC) (common)" :bold T
      :next-row T
      :slider SYREPTHRESH :label "SYREP Threshold"    :min 0 :max 255    :valuex 15c
      :slider E&STHRESH   :label "E & S Threshold"    :min 0 :max 255    :valuex 15c
      :next-row T
      :slider TRIGDELAY   :label "Trig Delay"         :min 0 :max 255    :valuex 15c
      :slider TRIGWIDTH   :label "Trig Width"         :min 0 :max 255    :valuex 15c
      :next-row T
      :slider VALSAMPLE   :label "Validation Sample"  :min 0 :max 255    :valuex 15c
      :slider TRIGW3      :label "Trig Card W3"       :min 0 :max 255    :valuex 15c

   :panel P5 :layout T :padx 10 :pady 10
      :layout H; :col-gap 10; :row-gap 10
      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 22 :menu $analogueinspmenu
      :message MUX-AI1-USE   :label ""
      :next-row T
      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 22 :menu $analogueinspmenu
      :message MUX-AI2-USE   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI2-USE   :label ""
      :next-row T
      :menubutton MUX-VI  :label "Voltage Inspection:"    :w 22 :menu $voltageinsptable
      :message MUX-VI-USE   :label ""

   :panel P6 :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 5; :row-gap 10

      :button REDISPLAY
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button SCALERS                           :command click-scalers
      :button SCALERCLR   :label "Clear All Scalers"    :command click-clearcurrentscalers
      :button HELP  
   
 :show T

}

proc make-frame2 {} {}

proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame "$electronicsframe" :label "Demon Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
     :layout H; :row-gap 5
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 24c
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
    :next-row T
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 24c
      :text SERIALNUM     :label "Serial Number:" :w 6 :read-only T      :valuex 16c
    :next-row T
      :text MODLEVEL      :label "Modification Level:" :w 6 :read-only T :valuex 24c
      :text OFFSET        :label "Offset Register:" :w 6 :read-only T    :valuex 16c
    :next-row T
      :checkbox FIFOMTY :label "Fifo not empty:"  :valuex 24c  :read-only T
    :next-row T
      :text TIMEW3    :label "Timeout W3"  :w 6 :valuex 24c
      :text TIME256   :label "Timeout 256" :w 6 :valuex 16c

    :next-row T
      :slider SS  :label "Sliding Scale" :min 0 :max 255  :read-only T   :valuex 24c
      :checkbox SSE :label "Enable"

    :next-row T
      :choice VALMODE :label "Validation Mode" :strings [list Demon Eurogam] :valuex 24c

    :next-row T
      :choice FTMODE :label "FT Mode" :strings [list Internal External] :valuex 24c

    :next-row T
      :choice LEMO   :label "A1 => LEMO (channel)" :strings [list OFF ON] :valuex 24c

    :next-row T
      :choice CFDE   :label "CFD (channel)" :strings [list OFF ON] :valuex 24c

    :next-row T
      :choice S2E    :label "Sumbus_2 (channel)" :strings [list OFF ON] :valuex 24c

    :next-row T
      :choice SB1C   :label "Sumbus_1 => SUMBUS" :strings [list OFF ON] :valuex 24c

    :next-row T
      :choice SB1C1  :label "Sumbus_1 => SUMBUS 1" :strings [list OFF ON] :valuex 24c

    :next-row T
      :choice SB2C1  :label "Sumbus_2 => SUMBUS 1" :strings [list OFF ON] :valuex 24c

    :next-row T
      :choice SB2C2  :label "Sumbus_2 => SUMBUS 2" :strings [list OFF ON] :valuex 24c


   
  :show T
 set electronicsvisible 1
}

proc make-chanSELframe {} {
  global chansel chanlist

   :frame CHANSEL-FRAME :label "Demon Detector Selection"  :show-footer F :resize F :transient T
   :panel CHANSEL-PANEL :layout T
   :choice CHANSEL :exclusive F :strings $chanlist :value $chansel
   :show T
}  

set scaleperiodchoice [list 5 10 20 50 100 200 500 1000]
set scaleperiod 10
set scalego 0
set scalerafterid ""

proc make-scalersframe {} {
   global env chanlist scalersframe scalersvisible
   global scaleperiodchoice  scalescalechoice scalescale scaleperiod scalego

  :frame "$scalersframe" :label "Demon Scalers Display" :resize F :show-footer T  \
     :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel SCALEP1 :layout T :padx 10 :pady 10
     :layout H; :col-gap 25

     :choice SCALEGO    :label "Display Auto Update"  :strings [list Off On]  :value $scalego
     :choice-stack SCALEPERIOD  :label "Update period (secs)" :strings $scaleperiodchoice \
          :value [lsearch $scaleperiodchoice $scaleperiod]

   :panel SCALEPS  :layout T :padx 10 :pady 10
     :layout H; :row-gap 0; :col-gap 0

    :message M1 :label "Prompt Signal Scalers" :bold T
    :next-row T

   set cards [expr ([llength $chanlist] + 5) / 6]
   set chanindex 0
   for {set c 0} {$c < $cards} {incr c} {

      if {$c != 0} then {:vskip 10}

      for {set i 0} {$i < 6} {incr i} {

         set chan [lindex $chanlist [expr $chanindex + $i]]
         if {$chan == ""} then {break}
         :text SCALEP$chan :label "$chan"  :valuex 8c  :w 8 :deaf T  
      }
      incr chanindex 6
      :next-row T
   }

    :message M2 :label "ADC Scalers" :bold T
    :next-row T

   set cards [expr ([llength $chanlist] + 5) / 6]
   set chanindex 0
   for {set c 0} {$c < $cards} {incr c} {

      if {$c != 0} then {:vskip 10}

      for {set i 0} {$i < 6} {incr i} {

         set chan [lindex $chanlist [expr $chanindex + $i]]
         if {$chan == ""} then {break}
         :text SCALEA$chan :label "$chan"  :valuex 8c  :w 8 :deaf T 
      }
      incr chanindex 6
      :next-row T
   }

   :panel SCALEB :layout B :padx 10 :pady 10
      :layout H; :col-gap 10

     :button SCALEREDISPLAY :label "Redisplay"  :command click-updteallscalers
     :hskip 100
     :button SCALECLR   :label "Clear Scalers"  :command click-clearallscalers
     :hskip 200
     :button SCALEHELP :label Help

   :show T

   set scalersvisible 1
}


