# dppc.tcl    -  Just handles downloading of DPPC programs

loadsource vxicontrol.common

set dppcBase [file join $env(MIDASAPPLBASE) dppc]
set dppcfile ""

set dppcframe [self frame-name].dppc
set dppcvisible 0

proc start-DPPC {} {
#  display DPPC sub frame
   global cardtype chanlist chanindex
   global dppcvisible dppcframe
   if {$dppcvisible==0} then {make-DPPC} else {open-frame $dppcframe}
   set dppcfile [read-vxi-register $cardtype[lindex $chanlist $chanindex].A.PARIL.DPPC.Program]
   :modify DPPCPROG :value $dppcfile
   click-redisplay
} 


#####################
proc click-dppcchoose args {
    global env dppcBase dppcfile

#    Here use the built in browser function
#    This uses the canvas function and requires a pale coloured background

    option add *Canvas.background  #c0c020
    set types {
      {{DPPC Program Files}  {.dxe}   }
      {{All Files}          *        }
    }
    set dppcfile [tk_getOpenFile -parent [self frame-name] -title "DPPC Program Selection"  \
       -initialdir $dppcBase -filetypes $types]
    option add *Canvas.background  $env(tkcanvasbackground)
    if {$dppcfile == ""} then {return}

   :modify DPPCPROG :value $dppcfile 

}
#####################
proc click-dppcdownload args {
   global dppcfile cardtype chanlist chanindex

   set CurrentVXIModule $cardtype[lindex $chanlist $chanindex]

    set-footer "Downloading DPPC program"
    modify-vxi-register $CurrentVXIModule.A.PARIL.DPPC.Program "-m 1"
    write-vxi-register $CurrentVXIModule.A.PARIL.DPPC.Program [Midas-Map-Filename $dppcfile]
    modify-vxi-register $CurrentVXIModule.A.PARIL.DPPC.Program "-m 0"
    insert-log "Downloaded DPPC program file $dppcfile"
    clear-footer
}

#####################
proc click-dppcldr args {
    global dppcfile cardtype chanlist chanindex

   set CurrentVXIModule $cardtype[lindex $chanlist $chanindex]

    set z [midas-confirmation "Loading $dppcfile into DPPCs in card $CurrentVXIModule\n"]
    if {$z == 0} then {return}

    set-footer "Resetting GIR"
    write-vxi-register $CurrentVXIModule.ResetGIR 1
    write-vxi-register $CurrentVXIModule.ResetGIR 0
    set-footer "Loading DPPC program"
    modify-vxi-registers $CurrentVXIModule.\[A-D\].PARIL.DPPC.Program "-m 2"
    write-vxi-registers $CurrentVXIModule.\[A-D\].PARIL.DPPC.Program [Midas-Map-Filename $dppcfile]
    modify-vxi-registers $CurrentVXIModule.\[A-D\].PARIL.DPPC.Program "-m 0"
    insert-log "Loaded DPPCs with $dppcfile"
    clear-footer
}


proc make-DPPC {} {
  global env dppcvisible dppcframe dppcfile

  :frame $dppcframe :label "HRGe8x DPPC" :show-footer T :resize F :transient T 

   :panel P1 :layout T :padx 10
     :layout H; :col-gap 5;  :row-gap 5

      :text     CHANNEL    :label "Current Channel"  :deaf T :valuex 20c :w 2
      :next-row T
      :text DPPCPROG     :label "DPPC program" :value $dppcfile :w 40
      :next-row T
      :button DPPCLDR      :label "Load program into DPPC" :command click-dppcldr
      :next-row T
      :button DPPCCHOOSE   :label "Select DPPC program"   :command click-dppcchoose
      :button DPPCDOWNLOAD :label "Download DPPC program" :command click-dppcdownload

  :show T
  set dppcvisible 1
}
