#    part of the Diagnostic task for testing GIR DSP functions
#    this is exopz.tcl

#    the global variable dsp is dependent on the GIR version fitted 
#    it is set when the slot is selected


global chansel cardtype card segindex seg
set cardtype $card

set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}

  :frame [self frame-name].exopz :label "PZ Adjustment" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

    :panel EXOPZP3 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 10
     :text     MODULE    :label "Current MODULE:" :deaf T :w 4 :bold T :value $moduleindex
     :text     CARD    :label "Current CARD:" :deaf T :w 8 :bold T :value $card
     :next-row T
     :slider EXOPZDAC     :label "Offset (mV):" :min -496 :max 496 :valuex 14c :value 0
     :next-row T
     :slider EXOPZPOTAR     :label "Rgain (Ohm):" :min 50 :max 10011  :valuex 14c :value 10011
     :next-row T
     :button EXOPZMAN  :label MAN :w 12
     :button EXOPZAUTO  :label "AUTO" :w 12 
     :next-row T
     :button EXOPZSTOP  :label STOP :w 12
     :button EXOPZRESET  :label RESET :w 12
#      :button REDISPLAY


   :show T
click-redisplay



 ###################################
proc click-exopzdac {p} {
   global $p CurrentVXIModule

set data1 [expr abs(2.048*(($p/0.5)+1000))]
set val [expr [truncate $data1]]
write-vxi-register $CurrentVXIModule.DSP.DAC.Adj $val
}

 ###################################
proc click-exopzpotar {p} {
   global $p CurrentVXIModule
set data1 [expr (($p-50)/39.45)+0.5]
set val [expr [truncate $data1]]

log "data1=$data1, val=$val"
write-vxi-register $CurrentVXIModule.DSP.POT.Adj $val
}
 ###################################
proc click-exopzauto {args} {
   global CurrentVXIModule segsel cardtype card

switch $segsel {
		0 {set seg A}
		1 {set seg B}
		2 {set seg C}
		3 {set seg D}
		}

write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0

#reset
   write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
	after 500
#start Spectre
#log "seg = $seg"
set dacpz0 0
write-vxi-register $CurrentVXIModule.$seg.PoleZero.Thresh $dacpz0
taskDelay 50
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0x1
taskDelay 150
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
set deltapz0 [read-vxi-register $CurrentVXIModule.GIR.DSP.DeltaPZ]

set dacpz128 128
write-vxi-register $CurrentVXIModule.$seg.PoleZero.Thresh $dacpz128
taskDelay 50
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0x1
taskDelay 150
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
set deltapz128 [read-vxi-register $CurrentVXIModule.GIR.DSP.DeltaPZ]

set dacpz255 255
write-vxi-register $CurrentVXIModule.$seg.PoleZero.Thresh $dacpz255
taskDelay 50
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0x1
taskDelay 150
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
set deltapz255 [read-vxi-register $CurrentVXIModule.GIR.DSP.DeltaPZ]

set alpha1 [expr ($deltapz128-$deltapz0)/($dacpz128-$dacpz0)]
set beta1 [expr (-$deltapz0/$alpha1)]


set alpha2 [expr ($deltapz255-$deltapz128)/($dacpz255-$dacpz128)]
set beta2 [expr (-$deltapz128/$alpha2)+$dacpz128]

set beta [expr abs($beta1+$beta2)/2]
log "deltapz0 = $deltapz0, dacpz0 = $dacpz0"
log "deltapz128 = $deltapz128, dacpz128 = $dacpz128"
log "deltapz255 = $deltapz255, dacpz255 = $dacpz255"
log "beta1 = $beta1, beta2 = $beta2, beta=$beta"


write-vxi-register $CurrentVXIModule.$seg.PoleZero.Thresh $beta
taskDelay 50
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0x1
taskDelay 150
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
set deltapz [read-vxi-register $CurrentVXIModule.GIR.DSP.DeltaPZ]
log " dacpz=$beta, deltapz=$deltapz"				
}

 ###################################
proc click-exopzman {args} {
   global CurrentVXIModule
write-vxi-register $CurrentVXIModule.GIR.DSP.Control 0

#reset
   write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
	after 500
#start Spectre

write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0x1
taskDelay 150
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
set deltapz [read-vxi-register $CurrentVXIModule.GIR.DSP.DeltaPZ]
log " deltapz=$deltapz"
}
 ###################################
proc click-exopzstop {args} {
   global CurrentVXIModule

#stop Spectre
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
}

 ###################################
proc click-exopzreset {args} {
   global CurrentVXIModule

#stop Spectre
write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
#reset
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 0x1
}


###################################
proc click-exopzinfo args {
    global TclBase
   midas-show-file  "$TclBase/info/explexopz"
}


###################################
proc click-exopzfinish args {
   global CurrentVXIModule
    write-vxi-register $CurrentVXIModule.GIR.DSP.PZ 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 0x1
    click-quit [self frame-name].exopz
}
