#    part of the Diagnostic task for testing GIR DSP functions
#    this is spectre.tcl

#    the global variable dsp is dependent on the GIR version fitted
#   it is set when the slot is selected
#    also the variable sar is used which should be set when the board type is selected
# this version is adapted to a germanium cluster card

  set maxadcchan 63
  set adcchannel 0
set adcdatabits 13
global adcdatabits

  set girspectreexists 1

  :frame [self frame-name].spectre :label "Spectra Control" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F 
      


    :panel SPECTREP1 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 5
      :text     MODULE    :label "Current MODULE:"  :deaf T :valuex 30c :w 4 :bold T :value $moduleindex
     :galley SPECTRERESULTS :rows 8 :cols 40 :deaf T


   :panel SPECTREP2 :layout T :padx 5 :pady 10
     :layout H; :col-gap 10; :row-gap 5
     :row-gap 0

     :message SPECTREMESS  :label "ADC channel: Spectrum: "
     :next-row T
     :number SPECTREADCCHAN  :w 2 :label "" \
			:min 0 :max $maxadcchan :value $adcchannel

     :button SPECTRESHOW  :label "Show"
     :button SPECTREZERO  :label "Zero"
     :button SPECTRECREATE  :label "Create"



    :panel SPECTREP3 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 10

     :row-gap 0
     :message SPECTRETPEAKP2  :label "ADC channel:      total:  "
     :galley SPECTRETPEAKINFO :rows 10 :cols 45 :deaf T
     :row-gap 5


    :panel SPECTREPA1 :layout T :padx 10 :pady 5
     :layout H; :col-gap 5; :row-gap 5
     :button SPECTREUPDATE :label Update
     :button SPECTRERESET  :label "Reset" :w 4
     :button INFO	:label "Info"   :w 4 
     :button SPECTREQUIT :label "Quit"   :w 4

position-frame 200 0 [self frame-name].spectre


 

#####################
proc click-info {args} {
   global TclBase
   midas-show-file  "$TclBase/info/explspectre"
			}

#####################
proc click-spectrequit {args} {
   global girspectreexists

  set girspectreexists 0

   click-quit [self frame-name].spectre
}



#####################
proc click-spectrereset {args} {
    global CurrentVXIModule girversion

    if {![midas-confirmation "Are you sure you wish to Reset?"]} then {return}
    :modify SPECTRETPEAKINFO  :append F

write-vxi-register $CurrentVXIModule.GIR.DSP.ResetMemExt 1
    refresh-results

}

#####################
proc click-spectreupdate {args} {
	global CurrentVXIModule card girversion

   set daqstate [read-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP]

# bit 8 = DSPEN, inversion ds saphir.defn.tcl a corriger

    write-vxi-register $CurrentVXIModule.GIR.ROCR.DSPEN 0
    write-vxi-register $CurrentVXIModule.GIR.ROCR.MODEDMA 0
    write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP 0

   write-vxi-register $CurrentVXIModule.GIR.DSP.DSPtotcount 1
	refresh-results
 	do_totpeak$card

   write-vxi-register $CurrentVXIModule.GIR.DSP.StartDSP $daqstate
   write-vxi-register $CurrentVXIModule.GIR.ROCR.MODEDMA 1
   write-vxi-register $CurrentVXIModule.GIR.ROCR.DSPEN 1

}

#####################
proc refresh-results {args} {
   global girversion CurrentVXIModule
    log " girversion = $girversion"

   if {$girversion == 3} then {    write-vxi-register $CurrentVXIModule.GIR.DSP.Mirror 0x1}
after 150
ReadEvent
}


#####################
proc click-spectreadcchan {v} {
    global adcchannel
    set adcchannel $v
}



#####################
proc click-spectreshow {args} {
   global adcchannel server CurrentVXIModule slot

   set f GIR$slot.c$adcchannel
   maybe-create-spectrum $f
   inform sd show /$server/$f
   set-footer [self frame-name].spectre "Displaying Spectrum /$server/$f"
}

#####################
proc click-spectrezero {args} {
   global adcchannel server offset34 girversion CurrentVXIModule slot card

   set f GIR$slot.c$adcchannel
   maybe-create-spectrum $f
   zero-spectrum $f
   set-footer [self frame-name].spectre "Zeroing Spectrum /$server/$f"
    write-vxi-register $CurrentVXIModule.GIR.DSP.DSPtotcount 1
#	    if {$girversion == 3} then {write-vxi-register $CurrentVXIModule.GIR.DSP.Mirror 0x1}
	    do_totpeak$card

}

#####################
proc click-spectrecreate {args} {
   global adcchannel server CurrentVXIModule slot

   set f GIR$slot.c$adcchannel
   maybe-create-spectrum $f
   set-footer [self frame-name].spectre "Created Spectrum /$server/$f"
}
	

#    procedures ReadEvent and ReadTotpeak  moved from  gesdsp.c


#####################
proc ReadEvent {} {
   global girversion CurrentVXIModule

   array set nomevent {0 "Item0" 1 "DSP Events Counter" 2  "Last event data number" 3 "Item Error" \
       4  "Data number Error" 5 "GIR Event Counter"}
 
   :modify SPECTRERESULTS :append F
	set length 5
set i 0

switch $girversion {
	4 {
      	set baseevent [expr (0x26001*4)]
	set spectrereg $CurrentVXIModule.GIR.DSP.IntMem

	}
	3 {
	set baseevent [expr (0x7ffd1*4)]
	set spectrereg $CurrentVXIModule.GIR.DSP.ExtMem
	}
		}

	modify-vxi-register $spectrereg "-o $baseevent -l $length"	
      	set DataRAM [read-vxi-register $spectrereg]
       foreach word $DataRAM {
:modify SPECTRERESULTS :strings "[format "%24s   :   0x%x" $nomevent($i) $word]\n"
incr i}
set compgir [read-vxi-register $CurrentVXIModule.GIR.EvNum.Count]
:modify SPECTRERESULTS :strings "[format "%24s   :   0x%x" $nomevent(5) $word]\n"

}

#####################
proc do_totpeakClusterGe {} {
   array set segment {0 A 1 B 2 C 3 D 4 E 5 F 6 G}

  global girversion CurrentVXIModule

   :modify SPECTRETPEAKINFO :append F

   set-footer [self frame-name].spectre "Reading data from $CurrentVXIModule"


   for {set i 0} {$i<=6} {incr i} {

	set adc0 [expr ($i*6)]
	set adc [expr ($i*6)]
	set length 6



switch $girversion {
	4 {
      	set basetpeak1 [expr (0x26180*4) + ($adc*4)]
      	set basetpeak2 [expr (0x261AA*4)]
	set spectrereg $CurrentVXIModule.GIR.DSP.IntMem
	}
	3 {
	set basetpeak1 [expr (0x7ff00*4) + ($adc*4)]
	set basetpeak2 [expr (0x7ff2A*4)]
	set spectrereg $CurrentVXIModule.GIR.DSP.ExtMem
	}
		}

      	modify-vxi-register $spectrereg "-o $basetpeak1 -l $length"	
      	set DataRAM [read-vxi-register $spectrereg]

       foreach word $DataRAM {
	if {$word != 0} then {
set typevoie [expr ($adc-$adc0)]

switch $typevoie {
0 { set typch "20 Mev"
    set typileup "q0"}
1 { set typch "20 Mev"
    set typileup "q12"}
2 { set typch "4 Mev"
    set typileup "q0"}
3 { set typch "4 Mev"
    set typileup "q12"}
4 { set typch "TAC"
    set typileup "q0"}
5 { set typch "TAC"
    set typileup "q12"}

		}

:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Ge%s.%s.%s : %d : 0x%x" $adc $segment($i) $typch $typileup $word $word]\n"}
	incr adc
     			 }

							}
#echelles

	set adc0 42
	set adc 42
	set length 4

	modify-vxi-register $spectrereg "-o $basetpeak2 -l $length"	
      	set DataRAM [read-vxi-register $spectrereg]
       foreach word $DataRAM {

	if {$word != 0} then {
				set typevoie [expr ($adc-$adc0)]
				switch $typevoie {
						0 { set typch "q0"}
						1 { set typch "q1"}
						2 { set typch "q2"}
						3 { set typch "q3"}
						}


:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Pattern.%s : %d : 0x%x" $adc $typch $word $word]\n"}
	incr adc

     			 }
     			 
   clear-footer [self frame-name].spectre

}



##########################################
proc do_totpeakClusterBGO {} {
   array set segment {0 Sum 1 Pattern 2 A 3 B 4 C 5 D 6 E 7 F 8 G 9 H 10 I 11 J 12 K 13 L 14 M 15 N 16 O 17 P 18 Q 19 R}

  global girversion CurrentVXIModule

   :modify SPECTRETPEAKINFO :append F

   set-footer [self frame-name].spectre "Reading data from $CurrentVXIModule"


   for {set i 0} {$i<=19} {incr i} {

	set adc0 [expr ($i*2)]
	set adc [expr ($i*2)]
	set length 2



switch $girversion {
	4 {
      	set basetpeak1 [expr (0x26180*4) + ($adc*4)]
      	set basetpeak2 [expr (0x261AA*4)]
	set spectrereg $CurrentVXIModule.GIR.DSP.IntMem
	}
	3 {
	set basetpeak1 [expr (0x7ff00*4) + ($adc*4)]
	set basetpeak2 [expr (0x7ff2A*4)]
	set spectrereg $CurrentVXIModule.GIR.DSP.ExtMem

	}
		}

      	modify-vxi-register $spectrereg "-o $basetpeak1 -l $length"	
      	set DataRAM [read-vxi-register $spectrereg]
       foreach word $DataRAM {
	if {$word != 0} then {
set typevoie [expr ($adc-$adc0)]

switch $typevoie {
0 { set typch "Energy"}
1 { set typch "TAC"}
		}

:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Bgo%s.%s : %d : 0x%x" $adc $segment($i) $typch $word $word]\n"}
	incr adc
     			 }

							}

#Echelles 
	set adc 42
	set length 1

	modify-vxi-register $spectrereg "-o $basetpeak2 -l $length"	
      	set DataRAM [read-vxi-register $spectrereg]

       foreach word $DataRAM {

	if {$word != 0} then {

:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Pattern : %d : 0x%x" $adc $word $word]\n"}

     			 }


   clear-footer [self frame-name].spectre

}
#####################
proc do_totpeakSaphir {} {
  global CurrentVXIModule

   :modify SPECTRETPEAKINFO :append F

#   set-footer [self frame-name].spectre "Reading data from $CurrentVXIModule"
#Spectres

   for {set i 0} {$i<=15} {incr i} {
	set length 2
	set adc0 [expr ($i*2)]
	set adc [expr ($i*2)]



      	set basetpeak [expr (0x26180*4) + ($adc*4)]
	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
      	set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

       foreach word $DataRAM {
	if {$word != 0} then {
				set typevoie [expr ($adc-$adc0)]
				switch $typevoie {
						0 { set typch "Energy"}
						1 { set typch "Timing"}
						}

:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.%s%s : %d : 0x%x" $adc $typch $i $word $word]\n"}
	incr adc
     			 }

				}


#Echelles 
	set adc0 32
      	set basetpeak [expr (0x261A0*4)]
	set length 4

	modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o $basetpeak -l $length"	
      	set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]

       foreach word $DataRAM {

	if {$word != 0} then {
				set typevoie [expr ($adc-$adc0)]
				switch $typevoie {
						0 { set typch "q0"}
						1 { set typch "q1"}
						2 { set typch "q2"}
						3 { set typch "q3"}
						}

:modify SPECTRETPEAKINFO :strings "[format " %02d : $CurrentVXIModule.Pattern.%s : %d : 0x%x" $adc $typch $word $word]\n"}
     			 }


#   clear-footer [self frame-name].spectre

}

#
# Spectrum Server routines
#

#####################
proc get-spectrum-list {slot} {
   global server maxadcchan
   set splist {}
   for {set i 0} {$i<=$maxadcchan} {incr i} {
      lappend splist GIR$slot.c$i
   }
   return $splist
}

#####################
proc execute-spectrum {n action} {
  global server adcdatabits
  global debug

#insert-debug "$action $n"

#insert-debug "$server"
  switch $action {
     maybe-create {
        if {$debug} then {insert-debug "maybe create spectrum, checking :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' ?spec)"} m]



# Check for "Pathname Invalid" and create if it doesn't exist
        if {$z!=0 && $m==0x30004} then {
           set range [expr int (pow(2, $adcdatabits))]
           if {$debug} then {insert-debug "maybe create spectrum, creating :range $range :name '$n' "}
           set z [catch {eg "(spectrum :path '/$server' :range $range :name '$n' !new)" } m]
        }
     }
     create {
        set range [expr int (pow(2, $adcdatabits))]
        if {$debug} then {insert-debug "create spectrum :range $range :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :range $range :name '$n' !new)" } m]
     }
     delete {
        if {$debug} then {insert-debug "delete spectrum  :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' !delete)"} m]
# Allow "Pathname Invalid" so that further spectra can be deleted
        if {$z!=0 && $m==0x30004} then {set z 0}
     }
     clear {
        if {$debug} then {insert-debug "clear spectrum  :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' !zero)"} m]
     }
  }
  if {$z!=0} then {
    display-eg-error-report self $m "Attempting to " $action "spectrum" $n
    clear-footer
    error $m
  }
}

proc maybe-create-spectrum n {execute-spectrum $n maybe-create}

proc create-spectrum n {execute-spectrum $n create}

proc delete-spectrum n {execute-spectrum $n delete}

proc zero-spectrum n {execute-spectrum $n clear}

#####################
proc create-spectra {} {
   global server slot
   set c 0
   foreach spectrum [get-spectrum-list $slot] {
      set-footer "creating /$server/$spectrum..."
      create-spectrum $spectrum
      incr c
   }
   set-footer "total of $c spectra successfully created"
}

#####################
proc delete-spectra {} {
   global server slot
   set c 0
   foreach spectrum [get-spectrum-list $slot] {
      set-footer "deleting /$server/$spectrum..."
      delete-spectrum $spectrum
      incr c
   }
   set-footer "total of $c spectra successfully deleted"
}

#####################
proc zero-spectra {} {
   global server slot
   set c 0
   foreach spectrum [get-spectrum-list $slot] {
      set-footer "zeroing /$server/$spectrum..."
      zero-spectrum $spectrum
      incr c
   }
   set-footer "total of $c spectra successfully zeroed"
}

# at a later stage this could be more intelligent
# it could check spectrum existence and only create if necessary
# maybe zeroing otherwise
#

#####################
proc setup-spectrum n {
  delete-spectrum $n
  create-spectrum $n
}

#####################
proc setup-spectra {} {
  delete-spectra
  create-spectra
}
