#    part of the Diagnostic task for testing GIR DSP functions
#    this is visumemint.tcl
global moduleindex card

  set visumemintaddr  0x0
  set visumemintwords 0x10

  set CHMEMINT 0x30000


  :frame [self frame-name].visumemint :label "Display Internal Memory" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

    :panel VISUMEMINTP1 :layout T :padx 10 :pady 10
     :layout H; :col-gap 10; :row-gap 10
     :text     MODULE    :label "Current MODULE:" :deaf T :w 4 :bold T :value $moduleindex
     :text     CARD    :label "Current CARD:" :deaf T :w 8 :bold T :value $card


    :panel VISUMEMINTP2 :layout T :padx 10 :pady 10
     :layout V; :col-gap 10; :row-gap 10

     :text VISUMEMINTADDR    :label "Address Offset"  :value $visumemintaddr   :valuex 15c  :w 12
     :text VISUMEMINTWORDS   :label "Words to read"   :value $visumemintwords  :valuex 15c  :w 12
     :message VISUMEMINTM1 :label "Memory Contents" :bold T
     :row-gap 0
     :message VISUMEMINTM2  :label "Address Offset: DSP Address: DATA"
     :galley VISUMEMINTINFO :rows 18 :cols 30 :deaf T
     :button VISUMEMINTREAD :label "Read Memory" :command do_visumemintdisplay
     :layout H; :col-gap 10
     :button VISUMEMINTCLR  :label "Clear Window" :command ":modify VISUMEMINTINFO :append F"

   :show T


###################################
proc click-visumemintaddr {v} {
   global  visumemintaddr visumemintwords CHMEMINT
   if {[scan-int $v] == $v && $v >= 0 && $v < 0x7ffff} then {
      if {[expr $v + $visumemintwords] <= $CHMEMINT} then {set visumemintaddr $v}
   }
   :modify VISUMEMINTADDR :value [format "0x%05x" $visumemintaddr]
}

###################################
proc click-visumemintwords {v} {
   global visumemintaddr visumemintwords CHMEMINT
   if {[scan-int $v] == $v && $v >= 0 && $v <= 0x400} then {
      if {[expr $visumemintaddr + $v] <= $CHMEMINT} then {set visumemintwords $v}
   }
   :modify VISUMEMINTWORDS :value [format "0x%02x" $visumemintwords]
   do_visumemintdisplay
}

###################################
proc do_visumemintdisplay {} {
   global visumemintp1exists
   global CurrentVXIModule
   global  visumemintaddr visumemintwords  moduleindex card

   :modify VISUMEMINTINFO :append F

   :modify MODULE :value $moduleindex
   :modify CARD :value $card

   set-footer [self frame-name].visumemint "Reading data from $CurrentVXIModule"
   set blocks [expr ($visumemintwords + 63) / 64]

   set words $visumemintwords

   for {set block 0} {$block < $blocks} {incr block} {
#    do a block read for 64 words or $words whichever is the smaller
      set offset [expr $block * 64 + $visumemintaddr]

      set vmeaddress [expr $offset * 4]
      if {$words < 64} then {set length $words} else {set length 64}
      modify-vxi-register $CurrentVXIModule.GIR.DSP.IntMem "-o [expr $offset * 4] -l $length"
      set DataRAM [read-vxi-register $CurrentVXIModule.GIR.DSP.IntMem]
      foreach word $DataRAM {
         :modify VISUMEMINTINFO  :strings "[format "0x%05x" $vmeaddress] [format "0x%02x" $offset]: $word\n"
         incr offset
         incr vmeaddress 4
      }
      set words [expr $words - 64]
   }
   clear-footer [self frame-name].visumemint

   click-visumemintaddr [expr $visumemintaddr + $visumemintwords]
}
