#    hist task code overlay for detector type "triggermk2"


set lowchannel  -1
set highchannel -1
set maxchannel  -1

set qualifier 1

set qnames   {q0 q1 q2 q3}
set qualnames {0 1 2 3}

set trignames  {Sumbus1 Sumbus2 Sumbus3 Sumbus4 TAC Pattern EvNumLSB EvNumMSB}
set girnames   {GIR.EvNum}

set trig 0
set gir 0


proc make-overlaypanel {} {
   global trignames girnames qnames

    :layout H; :row-gap 10; :col-gap 20

      :message DET-M1   :label "Trigger MK2 detector overlay applied"
      :next-row T
      :choice DET-QUAL  :label "Qualifier" :valuex 10c :exclusive F :strings $qnames   :value 1
      :choice DET-TRIG  :label "Items"   :exclusive F :strings $trignames :value 0 :layout V :w 10
      :row-gap -150
      :next-row T
      :choice DET-GIR   :label "GIR"   :valuex 10c  :exclusive F :strings $girnames  :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-TRIG           {click-adc $v trig}
      DET-GIR            {click-adc $v gir}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global trig gir qualifier

   if {[llength $spectrumlist] > 0} then {
       :modify DET-TRIG  :value 0
       :modify DET-GIR   :value 0
       :modify DET-QUAL  :value 0
   } else {
       :modify DET-TRIG  :value $trig
       :modify DET-GIR   :value $gir
       :modify DET-QUAL  :value $qualifier
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global trignames trig girnames gir qualnames qualifier

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set qlist   [list-take $qualnames [bits-in $qualifier]]
        set list {}

# append trig spectrum names
        foreach q $qlist {
           foreach adc [list-take $trignames [bits-in $trig]] {lappend list TriggerMK2.$adc.q$q}
           foreach adc [list-take $girnames  [bits-in $gir]]  {lappend list TriggerMK2.$adc.q$q}
        }
        return $list
}

proc range-of n {

    set fields [split $n "."]
    switch -glob [second $fields]  {
        EvNum*    {return 0x10000}
        GIR       {return 0x10000}
        Pattern   {return 0x1000}
        TAC       {return 0x1000}
        default   {return 0x100}
    }
}
