# icare.tcl---Setup frame for Icare card

#     created 23/6/97  from Saphir card frame   VP

set debug 0
set started 0

set frame ICARE
set frametitle "Icare Card Setup"
set icontitle Icare

set chanlist {???}
set chanindex 0


set defaultchanlist {1 2 3 4 5 6 11 12 13 14 15 16}

set cardtype Icare
set VXIGlobal ""

set presetslist {}
#############################################################
# Change list into a table - CW



#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil
        nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil
        nil nil nil nil nil nil nil 0 nil}
       
set table(ENABLE) {enable int-widget->param param->int-widget "CFD.Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 0 "CFD Enable"}

set table(ADC1PZ) {adc1pz slider-widget->param param->int-widget "Adc1.PoleZero"
       unit-reg->param param->unit-reg mV :slider 0 9180 20 1 "Adc1 PoleZero (mV)"}
set table(ADC2PZ) {adc2pz slider-widget->param param->int-widget "Adc2.PoleZero"
       unit-reg->param param->unit-reg mV :slider 0 9180 20 1 "Adc2 PoleZero (mV)"}
set table(ADC3PZ) {adc3pz slider-widget->param param->int-widget "Adc3.PoleZero"
       unit-reg->param param->unit-reg mV :slider 0 9180 20 1 "Adc3 PoleZero (mV)"}

set table(ADC1GAIN) {adc1gain int-widget->param param->int-widget "Adc1.Gain"
       int-reg->param param->int-reg nil :choice High Low nil 0 "Adc1 Gain"}
set table(ADC2GAIN) {adc2gain int-widget->param param->int-widget "Adc2.Gain"
       int-reg->param param->int-reg nil :choice High Low nil 0 "Adc2 Gain"}
set table(ADC3GAIN) {adc3gain int-widget->param param->int-widget "Adc3.Gain"
       int-reg->param param->int-reg nil :choice High Low nil 0 "Adc3 Gain"}

set table(ADC0ADDR) {adc0addr widget->param param->hex-widget "Adc0.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Adc0 Address"}
set table(ADC1ADDR) {adc1addr widget->param param->hex-widget "Adc1.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Adc1 Address"}
set table(ADC2ADDR) {adc2addr widget->param param->hex-widget "Adc2.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Adc2 Address"}
set table(ADC3ADDR) {adc3addr widget->param param->hex-widget "Adc3.Addr"
       int-reg->param param->int-reg nil :text 6 nil nil 1 "Adc3 Address"}

set table(CFDTHRESH) {cfdthresh slider-widget->param param->int-widget "CFD.Thresh"
       unit-reg->param param->unit-reg mV :slider 0 511 1 1 "CFD Threshold (mV)"}
set table(CFDDELAY) {cfddelay slider-widget->param param->int-widget "CFD.Delay"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "CFD Delay (ns)"}
set table(CFDWIDTH) {cfdwidth slider-widget->param param->int-widget "CFD.Width"
       unit-reg->param param->unit-reg ns :slider 0 255 1 1 "CFD Width (ns)"}

set table(FTSAMPLE) { ftsample slider-widget->param param->int-widget "FTSample"
       unit-reg->param param->unit-reg ns :slider 0 1275 4 1 "Fast Trigger Sample (ns)"}
set table(ADCDELAY) { adcdelay slider-widget->param param->int-widget "ConvertDelay"
       unit-reg->param param->unit-reg ns :slider 0 5100 10 1 "ADCs Convert Delay (ns)"}
set table(LTWATCHDOG) { ltwatchdog slider-widget->param param->int-widget "LTWatchdog"
       unit-reg->param param->unit-reg ns :slider 0 20400 40 1 "Local Trig Watchdog (ns)"}

set table(FTDELAY) { ftdelay slider-widget->param param->int-widget "FT.Delay"
       unit-reg->param param->unit-reg ns :slider 0 1275 4 1 "Fast Trigger Delay (ns)"}
set table(FTWIDTH) { ftwidth slider-widget->param param->int-widget "FT.Width"
       unit-reg->param param->unit-reg ns :slider 0 1275 4 1 "Fast Trigger Width (ns)"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "ValSample"
       unit-reg->param param->unit-reg ns :slider 0 4080 16 1 "Validation Sample (ns)"}
set table(TRIGWATCHDOG) { trigwatchdog slider-widget->param param->int-widget "Watchdog"
       unit-reg->param param->unit-reg ns :slider 0 20400 40 1 "Trigger Watchdog (ns)"}

set table(FT) {ft int-widget->param param->int-widget "FTMode"
       int-reg->param param->int-reg nil :choice Internal External nil 0 "Fast Trigger Mode"}
set table(VAL) {val int-widget->param param->int-widget "ValMode"
       int-reg->param param->int-reg nil :choice RAZ Validation nil 0 "Validation Mode"}
set table(SUMBUS) {sumbus int-widget->param param->int-widget "SumBus"
       int-reg->param param->int-reg nil :choice Off On nil 0 "Sum Bus"}

set table(SCALING) {scaling int-widget->param param->int-widget "Shift.Go"
       int-reg->param param->int-reg nil :choice Off On nil 0 "Shift Off/On"}
       
set table(CFDSCALER) {cfdscaler int-widget->param param->int-widget "CFD.Scaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(ADCSCALER) {adcscaler int-widget->param param->int-widget "ADC.Scaler"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALERSCLR) {scalersclr int-widget->param param->int-widget "Scalers.Clear"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(SCALERSLOAD) {scalersload int-widget->param param->int-widget "Scalers.Load"
       int-reg->param param->int-reg nil nil nil nil nil 0 nil}


#    These are used by the electronics window
set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset"
       int-reg->param param->int-reg nil nil nil nil nil 1 nil}
set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Last Card"}

#    register selection for parameter save function

set registersavepatterns {
   CFD.Enable
   CFD.Thresh CFD.Delay CFD.Width  
   FTSample FT.Delay FT.Width
   ValSample ConvertDelay LTWatchdog Watchdog
   FTMode ValMode SumBus
   Adc1.PoleZero Adc2.PoleZero Adc3.PoleZero
   Adc1.Gain Adc2.Gain Adc3.Gain
   ASIC1.Pattern_Mask_Reg_Wt    ASIC2.Pattern_Mask_Reg_Wt
   ASIC1.Transfer_Format_Reg_Wt ASIC2.Transfer_Format_Reg_Wt
   ASIC1.Correction_Reg_Wt      ASIC2.Correction_Reg_Wt
   ASIC.Ident01 ASIC.Ident23
}


# inspection tables must be in same order as entries in the :choice-stacks
# this is achieved by using these tables when generating the choices
# index number returned maps directly to the signal number to be written to 
# the Signal Select register

set insp_table(MUX-AI1) {"Insp.A1" AI}
set insp_table(MUX-AI2) {"Insp.A2" AI}
set insp_table(MUX-DI1) {"Insp.D1" DI}
set insp_table(MUX-DI2) {"Insp.D2" DI}
set insp_table(MUX-VI)  {"Insp.V"  VI}

set insp_menu(MUX-AI1) analogueinsptable
set insp_menu(MUX-AI2) analogueinsptable
set insp_menu(MUX-DI1) digitalinsptable
set insp_menu(MUX-DI2) digitalinsptable
set insp_menu(MUX-VI)  voltageinsptable


set inspection_widgetnames {MUX-AI1 MUX-AI2 MUX-DI1 MUX-DI2 MUX-VI}
set inspection_regnames    {Insp.A1 Insp.A2 Insp.D1 Insp.D2 Insp.V}

#    the inspection line tables are in parallel
#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set analogueinsptable {Disconnected
        In1(A1) In2(A2) In3(A3) TFAOut(A4) Time(A5) Out1(A6) Out2(A7) Out3(A8)
}
set AI-ChanSelect {0 * * * * * * * *}
set AI-Param      {* 0 1 2 3 4 5 6 7}

set analogueinspmenu {Disconnected 
 {Inputs_on_Card In1(A1) In2(A2) In3(A3) TFAOut(A4)} 
 {Amplifier_Outputs Time(A5) Out1(A6) Out2(A7) Out3(A8)} 
} 
  
set digitalinsptable {Disconnected
        Prompt Sumbus Fast_Card-Trigger Trigger_Sample Validation_Input Validation_Sample RAZ_Card-Trigger
        Convert ADC_Clock  
        Conversion_Enable ASIC16_1_Datavble ASIC16_2_Datavble ASIC16_StrobeOut ASIC16_1_EnIn ASIC16_2_EnIn ASIC16_StrobeIn ASIC16_EnOut
        WFiFo WclkFiFo RFiFo RClkFiFo EF1 EF2
        LECT Dtack RenIn RenOut 
        CrdReset
}

set DI-ChanSelect {0 * * 2 * 2 2 2 * 1 1 1 1 3 4 4 4 4 6 6 5 5 5 5 3 6 3 3 6} 
set DI-Param      {* 0 1 4 2 7 6 5 3 4 5 6 7 4 4 5 6 7 5 6 4 5 6 7 7 4 5 6 7} 


set digitalinspmenu { Disconnected {Decision_Logic Prompt(L1) Sumbus(L2)\ 
 Fast_Card-Trigger(L4) Trigger_Sample(L3) Validation_Input(L7) Validation_Sample(L8)\ 
 RAZ_Card-Trigger(L6)} {ADC's Convert(L4) ADC_Clock(L9)} {ASIC16 Conversion_Enable(L10)\ 
 ASIC16_1_Datavble(L11) ASIC16_2_Datavble(L12) ASIC16_StrobeOut(L17) ASIC16_1_EnIn(L13)\ 
 ASIC16_2_EnIn(L14) ASIC16_StrobeIn(L15) ASIC16_EnOut} {FIFO's WFiFo(L22) WclkFiFo(L23)\ 
 RFiFo(L25) RClkFiFo(L26) EF1(L27) EF2(L28)} { External_Communication  LECT(L20)\ 
 Dtack(L21)  RenIn(L18) RenOut(L19) } CrdReset 
} 
  
 
set voltageinsptable {Disconnected
        PZ1 PZ2 PZ3 Threshold Delay Width FT-Sample ADC-Convert
        1W3 2W3 3W3 4W3 5W3 6W3 Card_Trigger_Delay Card_Trigger_Width Card_Validation_Sample Card_Trigger_W3
        -24V -18V -12V -6V -5.2V -2V 0V VREFDAC +5V +6V +12V +18V +20V +24V
 }
set VI-ChanSelect {0 * * * * * * * * 7 7 7 7 7 7 7 7  7  7 8 8 8 8 8 8 8 8  8  8  8  8  8  8}
set VI-Param      {* 0 1 2 3 4 5 6 7 1 2 3 4 5 6 8 9 10 11 0 1 4 5 6 7 8 9 10 11 12 13 14 15}



#    these are common
set steplist1 "CFDTHRESH CFDDELAY CFDWIDTH FTSAMPLE FTDELAY FTWIDTH VALSAMPLE ADCDELAY LTWATCHDOG TRIGWATCHDOG"
#    no per segment items
set steplist2 ""


loadsource common.vxi


#    Icare registers accessible via the ASIC window

set ASICregs {IW01 IW23 IR01 IR23 PMW CRR TFW CRW FTW FTR CSW CSR}

foreach reg $ASICregs {set $reg 0}



#    procedures to handle cfd and adc scaler functions

proc click-scalers {} {
#  start scalers sub frame
   global scalersvisible scalersframe
   if {$scalersvisible==0} then {make-scalersframe} else {open-frame $scalersframe}
   click-updteallscalers
}

#    these procedures are called directly from the main Icare frame
#    they will apply to the scalers on the current card only unless the 
#    "Act on all Detectors" choice is set to All or Select

proc click-clearcurrentscalers {} {
#    to clear all scalers set control bit to 1 and then back to 0
   write-widget-reg SCALERSCLR 1
   write-widget-reg SCALERSCLR 0
}

proc click-loadcurrentscalers {} {
#    to load all scalers set control bit to 1 and then back to 0
   write-widget-reg SCALERSLOAD 1
   write-widget-reg SCALERSLOAD 0
}

proc click-updtecurrentscalers {} {
   click-loadcurrentscalers
   redisplay-widget-reg CFDSCALER
   redisplay-widget-reg ADCSCALER
}

#    these procedures are called directly from the Scalers display frame
#    they will apply to all scalers on all cards as if the "Act on all Detectors"
#    choice is set to All 

proc click-clearallscalers {} {
   global allchans
   set allchans 1
   make-myserver
   click-clearcurrentscalers
   set allchans 0
   make-myserver
}

proc click-loadallscalers {} {
#    to load all scalers set control bit to 1 and then back to 0
   global allchans
   set allchans 1
   make-myserver
   click-loadcurrentscalers
   set allchans 0
   make-myserver
}

proc click-updteallscalers {} {
   global allchans scalersframe
#    to redisplay all scalers in the Icare Scalers Display
#    first load all scalers
   open-frame $scalersframe
   set-footer $scalersframe "Updating Scalers"
   click-loadallscalers
#    now have to switch to all channel mode
   set allchans 1
   make-myserver
#    read all the ADC scalers and update display
   set l [read-regs * "" ADC.Scaler]
   foreach item $l {
       set r [first $item]
       set v [second $item]
       set m [first [split $r .]]
       set c [string range $m 5 end]
       :modify SCALEADC$c :value $v
   }
#    read all the CFD scalers and update display
   set l [read-regs * "" CFD.Scaler]
   foreach item $l {
       set r [first $item]
       set v [second $item]
       set m [first [split $r .]]
       set c [string range $m 5 end]
       :modify SCALECFD$c :value $v
   }
#    and finally switch back to single channel mode
   set allchans 0
   make-myserver
   clear-footer $scalersframe
}

proc click-scalers-period v {
   global scaleperiod scaleperiodchoice

   set scaleperiod [lindex $scaleperiodchoice $v]
}

proc click-scalers-go v {
   global scalego scalerafterid scaleperiod
   set scalego $v
#    v=0   stop scalers auto update
#    v=1   start scalers auto update
   switch $scalego {
      0  {
         if {$scalerafterid != ""} then {
            after cancel $scalerafterid
            set scalerafterid ""
         }
      }
      1  {
         if {$scalerafterid == ""} then {
            set scalerafterid [after [expr $scaleperiod * 1000] do-scalers-event]
         }
      }
   }
}

proc do-scalers-event {} {
   global scalerafterid
   set scalerafterid ""
   click-updteallscalers
   click-scalers-go 1
}

proc click-ASIC {} {
#  display ASIC sub frame
   global ASICvisible ASICframe
   if {$ASICvisible==0} then {make-ASICframe} else {open-frame $ASICframe}
   click-ASIC-redisplay
}

proc click-ASIC-redisplay {} {
   global ASICregs chanindex chanlist

   read-ASICregs

   set detector [lindex $chanlist $chanindex]
   set card [expr $detector / 6 + 1]
   set channel [expr $detector - [expr [expr $card - 1] * 6] + 1]
   set ASIC [expr [expr $channel + 2] / 3]

   :modify ASICM11 :label "Detector $detector"
   :modify ASICM12 :label "ASIC $ASIC / Channel [expr $channel -1]"
   if {$channel <= 3} then {
      :modify ASICM22 :label "ASIC 1 / Channels 0=>2"
   } else {
      :modify ASICM22 :label "ASIC 2 / Channels 3=>5"
   }
   :modify ASICM31 :label "Detector $detector" 
   :modify ASICM32 :label "Card $card / Channels 0=>5"

   foreach w $ASICregs {
      global $w
      show_word $w [set $w]
   }
}

proc read-ASICregs {} {
   global IR01 IR23 CRR FTR CSR
   global IW01 IW23 PMW TFW CRW
   global chanlist chanindex

   set detector [lindex $chanlist $chanindex]
   set card [expr $detector / 6 + 1]
   set channel [expr $detector - [expr [expr $card - 1] * 6] + 1]
   set ASIC [expr [expr $channel + 2] / 3]

   #    the first batch are write registers
   set IW01 [read-vxi-reg ASIC.Ident01]
   set IW23 [read-vxi-reg ASIC.Ident23]
   set PMW  [read-vxi-reg ASIC$ASIC.Pattern_Mask_Reg_Wt]
   set TFW  [read-vxi-reg ASIC$ASIC.Transfer_Format_Reg_Wt]
   set CRW  [read-vxi-reg ASIC$ASIC.Correction_Reg_Wt]

   #   ident register is per channel
   set IR01 [read-vxi-reg ASIC.Ident01]
   set IR23 [read-vxi-reg ASIC.Ident23]

   #    pattern reg is 3 channels per word
   set CRR  [read-vxi-reg ASIC$ASIC.Pattern_Correction_Reg_Rd]

   #    rest are per card and are R/W
   set FTR  [read-vxi-reg FIFO.Test_Reg]
   set CSR  [read-vxi-reg Status]
}

proc click-ASIC-read w {
   global chanlist chanindex

   set detector [lindex $chanlist $chanindex]
   set card [expr $detector / 6 + 1]
   set channel [expr $detector - [expr [expr $card - 1] * 6] + 1]
   set ASIC [expr [expr $channel + 2] / 3]

   set r [string range $w 0 [expr [string length $w] - 2]]
   global $r
   switch $r {
      IR01 {set IR01 [read-vxi-reg ASIC.Ident01]}
      IR23 {set IR23 [read-vxi-reg ASIC.Ident23]}
      CRR  {set CRR  [read-vxi-reg ASIC$ASIC.Pattern_Correction_Reg_Rd]}
      FTR  {set FTR  [read-vxi-reg FIFO.Test_Reg]}
      CSR  {set CSR  [read-vxi-reg Status]}
   }
   show_word $r [set $r]
}

proc click-ASIC-write w {
   global chanlist chanindex

   set detector [lindex $chanlist $chanindex]
   set card [expr $detector / 6 + 1]
   set channel [expr $detector - [expr [expr $card - 1] * 6] + 1]
   set ASIC [expr [expr $channel + 2] / 3]

   set r [string range $w 0 [expr [string length $w] - 2]]
   global $r
   switch $r {
      IW01 {write-vxi-reg ASIC.Ident01 $IW01}
      IW23 {write-vxi-reg ASIC.Ident23 $IW23}
      PMW  {write-vxi-reg ASIC$ASIC.Pattern_Mask_Reg_Wt $PMW}
      TFW  {write-vxi-reg ASIC$ASIC.Transfer_Format_Reg_Wt $TFW}
      CRW  {write-vxi-reg ASIC$ASIC.Correction_Reg_Wt $CRW}
      FTW  {write-vxi-reg FIFO.Test_Reg $FTW}
      CSW  {write-vxi-reg Status $CSW}
   }
}

   

proc set-ASIC-bit {w j i} {
#    insert-debug "ASIC bit $w $j $i"

     global $w
     
     set $w [flip-ASIC-bit $w $j $i]

     show_word $w [set $w]
}


proc flip-ASIC-bit {w j i} {

    set bit [expr $j * 8 + $i]

    global $w
    set dataword [set $w]

    for {set i 0} {$i < 32} {incr i} {
       set data($i) [expr $dataword >> [expr 31 - $i] & 1]
    }

    set data($bit) [expr $data($bit) + 1 & 1]

    set dataword 0
    for {set i 0} {$i < 32} {incr i} {
       set dataword [expr [expr $dataword << 1] + $data($i)]
    }
    return $dataword
}


proc click-scalefactor {v} {
    if {$v == 1} then {
#     direct 
        write-vxi-reg Shift.Enable 0
    } else {
#    scaled
        write-vxi-reg Shift.Enable 1
        write-vxi-reg Shift [expr $v-1]
    }
}

proc click-scaling {v} {
     write-vxi-reg Shift.Go $v
}
 
proc repaint-parameter {} {

   set v [read-vxi-reg Shift.Enable]
   set s [read-vxi-reg Shift]
   if {$v == 0} then {
       :modify SCALEFACTOR :value 0
   } else {
       :modify SCALEFACTOR :value [expr $s + 1]
   }
}


proc click arg {
   global debug userselection allchans ASICvisible
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
#    insert-debug "click with argument \{$arg\}"
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {
      *REDISPLAY   {click-redisplay}
      ENGINEERING  {click-$v}
      STEP        {click-step $v $i}

      SCALING      {click-scaling $v}
      SCALEFACTOR  {click-scalefactor $v}

      SCALEPERIOD {click-scalers-period $v}
      SCALEGO     {click-scalers-go $v}

      IR01B       -
      IR23B       -
      CRRB        -
      FTRB        -
      CSRB        {click-ASIC-read $w}

      IW01B       -
      IW23B       -
      PMWB        -
      TFWB        -
      CRWB        -
      FTWB        -
      CSWB        {click-ASIC-write $w}
      
      CHANNEL     {
           click-channel $v
           if {$ASICvisible != 0} then {click-ASIC-redisplay}
      }
      ALLCHANS    {click-whichchans $v}

      PARAM       {click-param $v}
      MUX-*       {click-inspection $w [lindex $arg 4]}

      default   {
          if {$allchans < 0} then {set userselection 1}
             click-on $w $v
             set userselection 0
      }
   }
}

set electronicsframe "[self frame-name].electronics"
set ASICframe        "[self frame-name].asic"
set ASICvisible 0
set scalersframe     "[self frame-name].scalers"
set scalersvisible 0




proc make-frame1 {} {
  global env chanlist 
  global analogueinspmenu digitalinspmenu voltageinsptable stepmenu stepmode

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel P1 :layout T :padx 10 :pady 5
     :layout H; :row-gap 10; :col-gap 10
      :choice-stack CHANNEL :label "Current Detector:" :strings $chanlist :valuex 18c  :rows 6
      :checkbox ENABLE :label "Enable:" :valuex 8c
      :choice ALLCHANS :label "Act on Detectors?" :valuex 20c :strings [list Current All Select] :value 0

   :panel P2 :layout T :padx 40
     :layout H; :col-gap 25
      :message M1  :label "Gain"                 :w 20
      :message M2  :label "Pole Zero Adjust (mV)"     :w 22
      :message M4  :label "Address"              :w 15
   :row-gap 5; :col-gap 20; :next-row T
       :message ADC0M    :label ADC0 :w 8
       :text ADC0ADDR    :label " " :w 6   :read-only T :valuex 53c
   :next-row T
      :message ADC1M     :label ADC1 :w 8   
      :choice ADC1GAIN   :label " " :strings [list High Low]
      :slider ADC1PZ     :label " "   :min 0 :max 9180
      :text ADC1ADDR     :label " " :w 6   :read-only T 
   :next-row T  
      :message ADC2M     :label ADC2 :w 8
      :choice ADC2GAIN   :label " " :strings [list High Low]
      :slider ADC2PZ     :label " "   :min 0 :max 9180
      :text ADC2ADDR     :label " " :w 6   :read-only T 
   :next-row T 
      :message ADC3M    :label ADC3 :w 8
      :choice ADC3GAIN   :label " " :strings [list High Low]
      :slider ADC3PZ     :label " "   :min 0 :max 9180  
      :text ADC3ADDR     :label " " :w 6   :read-only T 

   :panel P3 :layout T :padx 10 :pady 10
     :layout H; :row-gap 5; :col-gap 10
      :slider CFDTHRESH  :label "CFD Input Threshold (mV):" :min 0 :max 510    :valuex 30c
     :next-row T
      :slider CFDDELAY   :label "CFD Output Delay (ns):"    :min 0 :max 255    :valuex 30c
      :choice SCALING    :label "Scaling" :strings [list Off On]
     :next-row T
      :slider CFDWIDTH   :label "CFD Output Width (ns):"    :min 0 :max 255    :valuex 30c
      :choice-stack SCALEFACTOR :label "Scale Factor" :strings [list 1 2 4 8 16 32 64 128 256]
     :next-row T
      :slider FTSAMPLE   :label "Fast Trigger Sample (ns):" :min 0 :max 1275   :valuex 30c
     :next-row T
      :slider ADCDELAY   :label "ADCs Convert Delay (ns):"  :min 0 :max 5100   :valuex 30c
     :next-row T
      :slider LTWATCHDOG :label "Local Trig Watchdog (ns):" :min 0 :max 20400  :valuex 30c

     :layout H; :row-gap 5; :col-gap 20
      :next-row T
      :button SCALERUPDT  :label "Update scalers"   :command click-updtecurrentscalers
      :button SCALERCLR   :label "Clear Scalers"    :command click-clearcurrentscalers
      :text CFDSCALER     :label "CFD scaler"  :w 8 :deaf T
      :text ADCSCALER     :label "ADC scaler"  :w 8 :deaf T

   :panel P5 :layout T :padx 10 :pady 10
     :layout H; :row-gap 5; :col-gap 20
      :choice FT     :label "Fast Trigger"    :strings [list Internal External]
      :choice VAL    :label "Validation Mode" :strings [list Validation RAZ]
      :choice SUMBUS :label "Sumbus"          :strings [list Off On]

     :layout V
      :next-row T
      :slider FTDELAY      :label "Trigger Delay (ns):"     :min 0 :max 1275  :valuex 30c
      :slider FTWIDTH      :label "Trigger Width (ns):"     :min 0 :max 1275  :valuex 30c
      :slider VALSAMPLE    :label "Validation Sample (ns):" :min 0 :max 4080  :valuex 30c
      :slider TRIGWATCHDOG :label "Trigger Watchdog (ns):"  :min 0 :max 20400 :valuex 30c

   :panel P6 :layout T :padx 10 :pady 10
      :layout H; :col-gap 10; :row-gap 10
      :menubutton MUX-AI1 :label "Analogue Inspection 1:" :w 22 :menu $analogueinspmenu
      :message MUX-AI1-USE   :label ""
      :next-row T
      :menubutton MUX-AI2 :label "Analogue Inspection 2:" :w 22 :menu $analogueinspmenu
      :message MUX-AI2-USE   :label ""
      :next-row T
      :menubutton MUX-DI1 :label "Digital Inspection 1:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI1-USE   :label ""
      :next-row T
      :menubutton MUX-DI2 :label "Digital Inspection 2:"  :w 22 :menu $digitalinspmenu
      :message MUX-DI2-USE   :label ""
      :next-row T
      :menubutton MUX-VI  :label "Voltage Inspection:"    :w 22 :menu $voltageinsptable
      :message MUX-VI-USE   :label ""

   :panel P4 :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 5; :row-gap 10

      :button REDISPLAY
      :menubutton STEP      :label "[lindex $stepmenu $stepmode]"  :strings $stepmenu 
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button ASIC        :label "ASIC"         :command click-ASIC
      :button SCALERS                           :command click-scalers
      :button HELP  
   
 :show T

}

proc make-frame2 {} {}

proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame "$electronicsframe" :label "Icare Electronics" :resize F :transient T

   :panel P20 :layout T :padx 5 :pady 5
     :layout H; :row-gap 5
      :checkbox LASTCARD  :label "Last Card:"                            :valuex 20c
      :text MODELCODE     :label "Model Code:" :w 6  :read-only T        :valuex 20c
    :next-row T
      :text MANID         :label "Manufacturer ID:" :w 6  :read-only T   :valuex 20c
      :text SERIALNUM     :label "Serial Number:" :w 6 :read-only T      :valuex 16c
    :next-row T
      :text MODLEVEL      :label "Modification Level:" :w 6 :read-only T :valuex 20c
      :text OFFSET        :label "Offset Register:" :w 6 :read-only T    :valuex 20c
   
  :show T
 set electronicsvisible 1
}

proc make-chanSELframe {} {
  global chansel chanlist

   :frame CHANSEL-FRAME :label "Icare Detector Selection"  :show-footer F :resize F :transient T
   :panel CHANSEL-PANEL :layout T
   :choice CHANSEL :exclusive F :strings $chanlist :value $chansel
   :show T
}  

#    procedures which handle the display of the ICARE ASICs and other control, configuration and
#    status registers

proc make_word {widget title action} {

  set label(0) 31
  set label(1) 23
  set label(2) 15
  set label(3) 7

   :panel $widget :layout T :padx 10
     :layout H
  
     :message [set widget]M :label "$title"  :w 24

     for {set j 0} {$j < 4} {incr j} {

        :message [set widget]M$j  :label $label($j)  :w 5

        :canvas [set widget]BYTE$j  :w 175 :h 35

        for {set i 0} {$i < 8} {incr i} {
           set y 20
           set x [expr $i * 20  + 15]
           if {$i > 3} then {incr x 10}
           entry [:path [set widget]BYTE$j].bit$i -relief flat -width 1 -justify right
           [:path [set widget]BYTE$j].bit$i insert 0 " "
           :draw window :tag [set widget]bit$i :value $x $y -window [:path [set widget]BYTE$j].bit$i 

           if {$action == "Write"} then {
              bind [:path [set widget]BYTE$j].bit$i <ButtonPress-1>  "set-ASIC-bit $widget $j $i"
           }
        }
     }

     :hskip 10
     :button [set widget]B  :label  "$action"
}

proc show_word {widget dataword} {

     for {set i 0} {$i < 32} {incr i} {
        set data($i) [expr $dataword >> [expr 31 - $i] & 1]
     }

     for {set j 0} {$j < 4} {incr j} {
        for {set i 0} {$i < 8} {incr i} {
           [:path [set widget]BYTE$j].bit$i delete 0 end
           [:path [set widget]BYTE$j].bit$i insert 0 $data([expr $j * 8 + $i])
        }
     }
}

proc make-ASICframe {} {
   global env ASICframe ASICvisible
   global chanindex chanlist

  :frame "$ASICframe" :label "Icare ASIC Setup" :resize F :show-footer T  \
     :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

set detector [lindex $chanlist $chanindex]
set card [expr $detector / 6 + 1]
set channel [expr $detector - [expr [expr $card - 1] * 6] + 1]
set ASIC [expr [expr $channel + 2] / 3]

   :panel ASICP1 :layout T :padx 10 :pady 10
     :layout H

   :hskip 50
   :message ASICM11 :label "" 
   :hskip 600
   :message ASICM12 :label "" 

     make_word IW01 "adc1-adc0 Ident Reg W:" Write
     make_word IW23 "adc3-adc2 Ident Reg W:" Write
     make_word IR01 "adc1-adc0 Ident Reg R:" Read
     make_word IR23 "adc3-adc2 Ident Reg R:" Read

   :panel ASICP2 :layout T :padx 10 :pady 10
     :layout H

   :hskip 50
   :message ASICM21 :label "" 
   :hskip 600
   :message ASICM22 :label "" 

     make_word PMW "Pattern/Mask Reg W:"       Write
     make_word CRR "Pattern/Correction Reg R:" Read
     make_word TFW "Transfer Format Reg W:"    Write
     make_word CRW "Correction Reg W:"         Write

   :panel ASICP3 :layout T :padx 10 :pady 10
     :layout H

   :hskip 50
   :message ASICM31 :label "" 
   :hskip 600
   :message ASICM32 :label "" 

     make_word FTW "Fifo Test Reg W:"       Write
     make_word FTR "Fifo Test Reg R:"       Read
     make_word CSW "Config/Status Reg W:"   Write
     make_word CSR "Config/Status Reg R:"   Read

   :panel ASICB :layout B :padx 10 :pady 10
      :layout H; :col-gap 15

      :button ASICREDISPLAY :label "Redisplay"    :command click-ASIC-redisplay
      :button ASICSAVE      :label "Save Card Setup"     :command "inform vxisave start"
      :button ASICRESTORE   :label "Restore Card Setup"  :command "inform vxirestore start"
      :hskip 100
      :button ASICHELP :label Help


   :show T

   set ASICvisible 1
}


set scaleperiodchoice [list 5 10 20 50 100 200 500 1000]
set scaleperiod 10
set scalego 0
set scalerafterid ""

proc make-scalersframe {} {
   global env chanlist scalersframe scalersvisible
   global scaleperiodchoice  scalescalechoice scalescale scaleperiod scalego

  :frame "$scalersframe" :label "Icare Scalers Display" :resize F :show-footer T  \
     :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

   :panel SCALEP1 :layout T :padx 10 :pady 10
     :layout H; :col-gap 25

     :choice SCALEGO    :label "Display Auto Update"  :strings [list Off On]  :value $scalego
     :choice-stack SCALEPERIOD  :label "Update period (secs)" :strings $scaleperiodchoice \
          :value [lsearch $scaleperiodchoice $scaleperiod]

   :panel SCALEPS  :layout T :padx 10 :pady 10
     :layout H; :row-gap 0

   set cards [expr [llength $chanlist] + 5 / 6]
   set chanindex 0
   for {set c 0} {$c < $cards} {incr c} {

      if {$c != 0} then {:vskip 10}

      for {set i 0} {$i < 6} {incr i} {

         set chan [lindex $chanlist [expr $chanindex + $i]]
         if {$chan == ""} then {break}
         :text SCALECFD$chan :label "$chan.cfd"  :valuex 8c  :w 8 :deaf T  
      }
      :next-row T
      for {set i 0} {$i < 6} {incr i} {

         set chan [lindex $chanlist [expr $chanindex + $i]]
         if {$chan == ""} then {break}
         :text SCALEADC$chan :label "$chan.adc"  :valuex 8c  :w 8 :deaf T 
      }
      incr chanindex 6
      :next-row T
   }

   :panel SCALEB :layout B :padx 10 :pady 10
      :layout H; :col-gap 10

     :button SCALEREDISPLAY :label "Redisplay"  :command click-updteallscalers
     :hskip 100
     :button SCALECLR   :label "Clear Scalers"  :command click-clearallscalers
     :button SCALELOAD  :label "Load Scalers"   :command click-loadallscalers
     :hskip 200
     :button SCALEHELP :label Help

   :show T

   set scalersvisible 1
}


