# Setup frame for NAM card

# 23-11-92 PHO
#	included inspection line names
# 12-11-92 PHO
#	included software histogramming
# PHO 9-11-92
#	sorted channel list so NIM9 is before NIM10
# PHO 5-11-92
#	made changes to cope with more flexible naming

set panelh ":h 300"

set debug 0
set unshown 1
set frameformat 1
set chanlist {}
set chanindex 0
set channel NIM0
set minchannel 0
set maxchannel 31
set globalaction 0
set frame NAM
set frametitle "NAM/NIM Channel Setup"
set cardtype NAM.
set parameter DISABLE
set register "Disable"
set amp 1
set veto 1
set tfa 1
set bdc 1
set timeout 1
set mode 1
set enable 1
set presetslist {"UP4/UP4" "//CFDDirect/CFDDelay"}

set extraframe NX
set extravisible 0
set modcode 0
set serialnum 0
set modlevel 0
set manid 0
set offset 0
set histogram 0
set col1 ":valuex 100"
set col2 ":valuex 280"
set extraformat "
($frame (:command-frame $extraframe :label 'NAM/NIM Electronics' :w 330 :h 310
      :pin-in T
   (:panel :x 0 :y 0
      (:checkbox LASTCARD  :label 'Last Card:'                            $col1)
      (:text MODELCODE     :label 'Model Code:' :w 6  :read-only T        $col2)
    :next-row T
      (:checkbox POWER     :label 'Power:' :deaf T                        $col1)
      (:text SERIALNUM     :label 'Serial Number:' :w 6 :read-only T      $col2)
    :next-row T
      (:checkbox ENABLE    :label 'ADC Enabled:' :deaf T                  $col1)
      (:text MODLEVEL      :label 'Modification Level:' :w 6 :read-only T $col2)
    :next-row T
      (:checkbox HISTOGRAM :label 'Histogram:'                            $col1)
      (:text MANID         :label 'Manufacturer ID:' :w 6  :read-only T   $col2)
    :next-row T
      (:text OFFSET        :label 'Offset Register:' :w 6 :read-only T    $col2)
    :next-row T
      (:text ADC           :label 'ADC:' :w 8                             $col1)
      (:choice DEAD        :exclusive F :strings ('Dead') :deaf T)
      (:choice READY       :exclusive F :strings ('Ready') :deaf T)
    :next-row T
      (:choice MODE :label 'Readout:' :strings ('Block' 'Single Cycle')   $col1)
      (:choice DONE :exclusive F :deaf T :strings ('Done'))
    :next-row T
      (:choice EMPTY :label 'FIFO:' :strings ('Empty' 'Not Empty')        $col1)
    :next-row T
      (:checkbox LED-ENA :label 'LED:'                                    $col1)
      (:number LED-VAL :min 0 :max 15 :w 1 )
   )
:show T))" 
         

set table(CHANNEL) {channel widget->channel channel->widget nil nil nil nil nil}
set table(GLOBAL) {globalaction int-widget->param param->int-widget nil nil nil nil nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Enabled"
       int-reg->param param->int-reg nil :checkbox T nil nil}
set table(ADDRESS) {addr widget->param param->hex-widget "Addr"
       int-reg->param param->int-reg nil :text 6 nil nil}
set table(TIMEOUT) {timeout slider-widget->param param->int-widget "Validation.Timeout"
       unit-reg->param param->unit-reg ns :slider 0 12750 50}
set table(DISABLE) {disable int-widget->param param->int-widget "Disable"
       not-reg->param param->not-reg nil :checkbox F nil nil}
set table(POWER) {power int-widget->param param->int-widget "On"
       int-reg->param param->int-reg nil :checkbox T nil nil}
set table(GO) {go int-widget->param param->int-widget "NAM.Go"
       int-reg->param param->int-reg nil :choice Stop Go nil}
set table(MODE) {mode int-widget->param param->int-widget "Readout.Mode"
       int-reg->param param->int-reg nil :choice Block "Single Cycle" nil}
set table(DONE) {done int-widget->param param->int-widget "Readout.Done"
       int-reg->param param->int-reg nil :checkbox T nil nil}
set table(SELECT) {done int-widget->param param->int-widget "Select"
       int-reg->param param->int-reg nil :checkbox F nil nil}

set table(VAL-SOURCE) {vals int-widget->param param->int-widget "Validation.Source"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(MG-SOURCE) {mgs int-widget->param param->int-widget "MasterGate.Source"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(DI1) {di1 int-widget->param param->int-widget "Insp.D1"
       digital-insp-reg->param param->digital-insp-reg nil nil nil nil nil}
set table(DI2) {di2 int-widget->param param->int-widget "Insp.D2"
       digital-insp-reg->param param->digital-insp-reg nil nil nil nil nil}

# electronics

set table(LASTCARD) {lastcard int-widget->param param->int-widget "LastCard"
       int-reg->param param->int-reg nil :checkbox F nil nil}
set table(MODELCODE) {modcode str-widget->param param->hex-widget "VXI.ModelCode"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(SERIALNUM) {serialnum str-widget->param param->hex-widget "VXI.SerialNum"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(MODLEVEL) {modlevel str-widget->param param->hex-widget "VXI.ModLevel"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(MANID) {manid str-widget->param param->hex-widget "VXI.ManID"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(OFFSET) {offset str-widget->param param->hex-widget "VXI.Offset"
       int-reg->param param->int-reg nil nil nil nil nil}
set table(HISTOGRAM) {histogram int-widget->param param->int-widget "FIFO.Histogram"
       int-reg->param param->int-reg nil nil nil nil nil}

set table(GATE) {gate int-widget->param param->int-widget "ADC.Gate"
       int-reg->param param->int-reg nil :checkbox F nil nil}
set table(DEAD) {dead int-widget->param param->int-widget "ADC.DeadTime"
       int-reg->param param->int-reg nil :checkbox T nil nil}
set table(READY) {readt int-widget->param param->int-widget "ADC.Ready"
       int-reg->param param->int-reg nil :checkbox T nil nil}

set table(LED-ENA) {ledena int-widget->param param->int-widget "LED.Enable"
       int-reg->param param->int-reg nil :checkbox F nil nil}
set table(LED-VAL) {ledval int-widget->param param->int-widget "LED"
       int-reg->param param->int-reg nil :number 4 nil nil}
set table(EMPTY) {empty int-widget->param param->int-widget "FIFO.NotEmpty"
       int-reg->param param->int-reg nil :choice Empty "Not Empty" nil}
set table(ADC) {adc widget->param param->hex-widget "ADC"
       int-reg->param param->int-reg nil :text 8 0 nil}

#--------------------------------------------------------------------------------
# these three tables are parallel

set regnames {
	Disable
	On
	Addr
	Enabled
	Select
	ADC.Gate ADC.DeadTime ADC.Ready
	ADC
	LED.Enable LED
	Readout.Mode Readout.Done
	Validation.Timeout
	FIFO.NotEmpty
	VXI.ModelCode VXI.SerialNum VXI.ModLevel VXI.ManID VXI.Offset
	LastCard NAM.Go
	Validation.Source MasterGate.Source
	Insp.D1 Insp.D2
	FIFO.Histogram
   }

set widgetnames {
	DISABLE
	POWER
	ADDRESS
	ENABLE 
	SELECT
	GATE DEAD READY
	ADC
	LED-ENA LED-VAL
	MODE DONE
	TIMEOUT
	EMPTY
	MODELCODE SERIALNUM MODLEVEL MANID OFFSET
	LASTCARD GO
	VAL-SOURCE MG-SOURCE
	DI1 DI2
	HISTOGRAM
   }

set parameternames {
	"Enable"
	"Power"
	"address"
	"ADC Enabled"
	"ADC Select"
	"ADC Gate" "ADC Dead Time" "ADC Ready"
	"ADC Data"
	"LED Enable" "LED Value"
   }

# inspection tables must be in same order as entries in the :choice-stacks

set digitalinsptable {
	"Disconnected" "View" "Select" "DeadTime" "Ready" "Fail" "VMEAccess"
	"MasterGate" "OR.Fail" "REN" "Pass" "VXI.Readout" "FIFO.Empty"
	"FIFO.ReadoutDone" "FIFO.Read" "RIP.Mux" "RIP.VXI"
	"ValidationTimeout" "NoMasterGate" "Logic.1"
}

proc write-reg {c r v u g} {
	global debug 
	if {$g} then {
		set rr [make-reg-name * $r]
		set-footer "setting register $rr to $v ..."
		if {$debug} then {puts stderr "setting register $rr to $v"}
		set z [catch {eg "(register :pattern '$rr' :value '$v')" } m]
		if {$z!=0} then {
			display-eg-error-report self $m "Attempting to write value $v to registers" $rr
			error $m
		}
	} else {
		set rr [make-reg-name $c $r]
		set-footer "setting register $rr to $v ..."
		if {$debug} then {puts stderr "setting register $rr to $v"}
		set z [catch {eg "(register :name '$rr' :value '$v')" } m]
		if {$z!=0} then {
			display-eg-error-report self $m "Attempting to write value $v to register" $rr
			error $m
		}
	}
	clear-footer
}

proc read-reg {c r} {
	global debug cardtype
	set rr [make-reg-name $c $r]
	set-footer "reading register $rr ..."
	if {$debug} then {puts stderr "reading register $rr"}
	set z [catch {eg "(register :name '$rr' ?value)" } m]
	if {$z!=0} then {
		display-eg-error-report self $m "Attempting to read register" $rr
		error $m
	}
	clear-footer
	return "$cardtype$c.$r $m"
}

proc read-regs {c r} {
	global debug cardtype
	set pattern [make-reg-name $c $r]
	set-footer "reading registers $pattern ..."
	if {$debug} then {puts stderr "reading registers $pattern"}
	set z [catch {eg "(register :pattern '$pattern' ?names-and-values)" } m]
	if {$z!=0} then {
		display-eg-error-report self $m "Attempting to read registers" $pattern
		error $m
	}
	clear-footer
	return $m
}

proc inquire-regs {c r} {
	global debug cardtype
	set pattern [make-reg-name $c $r]
	set-footer "finding registers $pattern ..."
	if {$debug} then {puts stderr "finding registers $pattern"}
	set z [catch {eg "(register :pattern '$pattern' ?names)" } m]
	if {$z!=0} then {display-eg-error-report self $m; error $m}
	clear-footer
	return $m
}

proc widget->param {p v s} {
   global $p
   set $p $v
   }

proc slider-widget->param {p v s} {
	global $p 
	set oldv [set $p]

	if {$v==$oldv+1} then {set v [expr $oldv+$s]}
	if {$v==$oldv-1} then {set v [expr $oldv-$s]}
	set $p $v
   }

proc int-widget->param {p v s} {
   global $p
   set $p $v
   }

proc widget->channel {p v s} {
   global $p
   set $p $v
   }

proc scan-num s {
   if {[string first "0x" $s]==0} then {
      scan [string range $s 2 end] %x zzz; return $zzz}
   scan $s %f zzz; return $zzz
   }

proc scan-int s {
   if {[string first "0x" $s]==0} then {
      scan [string range $s 2 end] %x zzz; return $zzz}
   scan $s %d zzz; return $zzz
   }

proc strip-to-dot s {
	string range $s [expr 1+[string first . $s]] end
}

proc make-reg-name {chan reg} {
   global cardtype
   return /frontend/$cardtype$chan.$reg
   }

proc strip-to-channel {s chan} {
	global cardtype
	set r {}
	scan $s $cardtype$chan.%s r
	return $r
}

proc get-channel r {
   global cardtype chanlist

	foreach chan $chanlist {
		if {![string first $cardtype$chan. $r]} then {return $chan}
	}
}

proc lextract {l p} {
	set x {}
	for {set n 0} {[set n [lsearch [lrange $l $n end] $p]] >= 0} {} {
		puts stdout $n
		lappend x [lindex $l $n]
		set l [lreplace $l $n $n]
		puts stdout $x
		puts stdout $l
	}
	return [list $x $l]
}

proc get-channel-list {} {
	global cardtype chanlist chanindex channel
	set chanlist {}
	set l1 {}
	set l2 {}
	set l3 {}
	set l4 {}
	set l5 {}
	set l6 {}
	set parts {{NIM? l1} {NIM?? l2} {NIM??? l3} {RS? l4} {RS?? l5} {* l4}}

	foreach reg [inquire-regs * NAM.Go] {
		set c [string range $reg 4 [expr {[string last .N $reg] - 1}]]
		foreach pair $parts {
			if {[string match [first $pair] $c]} then {
				lappend [second $pair] $c
				break
			}
		}
	}
	set chanlist [concat $l1 $l2 $l3 $l4 $l5 $l6]
	
	set channel [lindex $chanlist $chanindex]
	catch {xv "(CHANNEL :strings ([quote-list $chanlist]) :value $chanindex)"}
}

proc first p {lindex $p 0}
proc second p {lindex $p 1}
proc third p {lindex $p 2}
proc fourth p {lindex $p 3}

proc quote-list l {
   set ll {}
   foreach f $l {append ll [format "'%s' " $f]}
   return $ll
   }

proc repaint-widget w {
   global table
   set line $table($w)
   set param [lindex $line 0]
   set w2p [lindex $line 1]
   set p2w [lindex $line 2]
   set reg [lindex $line 3]
   set r2p [lindex $line 4]
   set p2r [lindex $line 5]
   set unit [lindex $line 6]
   global $param
   set v [set $param]
   xv "[$p2w $w $v $unit]"
   }
   
proc repaint-channel {} {
   global chanindex
   catch {xv "(CHANNEL :value $chanindex)"}
   }

proc repaint-global {} {
   global globalaction
   catch {xv "(GLOBAL :value $globalaction)"}
   }

proc repaint-parameter {} {
   global register regnames
   catch {xv "(PARAM :value [lsearch $regnames $register])"}
   }

proc repaint-presets-menu {} {
   global presetslist
   set presetsmenu $presetslist
   lappend presetsmenu "" "" "Grab Setting" "Drop Setting" "Disconnect All"
   xv "(PRESETS :menu (:menu PRESETS-MENU :strings ([quote-list $presetsmenu])))"
   }

proc repaint {} {
   repaint-channel
   repaint-global
   repaint-parameter
   }


proc update-pair pair {
   global debug regnames widgetnames frameformat unshown
   set c [get-channel [first $pair]]
   set r [strip-to-channel [first $pair] $c]
   set v [second $pair]
   if {$v==""} then {return}
   set i [lsearch $regnames $r]
   if {$i<0} then {return}
   set w [lindex $widgetnames $i]
   global table
   set line $table($w)
   set param [lindex $line 0]
   set w2p [lindex $line 1]
   set p2w [lindex $line 2]
   set reg [lindex $line 3]
   set r2p [lindex $line 4]
   set p2r [lindex $line 5]
   set unit [lindex $line 6]
   $r2p $param $v
   global $param
   set v [set $param]
   if {$debug} then {puts stderr "$p2w $w $c $v $unit"}
   catch {
      case $frameformat in {
         1 {xv "[$p2w $w $v $unit]"}
         2 {xv "[$p2w $w.$c $v $unit]"; if {$unshown} then {xv "($w.$c :show T)"}}
         }
      }
   }

proc print-pair pair {
   global listing
   append listing [format "%-20s%s\n" [first $pair] [second $pair]]
   }

proc update-pairs l {foreach p $l {update-pair $p}}

proc print-pairs l {
   global listing
   set listing {}
   append listing [format "%s\n\n" [ date]]
   foreach p $l {print-pair $p}
   print-listing $listing
   }


proc param->analogue-insp-reg {p v u} {
   global analogueinsptable
   lindex $analogueinsptable $v
   }

proc param->digital-insp-reg {p v u} {
   global digitalinsptable
   lindex $digitalinsptable $v
   }

proc param->voltage-insp-reg {p v u} {
   global voltageinsptable
   lindex $voltageinsptable $v
   }

proc null-repainter {p v u} {}

proc param->int-widget {p v u} {return "($p :value $v)" }

proc param->str-widget {p v u} {return "($p :value '$v')" }

proc param->hex-widget {p v u} {format "(%s :value '0x%x')" $p $v }

proc param->choice-widget {p v u} {}

proc channel->widget {p v u} {return "($p :value $v)"}

proc param->int-reg {p v u} {return "$v"}

proc param->not-reg {p v u} {return "[expr $v^1]"}

proc param->unit-reg {p v u} {
	global $p
	return "[set $p]$u"
}

proc int-reg->param {p v} {global $p; set $p [scan-int $v]}

proc not-reg->param {p v} {global $p; set $p [expr [scan-int $v]^1]}

proc int-reg->choice-param {p v} {}

proc digital-insp-reg->param {p v} {
   global digitalinsptable
   global $p
   set i [lsearch $digitalinsptable $v]
   if {$i<0} then {puts stderr "digital inspection param '$v' not recognised"; return}
   set $p $i   
   }

proc analogue-insp-reg->param {p v} {
   global analogueinsptable
   global $p
   set i [lsearch $analogueinsptable $v]
   if {$i<0} then {puts stderr "analogue inspection param '$v' not recognised"; return}
   set $p $i   
   }

proc voltage-insp-reg->param {p v} {
   global voltageinsptable
   global $p
   set i [lsearch $voltageinsptable $v]
   if {$i<0} then {puts stderr "voltage inspection param '$v' not recognised"; return}
   set $p $i   
   }

proc unit-reg->param {p v} {global $p; set $p [scan-int $v]}

proc make-gauge-panel {w min max} {
   global frame minchannel maxchannel panelh
   xv "(PANEL :delete)"
   xv "($frame (:panel PANEL :x 0 :y 50 :w 750 $panelh :row-gap 0))"
   set x 120
   for {set i $minchannel} {$i<=$maxchannel} {incr i} {
      if {[expr $i%4]==0} then {xv "(PANEL :next-row T)"; set x 120}
      xv "(PANEL (:gauge $w.$i :valuex $x :label '$i:' 
                     :show F :min $min :max $max))"
      incr x 200
      }
   }

proc make-slider-panel {w min max} {
   global frame minchannel maxchannel panelh
   xv "(PANEL :delete)"
   xv "($frame (:panel PANEL :x 0 :y 50 :w 750 $panelh :row-gap 0))"
   set x 120
   for {set i $minchannel} {$i<=$maxchannel} {incr i} {
      if {[expr $i%3]==0} then {xv "(PANEL :next-row T)"; set x 120}
      xv "(PANEL (:slider $w.$i :valuex $x :label '$i:' 
                     :show F :min $min :max $max))"
      incr x 250
      }
   }

proc make-checkbox-panel {w deaf} {
	global frame minchannel maxchannel panelh chanlist
	xv "(PANEL :delete)"
	xv "($frame (:panel PANEL :x 0 :y 50 :w 750 $panelh))"
	set x 120
	set i 0
	foreach c $chanlist {
		if {[expr $i%5]==0} then {xv "(PANEL :next-row T)"; set x 120}
		xv "(PANEL (:checkbox $w.$c :valuex $x :label '$c:' :deaf $deaf :show F))"
		incr x 150
		incr i
	}
}

proc make-number-panel {w width} {
	global frame minchannel maxchannel panelh chanlist
	xv "(PANEL :delete)"
	xv "($frame (:panel PANEL :x 0 :y 50 :w 750 $panelh))"
	set x 120
	set i 0
	foreach c $chanlist {
		if {[expr $i%4]==0} then {xv "(PANEL :next-row T)"; set x 120}
		xv "(PANEL (:number $w.$c :valuex $x :label '$c:' :w $width :show F))"
		incr x 180
		incr i
	}
}

proc make-text-panel {w width} {
	global frame minchannel maxchannel panelh chanlist
	xv "(PANEL :delete)"
	xv "($frame (:panel PANEL :x 0 :y 50 :w 750 $panelh))"
	set x 120
	set i 0
	foreach c $chanlist {
		if {[expr $i%4]==0} then {xv "(PANEL :next-row T)"; set x 120}
		xv "(PANEL (:text $w.$c :valuex $x :label '$c:' :w $width :show F))"
		incr x 180
		incr i
	}
}

proc make-choice-panel {w off on} {
   global frame minchannel maxchannel panelh
   xv "(PANEL :delete)"
   xv "($frame (:panel PANEL :x 0 :y 50 :w 750 $panelh))"
   set x 120
   for {set i $minchannel} {$i<=$maxchannel} {incr i} {
      if {[expr $i%4]==0} then {xv "(PANEL :next-row T)"; set x 120}
      xv "(PANEL (:choice $w.$i :valuex $x :label '$i:' 
                      :show F :strings ('$off' '$on')))"
      incr x 150
      }
   }

proc make-panel w {
   global table register unshown
   set line $table($w)
   set type [lindex $line 7]
   set min [lindex $line 8]
   set max [lindex $line 9]
   case $type in {
     :gauge {make-gauge-panel $w $min $max}
     :slider {make-slider-panel $w $min $max}
     :checkbox {make-checkbox-panel $w $min}
     :number {make-number-panel $w $min}
     :text {make-text-panel $w $min}
     :choice {make-choice-panel $w $min $max}
     }
   set unshown 1
   }

proc click-on {ww v} {
	global table chanlist chanindex frameformat globalaction
	case $frameformat in {
		1  {set w $ww
			set c [lindex $chanlist $chanindex]}
		2  {set w [first [split $ww "."]]
			set c [string range $ww [string length $w.] end]}
	}
   set line "$table($w)"
   set param [lindex $line 0]
   set w2p [lindex $line 1]
   set p2w [lindex $line 2]
   set reg [lindex $line 3]
   set r2p [lindex $line 4]
   set p2r [lindex $line 5]
   set unit [lindex $line 6]
   set step [lindex $line 10]
   $w2p $param $v $step
   if {$reg!="nil"} then {
      write-reg $c $reg [$p2r $param $v $unit] $unit $globalaction
		if {$globalaction && $frameformat==2} then {
			quick-redisplay
		} else {
			update-pair [read-reg $c $reg]
		}
	}
   if {$reg!="nil" && $globalaction} then {set globalaction 0; repaint-global}
   }

proc click-channel v {
   global channel chanlist chanindex
	set chanindex $v
   set channel [lindex $chanlist $chanindex]
   quick-redisplay
   }

proc click-param v {
   global debug widgetnames regnames register parameter
   set w [lindex $widgetnames $v]
   set parameter $w
   set register [lindex $regnames $v]
   make-panel $parameter
   quick-redisplay
   }

proc click-electronics {} {
#  display extra sub frame
   global extraformat extravisible extraframe
   if {$extravisible==0} then {xv $extraformat} else {xv "($extraframe :show T)"}
   quick-redisplay
   set extravisible 1
   }   

proc click-format {} {
   global frameformat format1 format2 frame parameter extravisible
   if {$frameformat==1} then {
      set frameformat 2
      xv "($frame :delete)"
      xv $format2
      make-panel $parameter
      } \
   else {
      set extravisible 0
      set frameformat 1
      xv "($frame :delete)"
      xv $format1
      repaint-presets-menu
      }
   click-redisplay
   }

proc click-redisplay {} {
	get-channel-list
	quick-redisplay
}   

proc quick-redisplay {} {
   global chanlist chanindex redisplay register frameformat unshown 

   case $frameformat in {
      1 {set list [read-regs [lindex $chanlist $chanindex] *]}
      2 {set list [read-regs * $register]}
      }
   set redisplay $list
   update-pairs $list
   set unshown 0
   repaint
   }   

proc drop-trailing-nils ss {
   set n [llength $ss]
   if {$n==0} then {return {}}
   incr n -1
   if {[lindex $ss $n]=={}} then {drop-trailing-nils [lreplace $ss $n $n]} \
   else {return $ss}
   }

proc list-drop {ss p} {
   set n [lsearch $ss $p]
   if {$n<0} then {return $ss}
   lreplace $ss $n $n
   }

proc make-presets-pattern {} {
   global redisplay chanlist chanindex
   set pattern {}
   set z [catch {
      set ip [eg "(register :name '[make-reg-name [lindex $chanlist $chanindex] Insp.D1]' ?value)"]
      if {$ip=="Disconnected"} then {set ip ""}
      lappend pattern $ip
      set ip [eg "(register :name '[make-reg-name [lindex $chanlist $chanindex] Insp.D2]' ?value)"]
      if {$ip=="Disconnected"} then {set ip ""}
      lappend pattern $ip
      } m ]
   if {$z!=0} then {display-eg-error-report self $m; error $m}
   set pattern [drop-trailing-nils $pattern]
   set pattern [join $pattern "/"]   
   return $pattern
   }   


proc click-presets-grab {} {
   global presetslist
   set pattern [make-presets-pattern]
   if {$pattern!=""} then {lappend presetslist $pattern}
   repaint-presets-menu
   }

proc click-presets-drop {} {
   global presetslist
   set pattern [make-presets-pattern]
   set presetslist [list-drop $presetslist $pattern]
   repaint-presets-menu
   }

proc click-presets-disconnect-all {} {
   click-presets-set "Disconnected/Disconnected/Disconnected/Disconnected"
   }

proc click-presets-set v {
   global debug redisplay chanlist chanindex
   append items $v "///"
   set items [split $items "/"]
   if {[first $items]!={}} then \
      {write-reg [lindex $chanlist $chanindex] "Insp.D1" [third $items] "" 0}
   if {[fourth $items]!={}} then \
      {write-reg [lindex $chanlist $chanindex] "Insp.D2" [fourth $items] "" 0}
   set m [read-regs [lindex $chanlist $chanindex] Insp.*]
   set redisplay $m
   update-pairs $m
   }

proc click-presets v {
   global debug channel redisplay
   if {$debug} then {puts stdout "$v"}
   case $v in {
   {Disconnect\ All} {click-presets-disconnect-all}
   {Grab\ Setting} {click-presets-grab}
   {Drop\ Setting} {click-presets-drop}
   default {click-presets-set $v}
      }
   }

proc click-print {} {
   global redisplay
   print-pairs $redisplay
   }

proc click-help {} {
	clear-footer
	send mb goto [transparent "NAM Card"]
}

proc click-quit {f} {
   global extravisible
   xv "($f :delete)"
   set extravisible 0
}

proc click arg {
   global debug
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {remove-eg-error-report self; return}
   if {$c==":quit"} then {return [click-quit $f]}
   case $w in {
      REDISPLAY {click-redisplay}
      SAVE {click-save}
      RESTORE {click-restore}
      ELECTRONICS {click-electronics}
      HELP {click-help}
      FORMAT {after 100 click-format}
      CHANNEL {click-channel $v}
      PARAM {click-param $v}
      PRINT {click-print}
      PRESETS {}
      PRESETS-MENU {click-presets $v}
      default {click-on $w $v}
      }
   }


proc set-footer f {
   global frame
   xv "($frame :left-footer '[quote $f]')"
   }

proc clear-footer {} {
   global frame
   xv "($frame :left-footer ' ')"
   }

proc self op {
   global frame frametitle
   case $op in {
      frame-name {return $frame}
      frame-title {return $frametitle}
      }
   }

proc start args {
   global frameformat format1 globalaction
   set globalaction 0
   set frameformat 1
   xv $format1
   repaint-presets-menu
   click-redisplay
   }

proc finish args {
   global frame
   click-quit $frame
   }

set col1 ":valuex 100"
set col2 ":valuex 180"
set col3 ":valuex 400"

set format1 "
(:frame $frame :label '$frametitle'  :w 430 :h 340 :show-footer T :resize F
        :icon (:icon :image eg-array :transparent T :label 'NAM/NIM')

   (:panel :x 0 :y 0
      (:choice-stack CHANNEL :label 'Channel:'
         :rows 8 :cols 4 :strings ('NIM0') $col1)
      (:checkbox GLOBAL :label 'Act on all Channels:' $col3)
    :next-row T
      (:text ADDRESS :label 'Address:' :w 6   :read-only F $col1) 
#      (:text ADDRESS :label 'Address:' :w 6   :read-only T $col1) 
      (:checkbox DISABLE :label 'Enable:'  $col3)
    :next-row T
      (:choice GATE :label 'ADC Gate:' :strings ('Master Gate' 'Front Panel') $col1)
      (:checkbox SELECT    :label 'Select:'            $col3)
    :next-row T
      (:choice GO :label 'NAM:' :strings ('Stop' 'Go') $col2)
    :next-row T
      (:slider TIMEOUT  :label 'Validation Timeout (ns):' :min 0 :max 12750   $col2)
    :next-row T
      (:choice-stack VAL-SOURCE :label 'Validation Source:'  $col2
         :strings ('None' 'Validation 1' 'Validation 2' 'Validation 3'))
    :next-row T
      (:choice-stack MG-SOURCE :label 'Master Gate Source:' $col2
         :strings ('Front Panel' 'Validation 1' 'Validation 2' 'Validation 3'))
    :next-row T
      (:choice-stack DI1 :label 'Digital Inspection 1:'  $col2
         :strings ([quote-list $digitalinsptable]))
      (:button PRESETS :x 340 :label 'Presets:'
           :menu (:menu PRESETS-MENU :strings (' ')))
    :next-row T
      (:choice-stack DI2 :label 'Digital Inspection 2:' $col2
         :strings ([quote-list $digitalinsptable]))
    :next-row T
      (:button REDISPLAY :label 'Redisplay')
      (:button PRINT :label 'Print')
      (:button FORMAT :label 'By Parameter...')
      (:button ELECTRONICS :label 'Electronics...')
      (:button HELP :label 'Help...')
   )

) "

set format2 \
"(:frame $frame :label '$frametitle'  :w 750 :h 400 :show-footer T :resize F
        :icon (:icon :image eg-array :transparent T :label 'NAM/NIM')

   (:panel :x 0 :y 0
      (:choice-stack PARAM :label 'Parameter:' :valuex 120
         :strings ([quote-list $parameternames]))
      (:checkbox GLOBAL :label 'Act on all Channels:' :valuex 720)
   )

   (:panel PANEL :x 0 :y 100 $panelh)

   (:panel :x 0 :y 370
      (:button REDISPLAY :label 'Redisplay')
      (:button PRINT :label 'Print')
      (:button FORMAT :label 'By Channel...')
      (:button HELP :label 'Help...' :x 690)
   )
   )"

register-interest nam


