#    synctrig    generic VXI Version   /vxi/tcl/synctrig.tcl
global EGreport
set debug 0
set started 0

set frame synctrig
set frametitle "Sync Trig Generator"
set icontitle  "SyncTrig"

set tapestreams 1
set afterid ""
set triggerchanged 0

set vxireq 1
set ecreq 0
set datareq 0
set formatreq 0
set togglecount 0
set vxistate 0
set ecstate 0
set datastate 0
set formatstate 0

set EGkeep 0

loadsource common.vxi

set eventcount 1

if {[info exists env(D2VBserver)]} then {set D2VBserver $env(D2VBserver)} \
    else {set D2VBserver nneb}


proc click-count {v} { 
   global eventcount
	set eventcount $v
}

proc click-event {v} {
   global eventcount togglecount afterid resource triggerchanged
	if {$v == 1 } {
		if {$triggerchanged == 0 } { 
			EG "register :name '/$resource/TriggerMK2.VXI.Sync.Trig' :object '-n1' "
			set triggerchanged 1
		}
		set togglecount $eventcount
		sync-trig 0
		set-footer "Counting down $togglecount"
		sync-toggle
	}
	if {$v == 0 } { 
		after cancel $afterid 
		clear-footer
		click-redisplay
	}
}
proc sync-toggle {} {
	global debug afterid EGkeep togglecount EGreport
	set togglecount [expr {$togglecount -1 }]
	set EGkeep $EGreport
	set EGreport -1
	sync-trig 1
	sync-trig 0
	set EGreport $EGkeep
	if {$togglecount == 0  } then  {
		clear-footer
		click-redisplay
	        } \
	else	{
		if {[expr { ($togglecount / 20 ) * 20 }] == $togglecount } {
			set-footer "Counting down $togglecount"
		}
		set afterid [ after 20 sync-toggle ]
	}
}

proc sync-trig {v} {
	global resource
	EG "register :name '/$resource/TriggerMK2.VXI.Sync.Trig' :value '$v'"
}

proc click-redisplay {} {
  global vxireq ecreq datareq formatreq

}

proc click arg {
	global debug
        global vxireq ecreq datareq formatreq

	if {$debug} then {puts stderr "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	if {$c==":quit"} then {click-quit; return}
	switch -glob $w {

                EBGO   {click-event 1}
                EBSTOP {click-event 0}
                EVCNT  {click-count $v}

		default {puts stderr "sys:  click \{$arg\}"}
	}
}
# start up routine makes the frame.

proc start args {
   global started 
   if {$started == 0} then {make-frame} else {open-frame}
   set started 1
   click-redisplay
   return
}

proc click-quit args {close-frame}

proc finish args {destroy-frame}

proc make-frame {} {
  global env tapestreams 
  global vxireq ecreq datareq formatreq
  global vxistate ecstate datastate formatstate

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/egarray" \
      :icon-name "[self icon-title]" :resize F

     :panel PANEL1 :layout T :padx 100 :pady 5
     :layout V; :col-gap 10; :row-gap 10


   :panel PANEL2B :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10

   :panel PANEL2A :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10
       :vskip 20
       :message MSGEB  :label "Generate Events using TriggerMK2 Sync Trig" :bold T
       :hskip 30
       :button EBGO   :label "GO"     :w 8  :h 3 :colour green
       :button EBSTOP :label "STOP"   :w 8  :h 3 :colour red

   :panel PANEL2C :layout L :padx 5 :pady 5
     :layout V; :col-gap 10; :row-gap 10

   :panel PANEL3 :layout B :padx 5 :pady 5 :after FOOTER
     :layout H; :col-gap 10; :row-gap 10
      :next-row T
      :next-row T
      :next-row T
      :slider EVCNT :label "Number of events" :min 1 :max 10000 :resolution 1
      :layout V


   :panel BUTTONS :layout B :padx 5 :pady 5 :after FOOTER
     :layout H; :col-gap 10; :row-gap 10
      :next-row T
      :next-row T
      :button REDISPLAY   :label "Redisplay"       :command click-redisplay
      :hskip 70
      :button HELP        :command click-help

   :show T
}
 
