# vre.tcl     STR8080 control

#  11-07-95   VP   first version 

set debug 0
set started 0

set frame VRE
set frametitle "VRE (Struck 8080) Setup & Monitor"
set icontitle  VRE


for {set i 1} {$i <= 3} {incr i} {lappend defaultchanlist $i}; lappend defaultchanlist 15 47
set defaultchanlist {}

set cardtype VRE
set VXIGlobal ""
set chantype ""

set ServerOS "VxWorks"

set chanlist {???}
set chanindex 0

set mailtodspdata 0x0000
set mailfromdspdata 0x0000

set fwdirname      [file join $env(MIDASAPPLBASE) vre]
set fwprogname     "dsp-default.dmp"
set fwdfltprogname [file join $fwdirname $fwprogname]

set diagdirname  [file join $env(MIDASAPPLBASE) vre diag]
set diagfilename   ""

set dramoffset 0
set diagbufnum 1
set diagbufoffset 0

set diagmode 1
set diagctrl 1

set diagdata {}

#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL)     {channel          widget->channel   channel->widget        nil 
                     nil            nil           nil nil nil nil nil 1 nil}

set table(ENABLE-VXI)     {enableinput      logic-widget->param param->logic-widget "Enable_VXI"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(ENABLE-DT32)    {enableoutput     logic-widget->param param->logic-widget "Enable_DT32"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(ENABLE-ENL)    {enableevnuml    logic-widget->param param->logic-widget "Enable_EvNumL"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(ENABLE-ENH)    {enableevnumh     logic-widget->param param->logic-widget "Enable_EvNumH"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(RUN-DSP)    {rundsp        logic-widget->param param->logic-widget "Control.DSPrun"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(RUN-MODE)    {runmode        logic-widget->param param->logic-widget "DiagMode"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(MAIL-DSP)    {maildsp          logic-widget->param param->logic-widget "Status.DSP.NotReadMail"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(MAIL-VXI)    {mailvxi          logic-widget->param param->logic-widget "Status.VXI.NewMail"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(MAILOUT)     {mailout          int-widget->param param->hex-str-widget "Mail.FromDSP"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(DSPPROG)     {dspprog          int-widget->param param->str-widget     "DSPFile"
                     reg->param param->reg         "" nil nil nil nil 0 nil}

set table(STARTTOKEN)     {starttoken     hex-widget->param param->hex-widget "Start_Token"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(EVENTTOKENL)    {eventtokenl     hex-widget->param param->hex-widget "Event_TokenL"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(EVENTTOKENH)    {eventtokenh     hex-widget->param param->hex-widget "Event_TokenH"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(ENDTOKEN)       {endtoken     hex-widget->param param->hex-widget "End_Token"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}


set table(ROESCALER)    {roescaler     int-widget->param param->int-widget "ROErrors.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}
set table(VALSCALER)    {valscaler     int-widget->param param->int-widget "Val.Scaler"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(EVNUM)        {evnum     int-widget->param param->int-widget "EvNum"
                     int-reg->param param->int-reg "" nil nil nil nil 0 nil}

set table(MODELCODE)   {modcode          str-widget->param param->hex-widget     "VXI.ModelCode"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MANID)       {manid            str-widget->param param->hex-widget     "VXI.ManID"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(OFFSET)      {offset           str-widget->param param->hex-widget     "VXI.Offset"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(MODID)       {modid            logic-widget->param param->logic-widget "VXI.ModID"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(PASSED)      {passed           logic-widget->param param->logic-widget "VXI.Passed"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(READY)       {ready            logic-widget->param param->logic-widget "VXI.Ready"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(A24A32)      {a24a32           logic-widget->param param->logic-widget "VXI.A24A32"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(ADDRSPACE)   {addrspace        int-widget->param param->str-widget     "VXI.AddrSpace"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(DEVCLASS)    {devclass         int-widget->param param->str-widget     "VXI.DevClass"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(REQMEM)      {reqmem           int-widget->param param->str-widget     "VXI.ReqMem"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(LCAVERSYR)   {lcaversyr        int-widget->param param->str-widget     "LCA.Version.Year" 
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}
set table(LCAVERSWK)   {lcaverswk        int-widget->param param->str-widget     "LCA.Version.Week"
                     int-reg->param param->int-reg nil nil nil nil nil 0 nil}

#    register selection for parameter save function

set registersavepatterns {
   DSPFile
}

set xram_registers {
  {0 event_wordcount}
  {1 event_last_seq_fail}
  {2 sequencer_status}
  {3 word_count}
  {4 end_sub_event_token}
  {27 event_scaler}
  {6 token_count}
  {9 trace}
  {10 firmware_date_stamp}
  {26 seq_fail_scaler}
  {28 event_number}
  {12 event_nibble}
  {13 event_status}
  {14 event_validation}
  {16 this_event_number}
  {17 event_qualifiers}
  {18 mask_2byte}
  {19 mask_1byte}
  {20 clear_user_LED}
  {21 start_token}
  {22 event_tokenL}
  {23 event_tokenM}
  {24 end_token}
  {25 function_enables}
  {32 P3_sample_lsb}
  {33 P3_sample_msb}
  {36 P3_control}
  {38 P3_logic0_source}
  {39 P3_logic1_source}
  {40 P3_status}
  {43 delimiter}
  {44 event_sum}
  {45 diagnostic_mode}
  {46 diagnostic_control}
  {47 diagnostic_count}
}

set dsp_cmds {
  {0x1 copy XRAM to buffer}
  {0x2 load XRAM from buffer}
  {0x3 }
  {0x4 flush FIFOs}
  {0x20 exit Diag mode}
  {0x40 diag event mode}
  {0x41}
  {0x42}
  {0x43}
  {0x44}
  {0x45}
  {0x80 diag data mode}
  {0x81}
  {0x82}
  {0x83}
  {0x84}
  {0x85}
}


loadsource  common.vxi

proc read-vxi-reg {register} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister  /$resource/$cardtype$chan.$register
   EG "register :name '$VXIregister' ?value"
}

proc read-vxi-regs {register} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister  /$resource/$cardtype$chan.$register
   EG "register :pattern '$VXIregister' ?names-and-values"
}

proc write-vxi-reg {register value} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister /$resource/$cardtype$chan.$register
   EG "register :name '$VXIregister' :value '$value'"
}

proc write-vxi-regs {register value} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister /$resource/$cardtype$chan.$register
   EG "register :pattern '$VXIregister' :value '$value'"
}

proc init-vxi-reg {register} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister /$resource/$cardtype$chan.$register
   EG "register :name '$VXIregister' !initialise"
}

proc init-vxi-regs {register} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister /$resource/$cardtype$chan.$register
   EG "register :pattern '$VXIregister' !initialise"
}

proc redisplay {arg} {
   global ismapped
   if {!$ismapped} {return}
   global chanlist chanindex
   update-pairs [read-regs [lindex $chanlist $chanindex] "" $arg]
}

set ismapped 0

proc check-if-mapped {} {
    global ismapped
    set ismapped [:query_Mapped .]
}

#    called from vxicontrol 
#
proc vre-start {} {
  global started chanlist
  if {$started == 0} then {
    make-frame1
    set started 1
    close-frame
    make-chanlist
    make-myserver
  }
  return [llength $chanlist]
}

proc do-loadDSP {f} {
  global env
  global chanindex chanlist

#    This requires more work.
#    Currently the VxWorks systems are loaded from Unix and so
#    if we are controlling from Windows we need to convert the file
#    name to that as would be generated from Unix

  set f [Midas-Map-Filename $f]

  click-on RUN-DSP 0
  write-vxi-reg "DSPFile" $f
insert-log "loaded DSP program into VRE[lindex $chanlist $chanindex] from $f"
  click-on RUN-DSP 1
}

#    called from vxicontrol  proc DAQ-reset
#    act on single VRE or all dependent on contents of parameter 
#    

proc vre-initialise {} {

#      init-vxi-regs "*_Token*"
         init-vxi-reg   Start_Token
         init-vxi-reg   End_Token
         init-vxi-reg   Event_TokenH
         init-vxi-reg   Event_TokenL

#      write-vxi-regs "Enable_*" 0
         write-vxi-reg "Enable_DT32" 0
         write-vxi-reg "Enable_VXI" 0
         write-vxi-reg "Enable_EvNumH" 0
         write-vxi-reg "Enable_EvNumL" 0

#      write-vxi-regs "*.Scaler" 0
         write-vxi-reg "Val.Scaler" 0
         write-vxi-reg "ROErrors.Scaler" 0

         write-vxi-reg "EvNum" 0
}

proc vre-loadDSP {server} {
   global VXIServer myserver EGreport ismapped
   global fwdirname fwprogname
   global chanlist chanindex
#   insert-log "loading DSP code for VREs from [file join $fwdirname $fwprogname]"
   check-if-mapped
   set is $chanindex
   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}
   set chanindex 0
   foreach c $chanlist {
      make-myserver
      if {$server == "$VXIServer" || $server == $myserver} then {
         if {$ismapped} then {set-footer "loading DSP code for VRE$c"}

#    first load DSP code
         do-loadDSP [file join $fwdirname $fwprogname]

#    then initialise
         vre-initialise

#    and send command to DSP to action
         vre_cmd 2
      }
     incr chanindex
   }
   set chanindex $is
   set EGreport $EGreport_save
   make-myserver
   if {$ismapped} then {clear-footer}
#   do_update
}

proc vre-reloadDSP {server} {
   global VXIServer myserver EGreport ismapped
   global chanlist chanindex
#   insert-log "reloading DSP code for VREs"
   check-if-mapped
   set is $chanindex
   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}
   set chanindex 0
   foreach c $chanlist {
      make-myserver
      if {$server == "$VXIServer" || $server == $myserver} then {

         if {$ismapped} then {set-footer "reloading DSP code for VRE$c"}

	 set f [read-vxi-reg "DSPFile"]
         do-loadDSP $f

#    then initialise
         vre-initialise

#    and send command to DSP to action
         vre_cmd 2
      }
     incr chanindex
   }
   set chanindex $is
   set EGreport $EGreport_save
   make-myserver
   if {$ismapped} then {clear-footer}
}


#    called from vxicontrol  proc DAQ-flush
#    act on single VRE or all dependent on contents of parameter 
#    

proc vre-flushDSP {server} {
   global VXIServer myserver EGreport ismapped
   global chanlist chanindex
   check-if-mapped
   set is $chanindex
   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}
   set chanindex 0
   foreach c $chanlist {
      make-myserver
      if {$server == "$VXIServer" || $server == $myserver} then {

         vre-condloadDSP

         if {$ismapped} then {set-footer "flushing DSP code for VRE$c"}

#    first stop and restart the DSP code
         click-on RUN-DSP 0
#         write-vxi-reg "DSPFile" [read-vxi-reg "DSPFile"]
         click-on RUN-DSP 1

#    then initialise
         vre-initialise

#    and send command to DSP to action
         vre_cmd 2
      }
     incr chanindex
   }
   set chanindex $is
   set EGreport $EGreport_save
   make-myserver
   if {$ismapped} then {clear-footer}
}

#    called from vxicontrol  proc DAQ-Go
#    act on all VREs
# 
proc vre-enableDSP {} {
  global chanlist chanindex EGreport
   check-if-mapped
   set is $chanindex
   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}
   set chanindex 0
   foreach c $chanlist {
     make-myserver

      vre-condloadDSP

#     write-vxi-regs "Enable_*" 1
     write-vxi-reg "Enable_DT32" 1
     write-vxi-reg "Enable_VXI" 1
     write-vxi-reg "Enable_EvNumH" 1
     write-vxi-reg "Enable_EvNumL" 1

#    then send command to DSP to action
      vre_cmd 2
      incr chanindex
   }
   set chanindex $is
   set EGreport $EGreport_save
   make-myserver
#   do_update
}

#    called from vxicontrol  proc DAQ-halt 
#    act on all VREs
# 
proc vre-disableDSP {} {
  global chanlist chanindex EGreport
   check-if-mapped
   set is $chanindex
   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}
   set chanindex 0
   foreach c $chanlist {
      make-myserver

      vre-condloadDSP

#      write-vxi-regs "Enable_*" 0
      write-vxi-reg "Enable_DT32" 0
      write-vxi-reg "Enable_VXI" 0
      write-vxi-reg "Enable_EvNumH" 0
      write-vxi-reg "Enable_EvNumL" 0

#    then send command to DSP to action
      vre_cmd 2
      incr chanindex
   }
   set chanindex $is
   set EGreport $EGreport_save
   make-myserver
#   do_update
}

#    called from vxicontrol  proc DAQ-Go
#    act on all VREs
# 
proc vre-zero-counts {} {
  global chanlist chanindex EGreport
   check-if-mapped
   set is $chanindex
   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}
   set chanindex 0
   foreach c $chanlist {
      make-myserver

      vre-condloadDSP

#      write-vxi-regs "*.Scaler" 0
      write-vxi-reg "Val.Scaler" 0
      write-vxi-reg "ROErrors.Scaler" 0

      write-vxi-reg "EvNum" 0

#    then send command to DSP to action
      vre_cmd 2
      incr chanindex
   }
   set chanindex $is
   set EGreport $EGreport_save
   make-myserver
#   do_update
}

#    end of procedures used by vxicontrol


proc vre-condloadDSP {} {
   global EGreport ismapped
   global fwdirname fwprogname
   global chanindex chanlist

#    load firmware into the current VRE if not alreading in the RUN state

#   perform a check that the DSP is running
   if {[read-vxi-reg Control.DSPrun] != 0} then {return}

   set EGreport_save $EGreport
   if {$EGreport <= 0} then {set EGreport -1}

   if {$ismapped} then {set-footer "loading DSP code for VRE[lindex $chanlist $chanindex]"}

#    first load DSP code
   do-loadDSP [file join $fwdirname $fwprogname]

#    then initialise
   vre-initialise

#    and send command to DSP to action
    vre_cmd 2

   set EGreport $EGreport_save
   if {$ismapped} then {clear-footer}
}

proc vre_cmd {v} {
#    send command v to the VRE software
   global debug ismapped myserver
   if {$debug} then {insert-debug "called proc vre_cmd with argument \{$v\}"}

#    first write the command to the DSP mailbox
   write-vxi-reg "Mail.ToDSP" $v
#   if {$ismapped} {:modify MAILIN :value $v}
#    next check that it has been accepted - by the time we get to asking
#    the DSP should long before taken the mail
   set s [read-vxi-reg  "Status.DSP.NotReadMail"]
#   if {$ismapped} {:modify MAIL-DSP :value $s}
   if {$s != 0} then {midas-warning "DSP is not responding!"}
#    next check that the DSP has replied
   set s [read-vxi-reg "Status.VXI.NewMail"]
#   if {$ismapped} {:modify MAIL-VXI :value $s}
   if {$s == 0} then {midas-warning "DSP is not replying!"}
#    and check reply is OK
   set r [read-vxi-reg "Mail.FromDSP"]
#   if {$ismapped} {:modify MAILOUT :value $r}
   if {[expr $r] != [expr $v]} then \
      {midas-warning "DSP has rejected command - probably bad command"}
#   if {$ismapped} {redisplay "Status.*"}
}

proc click-reset {} {
   global debug
   if {$debug} then {insert-debug "called proc click-reset"}
   write-vxi-reg "VXI.Reset" 1
   redisplay "Control.*"
}

proc click-loadDSP {f} {
   global debug
   if {$debug} then {insert-debug "called proc click-loadDSP with argument \{$f\}"}
   do-loadDSP $f
}

proc click-DSPinit {} {
   global debug
   if {$debug} then {insert-debug "called proc click-DSPinit"}
   vre-condloadDSP
   init-vxi-regs "*_Token*"
   init-vxi-regs "Enable_*"
#    then send command to DSP to action
   vre_cmd 2
#    and finally an update
#   do_update
}

proc click-zero-counts {} {
   global debug
   if {$debug} then {insert-debug "called proc click-zero-counts"}
   vre-condloadDSP
   write-vxi-regs "*.Scaler" 0
   write-vxi-reg "EvNum" 0
#    then send command to DSP to action
   vre_cmd 2
#    and finally an update
   do_update
   vre_cmd 2
   redisplay  "*.Scaler"
   redisplay  "EvNum"
}

proc click-mailfromDSP {} {
   global debug
   if {$debug} then {insert-debug "called proc click-mailfromDSP"}
   redisplay "Mail.FromDSP"
   redisplay "Status.*"
}

proc do_update {} {
   global chanlist chanindex
   global redisplay ismapped
   if {[llength $chanlist] == 0} then {return}
   vre-condloadDSP
   if {!$ismapped} {return}
#    first get DSP to update RAM
   vre_cmd 1
#    now update display
   set list [read-regs [lindex $chanlist $chanindex] "" *]
   set redisplay $list
   update-pairs $list
   redisplay-OpMode
}

proc click-enable {w v} {
#    perform default click-on actions
   vre-condloadDSP
   click-on $w $v
#    then send command to DSP to action
   vre_cmd 2
#    and finally an update
#   do_update
}

proc click-enable-DSP v {
#    perform DSP enable/disable action
   click-on RUN-DSP $v
}

proc click-diagnostics {} {
#   display diagnostics sub frame
  global diagvisible diagframe
  if {$diagvisible == 0} then {make-diags} else {open-frame $diagframe}
  click-diagredisplay
}

proc click-diagctrl v {
#    diagnostic mode control
  global debug diagmode diagbufnum
  if {$debug} then {insert-debug "called proc click-diagctrl with argument $v"}
  switch $v {
    0   {vre_cmd [expr [expr $diagmode + 1] * 0x40]}
    1   {vre_cmd 0x20}
    2   {vre_cmd [expr [expr [expr $diagmode + 1] * 0x40] + $diagbufnum]}
  }
  redisplay-OpMode
  :modify DIAGCTRL :value 7
}

proc display_xram {} {
  global xram_registers
#    empty display
   :modify XRAMLIST :empty T
#    first comamnd 1 to take a copy of the X RAM
   vre_cmd 1
   foreach item $xram_registers {
      set offset [expr [first $item] * 4]
      set function [second $item]
#    set offset attribute for this word
      write-vxi-attrib "CtrlRAM" "-o $offset"
#    and read it
      set vl [read-vxi-reg "CtrlRAM"]
#    and add to display
     set l "[format "%24s %16s" $function $vl] \n"
     :modify XRAMLIST :strings "$l"
   }
}

proc display_dataram {} {
   global dramoffset

#    empty display
   :modify XRAMLIST :empty T \
      :strings "Data RAM display starting at word offset $dramoffset for 80 words\n\n"
   set offset $dramoffset
#    do a block read for 80 words
   write-vxi-attrib DataRAM.DataAccess "-o [expr $offset * 4] -l 80"
   set DataRAM [read-vxi-reg DataRAM.DataAccess]

#
# Modify for dumped - SBG TEAM
#

    set next_event_is_a_number 0

    for {set i 0} {$i < 80} {incr i} {
       
# add the number of the line
       :modify XRAMLIST :strings "[format "%2s" $i]"

# add the hexa value
       set vl [lindex $DataRAM  [expr $i]]
       :modify XRAMLIST :strings "[format "%12s" $vl]"
       
# decode the value
       if {$vl == 0xaa55aa55} then { 
# delimitor
	   set next_event_is_a_number 1
	   :modify XRAMLIST :strings "\t\t\t\t--------------"   
       } elseif {$next_event_is_a_number == 1} then {
# event number
	   set next_event_is_a_number 0
	   set nb [expr $vl >> 12 & 15]
	   :modify XRAMLIST :strings "[format "\t\t\t\tCounter : %s" $nb]"
       } else {
# data
	   set group [expr $vl >> 16 & 255]
           set item  [expr $vl >> 24 & 63]
           set qbits [expr $vl >> 30 & 3]
           set data  [expr $vl & 0x0000ffff]
           set title "Unknown"
	   if {$group <= 0} then {
               set title "illegal"
           } elseif {$group <= 20} then {
#               Euroball III cards (Cluster)
	       set detector [expr $group - 1]
	       switch $item {
		   0   {set title "Cluster$detector.GeA.20MeV"}
		   1   {set title "Cluster$detector.GeA.4MeV"}
		   2   {set title "Cluster$detector.GeA.FT"}
		   3   {set title "Cluster$detector.GeB.20MeV"}
		   4   {set title "Cluster$detector.GeB.4MeV"}
		   5   {set title "Cluster$detector.GeB.FT"}
		   6   {set title "Cluster$detector.GeC.20MeV"}
		   7   {set title "Cluster$detector.GeC.4MeV"}
		   8   {set title "Cluster$detector.GeC.FT"}
		   9   {set title "Cluster$detector.GeD.20MeV"}
		   10  {set title "Cluster$detector.GeD.4MeV"}
		   11  {set title "Cluster$detector.GeD.FT"}
		   12  {set title "Cluster$detector.GeE.20MeV"}
		   13  {set title "Cluster$detector.GeE.4MeV"}
		   14  {set title "Cluster$detector.GeE.FT"}
		   15  {set title "Cluster$detector.GeF.20MeV"}
		   16  {set title "Cluster$detector.GeF.4MeV"}
		   17  {set title "Cluster$detector.GeF.FT"}
		   18  {set title "Cluster$detector.GeG.20MeV"}
		   19  {set title "Cluster$detector.GeG.4MeV"}
		   20  {set title "Cluster$detector.GeG.FT"}
		   21  {set title "Cluster$detector.BGOSum.Energy"}
		   22  {set title "Cluster$detector.BGOSum.TAC"}
		   23  {set title "Cluster$detector.BGO.Pattern.High"}
		   24  {set title "Cluster$detector.BGO.Pattern.Low"}
		   25  {set title "Cluster$detector.BGOA.Energy"}
		   26  {set title "Cluster$detector.BGOA.TAC"}
		   27  {set title "Cluster$detector.BGOB.Energy"}
		   28  {set title "Cluster$detector.BGOB.TAC"}
		   29  {set title "Cluster$detector.BGOC.Energy"}
		   30  {set title "Cluster$detector.BGOC.TAC"}
		   31  {set title "Cluster$detector.BGOD.Energy"}
		   32  {set title "Cluster$detector.BGOD.TAC"}
		   33  {set title "Cluster$detector.BGOE.Energy"}
		   34  {set title "Cluster$detector.BGOE.TAC"}
		   35  {set title "Cluster$detector.BGOF.Energy"}
		   36  {set title "Cluster$detector.BGOF.TAC"}
		   37  {set title "Cluster$detector.BGOG.Energy"}
		   38  {set title "Cluster$detector.BGOG.TAC"}
		   39  {set title "Cluster$detector.BGOH.Energy"}
		   40  {set title "Cluster$detector.BGOH.TAC"}
		   41  {set title "Cluster$detector.BGOI.Energy"}
		   42  {set title "Cluster$detector.BGOI.TAC"}
		   43  {set title "Cluster$detector.BGOJ.Energy"}
		   44  {set title "Cluster$detector.BGOJ.TAC"}
		   45  {set title "Cluster$detector.BGOK.Energy"}
		   46  {set title "Cluster$detector.BGOK.TAC"}
		   47  {set title "Cluster$detector.BGOL.Energy"}
		   48  {set title "Cluster$detector.BGOL.TAC"}
		   49  {set title "Cluster$detector.BGOM.Energy"}
		   50  {set title "Cluster$detector.BGOM.TAC"}
		   51  {set title "Cluster$detector.BGON.Energy"}
		   52  {set title "Cluster$detector.BGON.TAC"}
		   53  {set title "Cluster$detector.BGOO.Energy"}
		   54  {set title "Cluster$detector.BGOO.TAC"}
		   55  {set title "Cluster$detector.BGOP.Energy"}
		   56  {set title "Cluster$detector.BGOP.TAC"}
		   57  {set title "Cluster$detector.BGOQ.Energy"}
		   58  {set title "Cluster$detector.BGOQ.TAC"}
		   59  {set title "Cluster$detector.BGOR.Energy"}
		   60  {set title "Cluster$detector.BGOR.TAC"}
		   62  {set title "Cluster$detector.Ge.GIR.EvNum"}
		   61  {set title "Cluster$detector.BGO.GIR.EvNum"}
		   default  {}
	       }
	   } elseif {$group <= 50} then {
#               Eurogam II cards (Clover)
	       set detector [expr $group - 21]
	       switch $item {
		   0   {}
		   1   {}
		   2   {}
		   3   {}
		   4   {set title "Clover$detector.BGO.Energy"}
		   5   {set title "Clover$detector.BGO.TAC"}
		   6   {set title "Clover$detector.BGO.Pattern"}
		   7   {}
		   8   {set title "Clover$detector.GeA.20MeV"}
		   9   {set title "Clover$detector.GeA.4MeV"}
		   10  {set title "Clover$detector.GeA.FT"}
		   11  {set title "Clover$detector.GeA.CO"}
		   12  {set title "Clover$detector.GeB.20Mev"}
		   13  {set title "Clover$detector.GeB.4MeV"}
		   14  {set title "Clover$detector.GeB.FT"}
		   15  {set title "Clover$detector.GeB.CO"}
		   16  {set title "Clover$detector.GeC.20MeV"}
		   17  {set title "Clover$detector.GeC.4MeV"}
		   18  {set title "Clover$detector.GeC.FT"}
		   19  {set title "Clover$detector.GeC.CO"}
		   20  {set title "Clover$detector.GeD.20MeV"}
		   21  {set title "Clover$detector.GeD.4MeV"}
		   22  {set title "Clover$detector.GeD.FT"}
		   23  {set title "Clover$detector.GeD.CO"}
		   default  {}
	       }	
           } elseif {$group <= 90} then {
#               Eurogam I cards  (Ge and BGO)
	       set detector [expr $group - 51]
	       switch $item {
		   0   {set title "Ge$detector.20MeV"}
		   1   {set title "Ge$detector.4MeV"}
		   2   {set title "Ge$detector.FT"}
		   3   {set title "Ge$detector.CO"}
		   4   {set title "BGO$detector.Energy"}
		   5   {set title "BGO$detector.TAC"}
		   6   {set title "BGO$detector.Pattern"}
		   default  {}
	       }  
           } elseif {$group <109} then {
#               BGO inner ball detectors
               set detector [expr $group - 91]
	       switch $item {
		   0   {set title "BGOBall$detector.Energy"}
		   1   {set title "BGOBall$detector.Pattern"}
		   2   {set title "BGOBall$detector.TAC"}
		   default  {}
	       }
           } elseif {$group <230} then {
#               ancillary detectors
               set detector [expr $group - 112]
               set title "Ancillary$detector.item$item"
	   } elseif {$group == 246} then {
#               trigger
	       switch $item {
		   0   {set title "MasterTrigger.SumBus1"}
		   1   {set title "MasterTrigger.SumBus2"}
		   2   {set title "MasterTrigger.SumBus3"}
		   3   {set title "MasterTrigger.SumBus4"}
		   4   {set title "MasterTrigger.TAC"}
		   5   {set title "MasterTrigger.Pattern"}
		   6   {set title "MasterTrigger.EvNumLSB"}
		   7   {set title "MasterTrigger.EvNumMSB"}
		   default  {}
	       }
           } else {
#               VRE + other diagnostics
	       set title "diagnostic"
           }
           :modify XRAMLIST :strings "[format  "%3d %3d %4d %6x\t%s" $qbits $item $group $data $title]"




        }
   :modify XRAMLIST :strings "\n"
   } 
# end for
   :modify XRAMLIST :see 0       
   }

#    procedures to display, set and zero the repeat counters

proc display_rptcounters {} {
   for {set i 1} {$i <= 5} {incr i} {
      :modify RPTCNT$i :value [read-vxi-reg "RptCount$i"]
   }
}

proc click-rptcounter {w v} {
  set c [string trim $w RPTCNT]
  write-vxi-reg "RptCount$c" $v
  display_rptcounters
}

proc zero_rptcounters {} {
  write-vxi-regs "RptCount?" 0
  display_rptcounters
}

#    procedures to redisplay    the current diagnostic buffer

proc display_diagbuf {} {
   global diagbufnum diagbufoffset
   if {$diagbufoffset == 0} then {
#   get first word of buffer which may be the length
#   set offset attribute for this word
       write-vxi-attrib "DiagBuf$diagbufnum" "-o 0"
#   and read it
       set vl [expr [read-vxi-reg "DiagBuf$diagbufnum"] + 1]
       if {$vl > 64} then {set vl 64}
       set rows [expr [expr $vl + 3] / 4]
   } else {
       set rows 16
       set vl 64
   }
#    empty display
   :modify XRAMLIST :empty T \
      :strings "Diagnostic Buffer $diagbufnum display starting at offset $diagbufoffset for $vl words\n\n"
   set offset $diagbufoffset
   for {set i 0} {$i < $rows} {incr i} {
      :modify XRAMLIST :strings "[format "%8s" $offset]"
      for {set j 0} {$j < 4} {incr j} {
#   set offset attribute for this word
        write-vxi-attrib "DiagBuf$diagbufnum" "-o [expr $offset * 4]"
#   and read it
        set vl [read-vxi-reg "DiagBuf$diagbufnum"]
#    and add to display
        :modify XRAMLIST :strings "[format "%12s" $vl]"
        incr offset
      }
   :modify XRAMLIST :strings "\n"
   }
}

#    procedures to handle access to the diagnostic data files

proc click-diag-dirname name {
   global diagdirname diagfilename
   set diagdirname $name
   set diagfilename ""
   diag-paint-directory
   diag-repaint
}

proc click-diag-filename name {
   global diagdirname diagfilename 
   set diagfilename $name
   diag-repaint          
   if {$name != "" && [file isdirectory [file join $diagdirname $name]]} then {
      click-diag-dirname [file join $diagdirname $name]
   }
} 

proc click-diag-list {c file} {

   switch $c {
      :list-select   {click-diag-filename $file}
      :list-deselect {click-diag-filename ""}
   }
}
            
proc diag-repaint {} {
   global diagdirname diagfilename 
     :modify DIAGDIR  :value "$diagdirname"
     :modify DIAGFILE :value "$diagfilename"
}

proc diag-paint-directory {} {
   global diagdirname
   set m [EG "directory :path '$diagdirname' ?files"]
   set dirlist [lsort [strip-dots [make-list $m]]]
   :modify DIAGLIST :empty T :strings [make-list $dirlist]
}

#    procedure to read the diagnostic data file into the scratchpad window

proc click-diag-loaddata {} {
   global diagdirname diagfilename diagdata
   set f [open [file join $diagdirname $diagfilename] r]
   set diagdata [read $f]
   close $f

#    empty display
   :modify XRAMLIST :empty T \
      :strings "Data File [file join $diagdirname $diagfilename] \n\n  "
   set c 0
   foreach word $diagdata {
#    and add to display
      :modify XRAMLIST :strings "[format "%12s" $word]"
      incr c
      if {$c == 5} then {:modify XRAMLIST :strings "\n  "; set c 0}
   }
}

#   procedure to load the current diagnostic buffer

proc click-diag-loadbuf {} {
   global EGreport diagframe
   global diagbufnum diagbufoffset diagdata
#   write the data
   :modify $diagframe :busy T
   set EGreport_save $EGreport
   set EGreport -1
   set offset 1
   foreach word $diagdata {
#   set offset attribute for this word
      write-vxi-attrib "DiagBuf$diagbufnum" "-o [expr $offset * 4]"
#   and write it
      write-vxi-reg "DiagBuf$diagbufnum" $word
      incr offset
   }
#   write the word count
   set word [expr $offset - 1]
#   set offset attribute for this word
   write-vxi-attrib "DiagBuf$diagbufnum" "-o 0"
#   and write it
   write-vxi-reg "DiagBuf$diagbufnum" $word
   set EGreport $EGreport_save
   :modify $diagframe :busy F
}

proc redisplay-OpMode {} {

  vre_cmd 1
  set mode [read-vxi-reg DiagMode]
  eval :modify [param->logic-widget RUN-MODE $mode ""]
  catch {eval :modify [param->logic-widget DIAGRUN-MODE $mode ""]}
}

proc click-redisplay {} {

   fw-paint-directory
   fw-repaint
   do_update
} 

proc click-diagredisplay {} {
  global dramoffset diagbufnum

  diag-repaint
  diag-paint-directory
  display_rptcounters
  redisplay-OpMode

  :modify DRAMOFFSET :value $dramoffset
  :modify DIAGBUF :value [expr $diagbufnum - 1]
}

proc start args {
   global  started
   if {$started == 0} then {make-frame1}
   set started 1
   open-frame
   check-if-mapped
   make-chanlist
   make-myserver
   click-redisplay
}

proc click arg {
   global debug
   global fwprogname fwdirname fwdfltprogname
   global dramoffset diagbufnum diagbufoffset
   global diagmode

   if {$debug} then {insert-debug "called proc click with argument \{$arg\}"}

   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {return [click-quit $f]}

   check-if-mapped

   switch -glob $w {
      CHANNEL     {click-channel $v}
      MAILIN      {vre_cmd $v; do_update}
      MAILCMD     {vre_cmd [first $v]; do_update}
      MAILRD      {click-mailfromDSP}
      FWPROG      {click-fw-progname $v}
      FWDIR       {click-fw-dirname $v}
      FWLIST      {click-fw-list $c $v}
      DSPLOAD     {click-loadDSP [file join $fwdirname $fwprogname]; do_update}
      DSPFLTLOAD  {click-loadDSP $fwdfltprogname; do_update}
      DSPINIT     {click-DSPinit; do_update}
      ZERO        {click-zero-counts}
      REDISPLAY   {click-redisplay}
      RESET       {click-reset; do_update}
      *HELP       {display-help vre}
      ENGINEERING  {click-$v}
      DIAG        {click-diagnostics}
      DIAGDIR     {click-diag-dirname $v}
      DIAGFILE    {click-diag-filename $v}
      DIAGLIST    {click-diag-list $c $v}
      DIAGREDISPLAY {click-diagredisplay; do_update}
      DIAGBUF     {set diagbufnum [expr $v + 1]}
      DIAGBUFOFFSET {set diagbufoffset $v}
      SHOWDIAGBUF {display_diagbuf}
      LOADDIAGDATA {click-diag-loaddata}
      LOADDIAGBUF {click-diag-loadbuf}
      DIAGMODE    {set diagmode $v}
      DIAGCTRL    {click-diagctrl $v; do_update}
      RPTZERO     {zero_rptcounters}
      RPTCNT*     {click-rptcounter $w $v}
      XRAM        {display_xram}
      DRAM        {display_dataram}
      SCALERRAM   {display_scalerram}
      CLEARSCALERS {click-clear-scalerram}
      DRAMOFFSET  {set dramoffset $v}
      RUN-DSP     {click-enable-DSP $v}
      ENABLE-*    {click-enable $w $v; do_update}
      default     {insert-debug "called proc click with argument \{$arg\}"}
   }
}

global electronicsframe
set electronicsframe "[self frame-name].electronics"
set electronicsvisible 0

global diagframe
set diagframe "[self frame-name].diag"
set diagvisible 0

proc make-frame1 {} {
   global env started
   global chanlist mailtodspdata mailfromdspdata fwprogname fwdirname
   global dsp_cmds

 :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]"

    :panel PANEL1 :layout T :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 20
      :choice-stack CHANNEL :label "VRE Number:" :valuex 15c :strings [quote-list $chanlist]
      :next-row T

      :message  M1           :label "Control:--" :bold T
      :hskip 25
      :checkbox RUN-DSP      :label "DSP Run:"
      :hskip 50
      :choice   RUN-MODE   :label "Operation Mode:"  :strings [list Normal Diagnostic] :deaf T

      :next-row T
      :col-gap 10
      :message  M11           :label "Enables:--" :bold T
      :checkbox ENABLE-VXI    :label "Input (VXI):"
      :checkbox ENABLE-DT32   :label "Output (DT32):"
      :checkbox ENABLE-ENL    :label "EvNum LSB:"
      :checkbox ENABLE-ENH    :label "EvNum MSB:"

      :next-row T
      :message  M2        :label "DSP Mail:--" :bold T
      :row-gap 0; :col-gap 0
      :next-row T
      :text MAILIN        :label "Mail to DSP:"    :w 8  :value $mailtodspdata :valuex 20c
      :col-gap 0
      :menubutton MAILCMD :label " " :strings $dsp_cmds
      :hskip 35
      :checkbox MAIL-DSP  :label "DSP Mailbox not empty:" :deaf T

      :row-gap 5
      :next-row T
      :text MAILOUT  :label "Mail from DSP:" :w 8 :deaf T :value $mailfromdspdata :valuex 20c
      :col-gap 0
      :button MAILRD      :label "read"
      :hskip 25
      :checkbox MAIL-VXI  :label "VXI Mailbox not empty:" :deaf T

    :panel PANEL2A :layout L :padx 5
     :layout V; :row-gap 5; :col-gap 10
      :message M3          :label "DSP Program:--" :bold T
      :text FWDIR      :label "Directory:" :w 25  :value $fwdirname :valuex 20c
      :text FWPROG     :label "File name:"  :w 25  :value $fwprogname :valuex 20c

    :panel PANEL2B :layout R :padx 5
      :list FWLIST :rows 5 :cols 20

    :panel PANEL3 :layout B :after FOOTER :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 10

      :button DSPLOAD      :label "load"
      :button DSPFLTLOAD   :label "load default"
      :button DSPINIT      :label "Initialise"
      :text DSPPROG        :label "Current Program File:" :w 25 :deaf T :shifters T

      :next-row T
      :vskip 10
      :message M4        :label   "Counts & Scalers:--        " :bold T
      :hskip 60
      :button ZERO  :label "Zero"
      :next-row T
      :text EVNUM        :label "EvNum Counter:"  :deaf T   :w 10
      :text VALSCALER    :label "Val Scaler:"     :deaf T   :w 10
      :text ROESCALER    :label "VXI Readout Errors:"    :deaf T   :w 10

      :next-row T
      :message M5       :label "DT32bus Tokens:--" :bold T
      :next-row T
      :text STARTTOKEN  :label "Start:"        :deaf T  :w 10
      :text EVENTTOKENH :label "EvNum (MSB):"  :deaf T  :w 10
      :text EVENTTOKENL :label "(LSB):"        :deaf T  :w 10
      :text ENDTOKEN    :label "End:"          :deaf T  :w 10

      :row-gap 10
      :next-row T
      :button REDISPLAY :label Redisplay
      :button RESET     :label Reset :inactive T
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics software]
      :button DIAG      :label "Diagnostics"
      :hskip 80
      :button HELP :label Help...

}


proc make-electronics {} {
  global env electronicsframe electronicsvisible

  :frame $electronicsframe :label "VRE Electronics" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5
      :text MANID     :deaf T  :label "Manufacturer ID:" :w 6 :read-only T :valuex 20c
      :text ADDRSPACE :deaf T  :label "Address Space:"   :w 6 :read-only T :valuex 20c

      :next-row T
      :text MODELCODE :deaf T  :label "Model Code:"    :w 6 :read-only T :valuex 20c
      :text DEVCLASS  :deaf T  :label "Device Class:"  :w 6 :read-only T :valuex 20c

      :next-row T
      :text REQMEM   :deaf T   :label "Memory Required:"    :w 6 :read-only T :valuex 20c
      :text OFFSET   :deaf T   :label "VXI Offset:"         :w 6 :read-only T :valuex 20c

      :next-row T
      :text LCAVERSYR    :deaf T  :label "LCA Version (year) :"    :w 6 :read-only T :valuex 20c
      :text LCAVERSWK    :deaf T  :label "LCA Version (week) :"    :w 6 :read-only T :valuex 20c

      :next-row T
      :col-gap 30
      :checkbox PASSED  :deaf T   :label "VXI Passed:"
      :checkbox READY   :deaf T   :label "VXI Ready:"
      :checkbox MODID   :deaf T   :label "VXI ModID:"
      :checkbox A24A32  :deaf T   :label "VXI A32:"

  :show T
  set electronicsvisible 1
}


proc make-diags {} {
  global env diagframe diagvisible diagmode

  :frame $diagframe :label "VRE Test & Diagnostic Control" :show-footer T :resize F :transient T 

  :panel PANEL1 :layout T :padx 5 :pady 5

    :galley XRAMLIST :rows 30 :cols 50 :deaf T :strings ""  :font fixed

  :panel PANEL2 :layout T :padx 5
    :layout H; :row-gap 5

    :message RPTCNT :label "Repeat Counters" :bold T
    :hskip 30
    :button RPTZERO :label "Zero all"
    :hskip 50
    :choice   DIAGRUN-MODE     :label "Operation Mode:"  :strings [list Normal Diagnostic] :deaf T
    :next-row T
    :text RPTCNT1 :label "#1" :w 12 
    :text RPTCNT2 :label "#2" :w 12
    :text RPTCNT3 :label "#3" :w 12 
    :text RPTCNT4 :label "#4" :w 12 
    :text RPTCNT5 :label "#5" :w 12 

  :panel PANEL3 :layout T :padx 5
    :layout H; :row-gap 5; :col-gap 10
    :vskip 5

    :choice-stack DIAGBUF :label "Current Diagnostic Buffer" \
         :strings [list #1 #2 #3 #4 #5]
    :text DIAGBUFOFFSET :label "Buffer Offset (word)" :w 6
    :button SHOWDIAGBUF   :label "Show Buffer"

    :next-row T
    :message DIAGM1 :label "Diagnostic Data File:--" :bold T
    :hskip 120
    :list DIAGLIST :rows 5 :cols 20
    :vskip -70

    :next-row T
    :text DIAGDIR  :label "Directory:"  :w 18 :valuex 20c
    :next-row T
    :text DIAGFILE :label "File name:"  :w 18 :valuex 20c
    :vskip 20

    :next-row T
    :button LOADDIAGDATA   :label "Load Scratch Pad from Data File"
    :button LOADDIAGBUF    :label "Copy Scratch Pad to Diagnostic Buffer"

  :panel PANEL4 :layout T :padx 5
    :layout H; :col-gap 20; :row-gap 10
    :vskip 5

    :text DRAMOFFSET :label "DataRAM Offset (word)" :w 6
    :button DRAM       :label "Show DataRAM"
    :button XRAM       :label "Show XRAM"
    :next-row T
    :button SCALERRAM  :label "Show Scalers"
    :button CLEARSCALERS :label "Clear Scalers"
    :next-row T; :col-gap 10
    :choice DIAGMODE :label "Diagnostic Mode"  :strings [list "Whole Event" "Data Insert"] \
        :exclusive T :value $diagmode
    :choice DIAGCTRL :label "Diagnostic Control" :strings [list "Run" "Halt" "Insert Buffer"] :value 7 :exclusive T

  :panel BUTTONS :padx 10 :layout B :after FOOTER
    :layout H; :col-gap 10
    :vskip 5

    :button DIAGREDISPLAY  :label Redisplay
    :hskip 100
    :button DIAGHELP  :label "Help..."


  :show T
  set diagvisible 1
}


#    procedures for the  scalers area  - Oct 15 1998

# commented out Vic's test list for {set i 0} {$i < 64} {incr i 2} {set ScalerName($i) "Scaler # $i"}
# the following list is for eb111197_in_scaler Oct 15 1998
set ScalerName(0)	"dt32_wait_scaler"
set ScalerName(1)	"loopy_scaler" 		
#equ	$FC01	; scaler for the number of times round the loopy loop.
set ScalerName(2)	"flag_register"		
#equ	$fc02	; store the flag register in loopy !
set ScalerName(3)	"nospace_scaler"	
#equ	$fc03	; count the number of times the input gets full.
set ScalerName(4)	"timer_scaler"		
#equ	$fc04	; count the number of times we time out on the sequencer.
set ScalerName(5)	"soft_scaler"		
#equ	$fc05	; count the number of times we get a software error.
set ScalerName(6)	"irq_pend_scaler"	
#equ	$fc06	; count the number of times we find a sequencer irq pending.
set ScalerName(7)	"mail_scaler"		
#equ	$fc07	; count the times round the mail box routine.
set ScalerName(8)	"mail_status_scaler"	
#equ	$fc08	; the status register when the mail IN flag is set
set ScalerName(9)	"seq_out_scaler"	
#equ	$fc09	; the OUT flag is set in A_STATUS !
set ScalerName(10)	"flush_scaler"		
#equ	$fc0a	; every time we go through the flush routine.
set ScalerName(11)	"stack_register"	
#equ	$fc0b	; store the stack pointer at various stages in the game ?
set ScalerName(12)	"ev_max_scaler"		
#equ	$fc0c
set ScalerName(13)	"inhibit_fail"		
#equ	$fc0d
set ScalerName(14)	"inhibit_value"		
#equ	$fc0e
set ScalerName(15)	"inhibit_failv"		
#equ	$fc0f
set ScalerName(16)	"inhibit_valuev"	
#equ	$fc10
set ScalerName(17)	"in_scaler"		
#equ	$fc11	; count the number of validation interrupts !
set ScalerName(18)	"dt32_control_store"	
#equ	$fc12
set ScalerName(19)	"dt32_fifo_status"	
#equ	$fc13
set ScalerName(20)	"dt32_A_STATUS"	
#equ	$fc14
set ScalerName(32)	"stack_start"		
#equ	$fc20	; try and store the PC values from the stack

proc display_scalerram {} {
   global ScalerName
#    empty display
   :modify XRAMLIST :empty T :strings "Scaler RAM display updated [date]\n\n"
   set ScalerRAM [read-vxi-reg ScalerRAM.DataAccess]
   for {set i 0} {$i < 64} {incr i} {
      if {[info exists ScalerName($i)]} then {
          set name $ScalerName($i)
          set value [lindex $ScalerRAM $i]
          :modify XRAMLIST :strings "[format "%35s   0x%08x %12d" $name $value $value]\n"
      }
   }
   :modify XRAMLIST :strings "\n" :see 0
}

proc click-clear-scalerram {} {init-vxi-reg ScalerRAM.DataAccess}
