#    definitions used by the BGOBALL VXI setup tasks
#


set chanlist {???}
set chanindex 0

set segindex -1

set defaultchanlist {0 1 2 3 4 5 6 7}

set cardtype BgoBall
set VXIGlobal ""

#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Disable" 
   not-reg->param param->not-reg nil :checkbox nil nil nil 1 "Enable"}

set table(VETOWIDTH) {vetowidth slider-widget->param param->int-widget "Veto.Width" 
   unit-reg->param param->unit-reg ns :slider 0 1000 4 1 "Veto Width (ns)"}
set table(DTWIDTH) {dtwidth slider-widget->param param->int-widget "DT.Width" 
   unit-reg->param param->unit-reg ns :slider 0 20000 71 1 "Dead Time Width (ns)"}
set table(SUMWIDTH) {sumwidth slider-widget->param param->int-widget "Sum.Width" 
   unit-reg->param param->unit-reg ns :slider 0 1000 4 1 "Sum Width (ns)"}
set table(FTSAMPLE) {ftsample slider-widget->param param->int-widget "FTSample" 
   unit-reg->param param->unit-reg ns :slider 0 2000 8 1 "Fast Trigger Sample (ns)"}
set table(PDSGATE) {pdsgate slider-widget->param param->int-widget "PDSGate" 
   unit-reg->param param->unit-reg ns :slider 0 10000 40 1 "PDS Gate (ns)"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "ValSample" 
   unit-reg->param param->unit-reg ns :slider 0 10000 40 1 "Validation Sample (ns)"}

set table(PATTERNRO) {patternro int-widget->param param->int-widget "Pattern.ROEnable" 
   int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Pattern"}
set table(TACRO) {tacro int-widget->param param->int-widget "TAC.ROEnable" 
   int-reg->param param->int-reg nil :checkbox nil nil nil 1 "TAC"}
set table(ENERGYRO) {energyro int-widget->param param->int-widget "Energy.ROEnable" 
   int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Energy"}


#    Inspection line configuration  -  this format is ONLY for Eurogam modules

set AI-Configuration [list Disconnected                           \
   "a.Input" "b.Input" "c.Input" "d.Input" "e.Input"              \
   "f.Input" "g.Input" "h.Input" "i.Input" "j.Input"              \
   "a.LineRec" "b.LineRec" "c.LineRec" "d.LineRec" "e.LineRec"    \
   "f.LineRec" "g.LineRec" "h.LineRec" "i.LineRec" "j.LineRec"    \
   "ShFilter" "PeakDet" "TAC" "TestGen"                           \
]

set DI-Configuration [list Disconnected                   \
   FT FTSample ValSample ValAck PDSGate Veto TACStart     \
]


set readoutitems {PATTERNRO TACRO ENERGYRO}

set channelitems {VETOWIDTH DTWIDTH SUMWIDTH FTSAMPLE VALSAMPLE PDSGATE}

set segmentitems {ENABLE}


set info(CARD) " From this window you can setup the electronics for the BgoBall detector VXI electronics.\n\
                Each VXI card contains 6 electronics channels but only the first 4 are normally connected\
                to BgoBall elements."
