#    definitions used by the Saphir VXI setup tasks
#
#    This card type is not used for segmented detectors



set chanlist {???}
set chanindex 0

set segindex -1

set defaultchanlist {0 1 2 3 4 5 6 7}

set cardtype Saphir
set VXIGlobal ""


#    The array "table" which is indexed by the "widget name" contains all the information needed
#    for the register/display item
#
#    Each element of "table" is a list
#
#       0.    name of global parameter used to hold current value of the register
#       1.    procedure to be used to convert the widget value into parameter value
#       2.    procedure to be used to convert the parameter value into a widget value
#       3.    name of the register
#       4.    procedure to be used to convert the register value into parameter value
#       5.    procedure to be used to convert the parameter value into a register value
#       6.    name of unit used for register access
#       7.    widget type to be used for "by parameter" displays
#       8-10  parameters for the procedure creating "by parameter" displays
#              eg  if (7) is :slider then 8 is min value, 9 is max value and 10 is unit
#       11    for startup only - initial value of the parameter (1)
#       12    for startup only - inserted for this widget into the table "parameternames"


set table(CHANNEL) {channel widget->channel channel->widget nil nil nil nil nil nil nil nil 1 nil}
set table(ALLCHANS) {allchans int-widget->param param->int-widget nil nil nil nil nil nil nil nil 0 nil}
set table(ENABLE) {enable int-widget->param param->int-widget "Enable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 0 "Enable"}
       
set table(MARKREJECT) {markreject int-widget->param param->int-widget "PileupReject"
       int-reg->param param->int-reg nil :choice Mark Reject nil 1 "Pileup"}

set table(CFDTHRESH) {cfdthresh slider-widget->param param->int-widget "CFD.Thresh"
       unit-reg->param param->unit-reg keV :slider 0 2600 4 1 "CFD Threshold (KeV)"}
set table(CFDDELAY) {cfddelay slider-widget->param param->int-widget "CFD.Delay"
       unit-reg->param param->unit-reg ns :slider 0 200 1 1 "CFD Delay (ns)"}
set table(CFDWIDTH) {cfdwidth slider-widget->param param->int-widget "CFD.Width"
       unit-reg->param param->unit-reg ns :slider 0 200 1 1 "CFD Width (ns)"}

set table(FTSAMPLE) { ftsample slider-widget->param param->int-widget "FTSample"
       unit-reg->param param->unit-reg ns :slider 0 2000 8 1 "Fast Trigger Sample (ns)"}
set table(VALSAMPLE) {valsample slider-widget->param param->int-widget "ValSample"
       unit-reg->param param->unit-reg ns :slider 0 10000 40 1 "Validation Sample (ns)"}
set table(PDSGATE) {pdsgate slider-widget->param param->int-widget "PDSGate"
       unit-reg->param param->unit-reg ns :slider 0 10000 40 1 "PDS Gate (ns)"}  
       
set table(READOUTE) {readoute int-widget->param param->int-widget "Energy.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Energy"}
set table(READOUTT) {readoutt int-widget->param param->int-widget "Timing.ROEnable"
       int-reg->param param->int-reg nil :checkbox nil nil nil 1 "Timing"}


#    Inspection line configuration  -  this format is for all modules EXCEPT Eurogam modules

#    for each item in the configuration  list
#    item 1    -   inspection line name
#    item 2    -   channel select 
#    item 3    -   parameter select

#    for channel select * implies value determined by adc channel
#    for parameter select * implies disconnect

set AI-Configuration [list       \
   {Disconnected       0   *}    \
   {Energy-Input       *   0}    \
   {TFA-Output         *   1}    \
   {LA-Output          *   2}    \
   {PDS-Output         *   3}    \
   {TAC-Output         *   4}    \
]

set DI-Configuration [list       \
   {Disconnected       0   *}    \
   {CFD-Direct         *   0}    \
   {CFD-Delay          *   1}    \
   {Fast_Trigger      32   1}    \
   {FT-Sample          *   6}    \
   {Validation        32   3}    \
   {Val-Sample         *   7}    \
   {Veto              32   4}    \
]



set readoutitems {READOUTE READOUTT}

set channelitems {MARKREJECT}

set segmentitems {ENABLE CFDTHRESH CFDDELAY CFDWIDTH FTSAMPLE VALSAMPLE PDSGATE}



set info(CARD) " From this window you can setup the electronics for the Saphir detector VXI electronics.\n\
                Each VXI card contains 16 electronics channels."


